Type: Package
Package: SpaceMarkers
Title: Spatial Interaction Markers
Version: 2.1.0
Authors@R: c(
    person(given = "Atul", family = "Deshpande", email = "adeshpande@jhu.edu", role = c("aut", "cre"), comment = c(ORCID="0000-0001-5144-6924")),
    person(given = "Ludmila", family = "Danilova", email = "ldanilo1@jhmi.edu", role = "ctb"),
    person(given = "Dmitrijs", family = "Lvovs", email = "dlvovs1@jh.edu", role = "ctb", comment = c(ORCID = "0009-0003-2152-6853"))
  )
BugReports: https://github.com/DeshpandeLab/SpaceMarkers/issues
URL: https://github.com/DeshpandeLab/SpaceMarkers
Description: Spatial transcriptomic technologies have helped to resolve the connection
            between gene expression and the 2D orientation of tissues relative to each other.
            However, the limited single-cell resolution makes it difficult to highlight the most 
            important molecular interactions in these tissues. SpaceMarkers, R/Bioconductor software,
            can help to find molecular interactions, by identifying genes associated with latent space 
            interactions in spatial transcriptomics.
Depends: R (>= 4.4.0)
biocViews: SingleCell, GeneExpression, Software, Spatial,
        Transcriptomics
Imports: matrixStats, matrixTests, rstatix, spatstat.explore,
        spatstat.geom, ape, hdf5r, nanoparquet, jsonlite, Matrix,
        qvalue, stats, utils, methods, ggplot2, reshape2, RColorBrewer,
        circlize, mixtools, dplyr, readbitmap, rlang, effsize, viridis
Suggests: data.table, devtools, knitr, cowplot, rjson, rmarkdown,
        BiocStyle, testthat (>= 3.0.0), CoGAPS, ComplexHeatmap
Enhances: BiocParallel
VignetteBuilder: knitr
Config/testthat/edition: 3
Encoding: UTF-8
LazyData: false
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.3
License: MIT + file LICENSE
git_url: https://git.bioconductor.org/packages/SpaceMarkers
git_branch: devel
git_last_commit: 2b359d8
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-30
NeedsCompilation: no
Packaged: 2025-10-30 23:17:28 UTC; biocbuild
Author: Atul Deshpande [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-5144-6924>),
  Ludmila Danilova [ctb],
  Dmitrijs Lvovs [ctb] (ORCID: <https://orcid.org/0009-0003-2152-6853>)
Maintainer: Atul Deshpande <adeshpande@jhu.edu>

<p align="center">
  <img src="SpaceMarkersHexWhite.png" width="200" title="SpaceMarkers hex logo">
</p>

# SpaceMarkers
An R/Bioconductor software tool to identify genes associated with latent space interactions in spatial transcriptomics.

## Citation
If you use the SpaceMarkers software please cite:

Atul Deshpande, Melanie Loth, et al.,
[Uncovering the spatial landscape of molecular interactions within the tumor microenvironment through latent spaces](https://doi.org/10.1016/j.cels.2023.03.004).
*Cell Systems,* April 2023. https://doi.org/10.1016/j.cels.2023.03.004

## Installation
You can install the latest Bioconductor release from SpaceMarkers using the code below.
```
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("SpaceMarkers")
```
You can install the development version of SpaceMarkers directly from the Github source.
```
install.packages("remotes")
remotes::install_github("DeshpandeLab/SpaceMarkers", dependencies = TRUE, build_vignettes = TRUE)
```

#' @importFrom spatstat.geom owin ppp marks
#' @importFrom spatstat.explore Smooth
#' @importFrom ape Moran.I
#import description end
0



## author: Atul Deshpande
## email: adeshpande@jhu.edu

.find_kernel_outliers_for_sensitivity <- function(pattern,locs,
                                                    pattern_threshold=0.15,
                                                sigma = 10,kernelthreshold = 2,
                                                method = "Pattern_Threshold",
                                                outlier = "positive",...)
{
    allwin<-spatstat.geom::owin(xrange = c(min(locs$x),max(locs$x)),
                                    yrange=c(min(locs$y),max(locs$y)))
    X<-spatstat.geom::ppp(x=locs$x,y=locs$y,window=allwin,marks=pattern)
    Kact<-spatstat.explore::Smooth(X,at ="points",sigma=sigma,...)
    Karr<-vapply(seq(1,100), function(i){Xr<-X;
    spatstat.geom::marks(Xr)<-sample(spatstat.geom::marks(X));
    temp<-spatstat.explore::Smooth(Xr,at="points",sigma=sigma,...);
        return(temp)}, numeric(length(Kact)))
    Kvec <- unlist(Karr)
    mKvec <- mean(Kvec)
    sKvec <- sd(Kvec)
    Kact<-(Kact-mKvec)/sKvec
    return(Kact)
}

.get_optimal_sigma_thresh <- function(pattern, locs, sigVec, threshVec,...){
    visium.dist <- as.matrix(dist(locs))
    visium.dist.inv <-1/visium.dist
    diag(visium.dist.inv) <- 0
    allwin<-spatstat.geom::owin(xrange=c(min(locs$x),max(locs$x)),
                                    yrange=c(min(locs$y),max(locs$y)))
    X<-spatstat.geom::ppp(x=locs$x,y=locs$y,window=allwin,marks=pattern)
    Ks<-vapply(sigVec,function(i) spatstat.explore::Smooth(X,at="points",
                                                            sigma=i,...),
                                                            numeric(X$n))
    mor_1<-vapply(seq(1,length(sigVec)),function(i) unlist(ape::Moran.I(
        spatstat.geom::marks(X)-Ks[,i], visium.dist.inv)),numeric(4))
    sigOpt1_ind <- which.min(abs(unlist(mor_1[1,])-unlist(mor_1[2,])))
    if (sigOpt1_ind>1&&sigOpt1_ind<length(sigVec)){
        smallsigVec<-seq(sigVec[sigOpt1_ind-1],sigVec[sigOpt1_ind+1],
                            (sigVec[sigOpt1_ind+1]-sigVec[sigOpt1_ind-1])/10)
    }else if (sigOpt1_ind==1){
        smallsigVec <- seq(sigVec[sigOpt1_ind],sigVec[sigOpt1_ind+1],
                            (sigVec[sigOpt1_ind+1] - sigVec[sigOpt1_ind])/10)
    }else{
        smallsigVec <- seq(sigVec[sigOpt1_ind-1],sigVec[sigOpt1_ind],
                            (sigVec[sigOpt1_ind] - sigVec[sigOpt1_ind-1])/10)
    }
    smallKs<-vapply(smallsigVec,function(i) spatstat.explore::Smooth(
            X,at="points", sigma = i, ...), numeric(X$n))
    smallmor_2<-vapply(seq(1,length(smallsigVec)), function(i) unlist(
            ape::Moran.I(spatstat.geom::marks(X)-smallKs[,i],visium.dist.inv)),
            numeric(4))
    sigOpt1_ind <- which.min(abs(unlist(smallmor_2[1,])-
                                unlist(smallmor_2[2,])))
    Kact2<-.find_kernel_outliers_for_sensitivity(pattern=pattern,locs=locs,
                                                sigma=smallsigVec[sigOpt1_ind],
                                                method="Kernel2",
                                                kernelthreshold=0,
                                                outlier="positive")
    inds2<-(kronecker(matrix(1,1,length(threshVec)),Kact2)>threshVec)*1
    mor_2_ind<-vapply(seq(1,length(threshVec)),function(j){
        visium.dist.inv_1<- visium.dist.inv;visium.dist.inv_1[inds2[,j]==0]<-0;
        unlist(ape::Moran.I(spatstat.geom::marks(X)-smallKs[,sigOpt1_ind],
                            visium.dist.inv_1))}, numeric(4))
    threshOpt1_ind<-which.min(abs(unlist(mor_2_ind[1,])-unlist(mor_2_ind[2,])))
    return(data.frame(
        sigmaOpt=smallsigVec[sigOpt1_ind],threshOpt=threshVec[threshOpt1_ind]))
}

#===================
#' Calculate the optimal parameters from spatial kernel density for 
#' cell-cell interactions
#' @description This function uses Morans.I to calculate the optimal width of 
#' the kernel density (sigmaOpt) as well as the outlier threshold around the set
#' of spots (threshOpt) for a null distribution.
#' @export
#' @param spatialPatterns  A data frame that contains the spatial coordinates 
#' for each cell type. The column names must include 'x' and 'y' as well as a 
#' set of numbered columns named  'Pattern_1.....N'.
#' @param ... Arguments passed to methods
#' @return a numeric matrix of sigmaOpts - the optimal width of the gaussian 
#' distribution, and the threshOpt - outlier threshold around the set of spots 
#' for each pattern
#' @examples
#' library(SpaceMarkers)
#' # Create test data
#' cells <- c()
#' test_num <- 500
#' for(i in 1:test_num){
#'     cells[length(cells)+1] <- paste0("cell_",i)
#' }
#' spPatterns <- data.frame(barcode = cells,
#' y = runif(test_num, min=0, max=test_num),
#' x = runif(test_num, min=0, max=test_num),
#' Pattern_1 = runif(test_num, min=0, max=1),
#' Pattern_2 = runif(test_num, min=0, max=1) )
#' # Call the get_spatial_params_morans_i function with the test data
#' optParams <- get_spatial_params_morans_i(spPatterns)
#'
get_spatial_params_morans_i <- function(spatialPatterns,...){
    .Deprecated(new = "get_spatial_parameters")
    sigmaRes <- max(floor(min(diff(range(spatialPatterns$x)),
                                diff(range(spatialPatterns$y)))/250),1)
    sigVec <- seq(2,40*sigmaRes,sigmaRes)
    threshVec <- seq(1,3,0.1)
    patternList <- setdiff(colnames(spatialPatterns),c("barcode","x","y"))
    optParams<-vapply(patternList,function(i) unlist(.get_optimal_sigma_thresh(
        pattern=spatialPatterns[,i],locs=data.frame(
        x=spatialPatterns$x,y=spatialPatterns$y),sigVec,threshVec,...)),numeric(2))
    return(optParams)
}

#===================
#' Read optimal parameters for spatial kernel density from user input or .json
#' file
#'
#' @description This function obtains the width of a spatial kernel density
#' (sigma) from either the user input or from a scale factors .json file. 
#' The outlier threshold around the set of spots (threshold) for each pattern is
#' specified  by the user (default is 4). 
#' @export
#' @param spatialPatterns  A data frame that contains the spatial coordinates 
#' for each cell type. The column names must include 'x' and 'y' as well as a 
#' set of numbered columns named  'Pattern_1.....N'.
#' @param visiumDir A string path specifying the location of the 10xVisium
#' directory
#' @param spatialDir A string path specifying the location of the spatial folder
#' containing the .json file of the spot characteristics
#' @param pattern A string specifying the name of the .json file
#' @param sigma A numeric value specifying the width of the kernel density 
#' estimate to be used for smoothing
#' @param threshold A numeric value specifying how many standard deviations 
#' above the mean of a null distribution to use an outlier threshold for
#' identifying 'hotspots'
#' @param resolution A string specifying image resolution to be used for spot 
#' diameter. Can take values of "fullres" (default), "lowres" or "hires".
#' @param ... Arguments passed to methods
#' @return a numeric matrix of sigmaOpts - the optimal width of the gaussian 
#' distribution, and the threshOpt - outlier threshold around the set of spots 
#' for each pattern
#' @examples
#' library(SpaceMarkers)
#' # Create test data
#' cells <- c()
#' test_num <- 500
#' for(i in 1:test_num){
#'     cells[length(cells)+1] <- paste0("cell_",i)
#' }
#' spPatterns <- data.frame(barcode = cells,
#' y = runif(test_num, min=0, max=test_num),
#' x = runif(test_num, min=0, max=test_num),
#' Pattern_1 = runif(test_num, min=0, max=1),
#' Pattern_2 = runif(test_num, min=0, max=1) )
#' # Call the get_spatial_parameters function with the test data
#' optParams <- get_spatial_parameters(spPatterns, sigma = 10)
#'

get_spatial_parameters <- function(spatialPatterns,visiumDir = ".",
                                         spatialDir ="spatial",
                                         pattern = "scalefactors_json.json",
                                         sigma = NULL,threshold = 4,
                                         resolution = 
                                           c("fullres","lowres","hires"), ...) {
    #resolve resolution parameter
    resolution <- match.arg(resolution, several.ok = FALSE)
    message("resolution: ", resolution)
    patternList <- setdiff(colnames(spatialPatterns),c("barcode","x","y"))
    if (!is.null(sigma)) {
      sigmaOpt <- sigma
      threshOpt <- threshold
    } else if (is.null(sigma) & 
               file.exists(file.path(visiumDir,spatialDir,pattern))) {
        message("Reading spot diameter from specified .json file")
        scale_values <- jsonlite::read_json(file.path(visiumDir,spatialDir,
                                                    pattern))
      if ("lowres" %in% resolution){
        resolution <- "lowres"
      } else if ("hires" %in% resolution){
        resolution <- "hires"
      } else if ("fullres" %in% resolution){
        resolution <- "fullres"
      } else {
        stop("Resolution argument not recognized.
             Please supply either lowres, hires or fullres.")
      }
      
      threshOpt <- threshold
      sigmaOpt <- as.numeric(scale_values$spot_diameter_fullres)
      if (resolution != "fullres") {
        scale_factor <- scale_values[grepl(resolution,
                                           names(scale_values))][[1]]
        sigmaOpt <- sigmaOpt * as.numeric(scale_factor)
      } 
      
      
    } else  {
      stop("Please specify the sigma or correct path to .json")
    }
    optParams <-matrix(c(sigmaOpt,threshOpt),nrow = 2,
                       ncol = length(patternList))
    colnames(optParams) <- patternList
    rownames(optParams) <- c("sigmaOpt","threshOpt")
  return(optParams)
}

test_that("get_spatial_params_morans_i returns optimal parameters", {
  # Create test data
  set.seed(123)
  cells <- c()
  test_num <- 500
  for(i in 1:test_num){
    cells[length(cells)+1] <- paste0("cell_",i)
  }
  spPatterns <- data.frame(barcode = cells,
                            y = runif(test_num, min=0, max=test_num),
                            x = runif(test_num, min=0, max=test_num),
                            Pattern_1 = runif(test_num, min=0, max=1),
                            Pattern_2 = runif(test_num, min=0, max=1) )
  # Call the get_spatial_parameters function with the test data
  suppressWarnings(optParams <- get_spatial_params_morans_i(spPatterns))
  optParams_test <- data.matrix(data.frame("Pattern_1" = c(40,3),
                                           "Pattern_2" = c(40.0,2.5)))
  rownames(optParams_test) <- c("sigmaOpt","threshOpt")
  # Perform assertions to check if the optimal parameters are returned correctly
  expect_equal(optParams["sigmaOpt",] ,optParams_test["sigmaOpt",], tolerance = 3,
               info = "Parameters are outside the reasonable range")
  expect_equal(optParams["threshOpt",] ,optParams_test["threshOpt",], tolerance = 3,
               info = "Parameters are outside the reasonable range")
  expect_equal(ncol(optParams), 2, info = "Incorrect number of pattern parameters")
  expect_equal(colnames(optParams), c("Pattern_1", "Pattern_2"), info = "Incorrect pattern names")

})

# Sample data to use in tests
spatialPatterns <- data.frame(
  barcode = c("A", "B", "C"),
  x = c(1, 2, 3),
  y = c(4, 5, 6),
  pattern1 = c(0.5, 0.6, 0.7),
  pattern2 = c(0.8, 0.9, 1.0)
)
temp <- "mock_visiumDir"
# Mock JSON data for testing
mock_json <- function(temp_dir = temp) {
  spatial_dir <- file.path(temp_dir, "spatial")
  
  dir.create(spatial_dir, showWarnings = FALSE, recursive = TRUE)
  
  json_data <- list(
    scale_factors = 1,
    tissue_hires_scalef = 0.75,
    tissue_lowres_scalef = 0.25,
    spot_diameter_fullres = 4
  )
  jsonlite::write_json(json_data,file.path(spatial_dir,
                                           "scalefactors_json.json"), 
                       simplifyVector =TRUE)
  return(list(visiumDir = temp_dir, spatialDir = spatial_dir,
              pattern = "scalefactors_json.json"))
}

# Test cases for get_spatial_paramsExternal
test_that("get_spatial_parameters works with provided sigma", {
  result <- get_spatial_parameters(spatialPatterns, sigma = 5)
  
  expect_equal(nrow(result), 2)
  expect_equal(ncol(result), 2)
  expect_equal(result[["sigmaOpt", "pattern1"]], 5)
  expect_equal(result[["threshOpt", "pattern1"]], 4)
  expect_equal(result[["sigmaOpt", "pattern2"]], 5)
  expect_equal(result[["threshOpt", "pattern2"]], 4)
})

test_that("get_spatial_parameters works by reading from JSON file", {
  paths <- mock_json()
  
result <- get_spatial_parameters(spatialPatterns,
                                         visiumDir = paths$visiumDir,
                                         spatialDir = "spatial")
  
  expect_equal(nrow(result), 2)
  expect_equal(ncol(result), 2)
  expect_equal(result[["sigmaOpt", "pattern1"]], 4)
  expect_equal(result[["threshOpt", "pattern1"]], 4)
  expect_equal(result[["sigmaOpt", "pattern2"]], 4)
  expect_equal(result[["threshOpt", "pattern2"]], 4)
})

test_that("get_spatial_parameters works with threshold", {
  result <- get_spatial_parameters(spatialPatterns, sigma = 6,
                                         threshold = 10)
  
  expect_equal(result[["sigmaOpt", "pattern1"]], 6)
  expect_equal(result[["threshOpt", "pattern1"]], 10)
  expect_equal(result[["sigmaOpt", "pattern2"]], 6)
  expect_equal(result[["threshOpt", "pattern2"]], 10)
})
unlink(temp, recursive = TRUE)

# Ensure required packages are installed (if not already)
# install.packages(c("circlize", "RColorBrewer"))

# --- Helper Function 1: Data Preparation ---
.prepare_circos_data_logic <- function(lr_df,
                                       all_molecules_def, # Expected: data.frame with cell_type, molecule_name, molecule_type
                                       split_segments_for_links,
                                       link_buffer_fraction,
                                       scale_link_width_by_score,
                                       score_transform_for_width,
                                       inter_molecule_segment_gap) {
    # This function now takes all_molecules_def as an argument.
    # lr_df is the already filtered data frame of interactions for the current plot.

    if (nrow(all_molecules_def) == 0) {
      return(list(bed_data = data.frame(), links_data = data.frame()))
    }

    bed_data_intermediate <- all_molecules_def

    if (split_segments_for_links) {
        if (scale_link_width_by_score) {
            lr_df$link_actual_width <- score_transform_for_width(lr_df$score)
            lr_df$link_actual_width[lr_df$link_actual_width <= 1e-6] <- 0.1 # Min width
        } else {
            lr_df$link_actual_width <- 1 # Each interaction gets 1 unit width
        }

        source_lengths <- stats::aggregate(link_actual_width ~ source_cell_type + ligand, data = lr_df, FUN = sum)
        if(nrow(source_lengths) > 0) {
          colnames(source_lengths) <- c("cell_type", "molecule_name", "total_segment_length")
          source_lengths$molecule_type <- "ligand"
        } else { # Handle empty aggregation
            source_lengths <- data.frame(cell_type=character(), molecule_name=character(), total_segment_length=numeric(), molecule_type=character())
        }


        target_lengths <- stats::aggregate(link_actual_width ~ target_cell_type + receptor, data = lr_df, FUN = sum)
        if(nrow(target_lengths) > 0){
          colnames(target_lengths) <- c("cell_type", "molecule_name", "total_segment_length")
          target_lengths$molecule_type <- "receptor"
        } else {
            target_lengths <- data.frame(cell_type=character(), molecule_name=character(), total_segment_length=numeric(), molecule_type=character())
        }

        molecule_total_lengths <- rbind(source_lengths, target_lengths)

        if(nrow(molecule_total_lengths) > 0){
            bed_data_intermediate <- merge(all_molecules_def, molecule_total_lengths,
                                       by = c("cell_type", "molecule_name", "molecule_type"), all.x = TRUE)
            bed_data_intermediate$total_segment_length[is.na(bed_data_intermediate$total_segment_length)] <- 1 # Default length
        } else { # if no interactions, molecule_total_lengths is empty
            bed_data_intermediate$total_segment_length <- 1
        }
        bed_data_intermediate$segment_length_val <- bed_data_intermediate$total_segment_length
    } else { # Not splitting segments, each molecule segment has base length 1
        bed_data_intermediate$segment_length_val <- 1
    }

    # Assign cumulative start/end for molecule segments on tracks, incorporating inter-segment gaps
    bed_data_list <- lapply(split(bed_data_intermediate, bed_data_intermediate$cell_type), function(df_cell) {
        df_cell <- df_cell[order(df_cell$molecule_type, df_cell$molecule_name), ]
        if (nrow(df_cell) > 0) {
            current_pos <- 0
            starts <- numeric(nrow(df_cell))
            ends <- numeric(nrow(df_cell))
            for (i in 1:nrow(df_cell)) {
                if (i > 1) current_pos <- current_pos + inter_molecule_segment_gap
                starts[i] <- current_pos
                ends[i] <- current_pos + df_cell$segment_length_val[i]
                current_pos <- ends[i]
            }
            df_cell$start <- starts
            df_cell$end <- ends
        } else {
            df_cell$start <- numeric(0); df_cell$end <- numeric(0);
        }
        df_cell
    })
    bed_data <- do.call(rbind, bed_data_list)
    if(!is.null(bed_data)) rownames(bed_data) <- NULL # bed_data can be NULL if no segments

    # Prepare links_data
    links_data <- data.frame() # Initialize empty
    if (nrow(lr_df) > 0 && !is.null(bed_data) && nrow(bed_data) > 0) {
        if (split_segments_for_links) {
            lr_df_temp_links <- lr_df # Already has interaction_id and link_actual_width
            lr_df_temp_links <- lr_df_temp_links[order(lr_df_temp_links$source_cell_type, lr_df_temp_links$ligand, lr_df_temp_links$interaction_id), ]
            lr_df_temp_links$source_sub_offset <- ave(lr_df_temp_links$link_actual_width, lr_df_temp_links$source_cell_type, lr_df_temp_links$ligand,
                                                FUN = function(x) c(0, cumsum(x)[-length(x)]))
            lr_df_temp_links <- lr_df_temp_links[order(lr_df_temp_links$target_cell_type, lr_df_temp_links$receptor, lr_df_temp_links$interaction_id), ]
            lr_df_temp_links$target_sub_offset <- ave(lr_df_temp_links$link_actual_width, lr_df_temp_links$target_cell_type, lr_df_temp_links$receptor,
                                                FUN = function(x) c(0, cumsum(x)[-length(x)]))
            lr_df_temp_links <- lr_df_temp_links[order(lr_df_temp_links$interaction_id), ]

            links_data_list_apply <- apply(lr_df_temp_links, 1, function(row) {
                lig_info <- bed_data[bed_data$cell_type == row["source_cell_type"] & bed_data$molecule_name == row["ligand"] & bed_data$molecule_type == "ligand", ]
                rec_info <- bed_data[bed_data$cell_type == row["target_cell_type"] & bed_data$molecule_name == row["receptor"] & bed_data$molecule_type == "receptor", ]
                if (nrow(lig_info) == 1 && nrow(rec_info) == 1) {
                    actual_w = as.numeric(row["link_actual_width"])
                    s_start = lig_info$start + as.numeric(row["source_sub_offset"]) + (actual_w * link_buffer_fraction)
                    s_end   = lig_info$start + as.numeric(row["source_sub_offset"]) + actual_w * (1 - link_buffer_fraction)
                    t_start = rec_info$start + as.numeric(row["target_sub_offset"]) + (actual_w * link_buffer_fraction)
                    t_end   = rec_info$start + as.numeric(row["target_sub_offset"]) + actual_w * (1 - link_buffer_fraction)
                    if (s_start >= s_end) { s_end <- s_start + 1e-6 }
                    if (t_start >= t_end) { t_end <- t_start + 1e-6 }
                    data.frame(source_cell_type = row["source_cell_type"], source_start = s_start, source_end = s_end,
                               target_cell_type = row["target_cell_type"], target_start = t_start, target_end = t_end,
                               score = as.numeric(row["score"]), stringsAsFactors = FALSE)
                } else { NULL }
            })
        } else { # Not splitting, links use full segment width from bed_data
            links_data_list_apply <- apply(lr_df, 1, function(row) {
                lig_info <- bed_data[bed_data$cell_type == row["source_cell_type"] & bed_data$molecule_name == row["ligand"] & bed_data$molecule_type == "ligand",]
                rec_info <- bed_data[bed_data$cell_type == row["target_cell_type"] & bed_data$molecule_name == row["receptor"] & bed_data$molecule_type == "receptor",]
                if (nrow(lig_info) == 1 && nrow(rec_info) == 1) {
                    data.frame(source_cell_type = row["source_cell_type"], source_start = lig_info$start, source_end = lig_info$end,
                               target_cell_type = row["target_cell_type"], target_start = rec_info$start, target_end = rec_info$end,
                               score = as.numeric(row["score"]), stringsAsFactors = FALSE)
                } else { NULL }
            })
        }
        # Filter out NULLs from apply if any rows failed to produce link data
        links_data <- do.call(rbind, Filter(Negate(is.null), links_data_list_apply))
        if(!is.null(links_data)) rownames(links_data) <- NULL
    }
    return(list(bed_data = bed_data, links_data = links_data))
}

# --- Helper Function 2: Color Generation ---
.generate_circos_colors <- function(molecules_in_plot_df, # Should be unique molecules: molecule_name, molecule_type
                                    cell_types_in_plot_vector,
                                    use_individual_molecule_colors,
                                    default_ligand_color,
                                    default_receptor_color,
                                    individual_ligand_palette_generator,
                                    individual_receptor_palette_generator,
                                    cell_type_palette_name = "Set1") {
    n_cell_types <- length(cell_types_in_plot_vector)
    pal_ct_max <- RColorBrewer::brewer.pal.info[cell_type_palette_name, "maxcolors"]
    pal_ct <- RColorBrewer::brewer.pal(min(n_cell_types, pal_ct_max), cell_type_palette_name)
    cell_type_colors_vec <- if (n_cell_types > length(pal_ct)) grDevices::colorRampPalette(pal_ct)(n_cell_types) else pal_ct[1:n_cell_types]
    names(cell_type_colors_vec) <- cell_types_in_plot_vector

    name_cols_ligand <- NULL; name_cols_receptor <- NULL
    if(use_individual_molecule_colors) {
        .gen_mol_cols_helper <- function(mol_names, pal_gen, pal_default_name, type) {
            n_unique <- length(mol_names)
            if (n_unique == 0) return(stats::setNames(character(0), character(0)))
            colors_vec <- if (is.null(pal_gen)) {
                max_brewer <- RColorBrewer::brewer.pal.info[pal_default_name, "maxcolors"]
                # Ensure n for brewer.pal is at least 3, or adjust if n_unique is less
                n_for_brewer <- if (n_unique < 3 && n_unique > 0) 3 else n_unique
                base_pal <- RColorBrewer::brewer.pal(min(n_for_brewer, max_brewer), pal_default_name)
                if (n_unique <= length(base_pal)) base_pal[1:n_unique] else grDevices::colorRampPalette(base_pal)(n_unique)
            } else { pal_gen(n_unique) }
            # Ensure colors_vec length matches mol_names length
            if(length(colors_vec) != n_unique) {
                warning(paste("Palette generator for", type, "did not return correct number of colors. Using default."))
                # Fallback to default logic
                max_brewer <- RColorBrewer::brewer.pal.info[pal_default_name, "maxcolors"]
                n_for_brewer <- if (n_unique < 3 && n_unique > 0) 3 else n_unique
                base_pal <- RColorBrewer::brewer.pal(min(n_for_brewer, max_brewer), pal_default_name)
                colors_vec <- if (n_unique <= length(base_pal)) base_pal[1:n_unique] else grDevices::colorRampPalette(base_pal)(n_unique)
            }
            stats::setNames(colors_vec, mol_names)
        }
        lig_names <- sort(unique(molecules_in_plot_df$molecule_name[molecules_in_plot_df$molecule_type == "ligand"]))
        rec_names <- sort(unique(molecules_in_plot_df$molecule_name[molecules_in_plot_df$molecule_type == "receptor"]))
        
        name_cols_ligand <- .gen_mol_cols_helper(lig_names, individual_ligand_palette_generator, "Greens", "ligands")
        name_cols_receptor <- .gen_mol_cols_helper(rec_names, individual_receptor_palette_generator, "Blues", "receptors")
    }
    return(list(cell_type_colors = cell_type_colors_vec,
                name_colors_ligand = name_cols_ligand,
                name_colors_receptor = name_cols_receptor))
}

# @import circlize
# @import RColorBrewer
# @import ComplexHeatmap
# --- Helper Function 3: Drawing Circlize Elements ---
.draw_circos_plot_elements <- function(bed_data,
                                       links_data,
                                       plot_cell_order,
                                       cell_type_colors,
                                       name_colors_ligand, # Used if use_individual_molecule_colors is TRUE
                                       name_colors_receptor, # Used if use_individual_molecule_colors is TRUE
                                       # Plotting parameters passed from top-level function
                                       gap_degree_after_sector, track_height_molecules,
                                       molecule_label_cex, cell_label_cex,
                                       link_transparency, link_connection_rou=0.7,
                                       link_arrowhead_type,
                                       link_arrowhead_width, link_arrowhead_length,
                                       score_color_palette_fun,
                                       molecule_segment_border_col,
                                       use_individual_molecule_colors,
                                       default_ligand_color,
                                       default_receptor_color,
                                       show_score_legend = TRUE) {
    circlize::circos.clear()
    circlize::circos.par(
        gap.after = stats::setNames(rep(gap_degree_after_sector, length(plot_cell_order)), plot_cell_order),
        start.degree = 90, 
        track.margin = c(0.01, 0.01), 
        cell.padding = c(0.02, 0, 0.02, 0),
        canvas.xlim = c(-1.1, 1.1), # Ensure full circle
        canvas.ylim = c(-1.1, 1.1),
        points.overflow.warning = FALSE
        )
    sector_xlim_df <- stats::aggregate(end ~ cell_type, data = bed_data, FUN = max, na.rm = TRUE)
    ordered_sector_xlim <- data.frame(cell_type = plot_cell_order, stringsAsFactors = FALSE)
    ordered_sector_xlim <- merge(ordered_sector_xlim, sector_xlim_df, by = "cell_type", all.x = TRUE, sort=FALSE) # Keep order
    ordered_sector_xlim$end[is.na(ordered_sector_xlim$end)] <- 1
    ordered_sector_xlim$start <- 0
    
    circlize::circos.initialize(factors = ordered_sector_xlim$cell_type, xlim = as.matrix(ordered_sector_xlim[, c("start", "end")]))

    circlize::circos.track(ylim = c(0, 1), bg.border = NA, track.height = track_height_molecules,
        panel.fun = function(x, y) {
            sector_name = circlize::get.cell.meta.data("sector.index")
            circlize::circos.text(x = circlize::CELL_META$xcenter, y = circlize::CELL_META$cell.ylim[2] + circlize::uy(6, "mm"),
                labels = sector_name, facing = "bending.inside", niceFacing = TRUE, adj = c(0.5, 0), cex = cell_label_cex, col = cell_type_colors[sector_name])
            
            sector_molecules <- bed_data[bed_data$cell_type == sector_name, ]
            if (nrow(sector_molecules) > 0) {
                for (i in 1:nrow(sector_molecules)) {
                    mol <- sector_molecules[i, ]
                    segment_col <- if(use_individual_molecule_colors) {
                        cols <- if(mol$molecule_type == "ligand") name_colors_ligand else name_colors_receptor
                        # Fallback if molecule name not in generated palette (should not happen with current logic)
                        col_val <- cols[mol$molecule_name]; if(is.na(col_val) || length(col_val)==0) ifelse(mol$molecule_type == "ligand", default_ligand_color, default_receptor_color) else col_val
                    } else { if(mol$molecule_type == "ligand") default_ligand_color else default_receptor_color }
                    if(is.na(segment_col) || length(segment_col) == 0 || segment_col == "") segment_col <- "grey" 

                    circlize::circos.rect(xleft = mol$start, ybottom = circlize::CELL_META$ylim[1], xright = mol$end, ytop = circlize::CELL_META$ylim[2],
                                          col = segment_col, border = molecule_segment_border_col,
                                          sector.index = sector_name, track.index = circlize::get.current.track.index())
                    circlize::circos.text(x = (mol$start + mol$end) / 2, y = mean(circlize::CELL_META$ylim), labels = mol$molecule_name,
                                          facing = "clockwise", niceFacing = TRUE, cex = molecule_label_cex, adj = c(0.5, 0.5), col = "black",
                                          sector.index = sector_name, track.index = circlize::get.current.track.index())
                }
            }
        })

    if (!is.null(links_data) && nrow(links_data) > 0) {
        link_cols_vec <- rep(grDevices::adjustcolor("grey50", alpha.f = link_transparency), nrow(links_data))
        if (!is.null(score_color_palette_fun) && "score" %in% colnames(links_data)) {
             if (is.function(score_color_palette_fun)) {
                link_scores <- links_data$score
                score_domain <- try(attr(score_color_palette_fun, "breaks"), silent = TRUE) 
                if (!inherits(score_domain, "try-error") && !is.null(score_domain) && length(score_domain) > 0) {
                     link_scores[!is.na(link_scores)] <- pmax(link_scores[!is.na(link_scores)], min(score_domain, na.rm=TRUE), na.rm=TRUE)
                     link_scores[!is.na(link_scores)] <- pmin(link_scores[!is.na(link_scores)], max(score_domain, na.rm=TRUE), na.rm=TRUE)
                }
                valid_scores_idx <- !is.na(link_scores)
                if(any(valid_scores_idx)){
                    raw_cols <- score_color_palette_fun(link_scores[valid_scores_idx])
                    link_cols_vec[valid_scores_idx] <- grDevices::adjustcolor(raw_cols, alpha.f = link_transparency)
                }
              } else { warning("`score_color_palette_fun` is not a function. Using default link colors.") }
        }
        
        #arr_width_val <- if(is.null(link_arrowhead_width)) circlize:::parse_circos_par_from_cherries("arrow.width") else link_arrowhead_width
        #arr_length_val <- if(is.null(link_arrowhead_length)) circlize:::parse_circos_par_from_cherries("arrow.length") else link_arrowhead_length
        for (i in 1:nrow(links_data)) {
            link <- links_data[i, ]
            if (link$source_start >= link$source_end || link$target_start >= link$target_end) next
            circlize::circos.link(
                sector.index1 = link$source_cell_type, 
                point1 = c(link$source_start, link$source_end),
                sector.index2 = link$target_cell_type, 
                point2 = c(link$target_start, link$target_end),
                col = link_cols_vec[i],
                rou = link_connection_rou,
                border = NA,
                directional = 1, 
                arr.type = "big.arrow",
                arr.col = link_cols_vec[i], 
                arr.width = link_arrowhead_width, 
                arr.length = link_arrowhead_length
            )
        }
    }
        # After the main plot is drawn but BEFORE circos.clear()
    if (show_score_legend && !is.null(score_color_palette_fun) && is.function(score_color_palette_fun)) {
            lgd_links = ComplexHeatmap::Legend(
                col_fun = score_color_palette_fun,
                title = "Interaction Score",
                direction = "vertical"
            )
            ComplexHeatmap::draw(
                lgd_links,
                x = grid::unit(1, "npc") - grid::unit(5, "mm"), # Adjusted position
                y = grid::unit(5, "mm"),
                just = c("right", "bottom")
            )
    }
    circlize::circos.clear()
}


# --- Top-Level Function 1: General Cell Interaction Plot ---
#' Plot Ligand-Receptor Interactions between Cell Types
#'
#' Visualizes ligand-receptor interactions as a circular plot, allowing for
#' selection of cell types, customization of segment and link appearance,
#' and different modes of representing interactions.
#'
#' @param lr_interactions_df A data.frame with columns: `ligand`, `receptor`,
#'   `source_cell_type`, `target_cell_type`, `score`.
#' @param selected_cell_types Optional character vector. If provided, only these cell types
#'   and interactions *between* them will be shown.
#' @param cell_order Optional character vector for specific cell type ordering. If NULL,
#'   alphabetical order is used for the (selected) cell types.
#' @param gap_degree_after_sector Numeric, gap in degrees after each sector. Default is 5.
#' @param track_height_molecules Numeric, height of the track for molecule segments. Default is 0.1.
#' @param molecule_label_cex Numeric, cex for molecule labels. Default is 0.6.
#' @param cell_label_cex Numeric, cex for cell type labels. Default is 0.9.
#' @param link_transparency Numeric, alpha for links (0 to 1). Default is 0.5.
#' @param link_connection_rou Numeric (0-1) or vector of two for `rou` in `circos.link`. Default is 0.7.
#' @param link_arrowhead_type Character. Type of arrowhead (e.g., "triangle", "big.arrow"). Default is "big.arrow".
#' @param link_arrowhead_width Numeric. Width of the arrowhead. Default uses circlize default.
#' @param link_arrowhead_length Numeric. Length of the arrowhead. Default uses circlize default.
#' @param score_color_palette_fun A function (e.g., from `circlize::colorRamp2`) to map scores to colors.
#' @param split_segments_for_links Logical. If TRUE, molecule segments are sized by interaction count/score
#'   and links connect to unique sub-segments. Default is TRUE.
#' @param link_buffer_fraction Numeric (0 to <0.5). Buffer around each link within its sub-segment.
#'   Applies if `split_segments_for_links` is TRUE. Default is 0.1.
#' @param scale_link_width_by_score Logical. If TRUE (and `split_segments_for_links` is TRUE),
#'   link/sub-segment width is proportional to score. Default is FALSE.
#' @param score_transform_for_width Function to transform scores for width scaling. Default is `function(s) s`.
#' @param use_individual_molecule_colors Logical. If TRUE, each unique ligand/receptor name gets a distinct color.
#'   Default is TRUE.
#' @param default_ligand_color Character, color for all ligand segments if `use_individual_molecule_colors` is FALSE.
#'   Default is "lightgreen".
#' @param default_receptor_color Character, color for all receptor segments if `use_individual_molecule_colors` is FALSE.
#'   Default is "lightblue".
#' @param individual_ligand_palette_generator Function (takes n, returns n colors) for unique ligands.
#'   Default generates a green palette.
#' @param individual_receptor_palette_generator Function (takes n, returns n colors) for unique receptors.
#'   Default generates a blue palette.
#' @param molecule_segment_border_col Color for the border of L/R segments. Default `NA` (no border).
#' @param inter_molecule_segment_gap Numeric, gap between L/R segments on the same track. Default is 0.1.
#'
#' @return Invisibly returns NULL. The function is called for its side effect of creating a plot.
#' @export
#' @examples
#' \dontrun{
#' if (requireNamespace("circlize", quietly = TRUE) &&
#'     requireNamespace("RColorBrewer", quietly = TRUE)) {
#'   lr_data <- data.frame(
#'     ligand = c("LGF1", "LGF1", "LGF2", "LGF3", "LGF4", "LGF1", "LGF5", "LGF6"),
#'     receptor = c("REC1", "REC2A", "REC1", "REC3B", "REC1", "REC4", "REC4", "REC2A"),
#'     source_cell_type = c("CellA", "CellA", "CellB", "CellC",
#'                           "CellA", "CellD", "CellD", "CellB"),
#'     target_cell_type = c("CellB", "CellC", "CellB", "CellA",
#'                           "CellD", "CellA", "CellD", "CellC"),
#'     score = c(4, 0.9, 0.7, 0.95, 0.6, 0.1, 0.88, 2.5),
#'     stringsAsFactors = FALSE
#'   )
#'   # Basic plot with defaults
#'   # plot_cell_interaction_circos(lr_data)
#'
#'   # Plot with selected cell types and custom order
#'   # plot_cell_interaction_circos(lr_data,
#'   #                           selected_cell_types = c("CellA", "CellB", "CellD"),
#'   #                           cell_order = c("CellD", "CellA", "CellB"))
#'  }
#' }
#' @import circlize
#' @import RColorBrewer
#' @export
plot_cell_interaction_circos <- function(lr_interactions_df,
                                     selected_cell_types = NULL,
                                     cell_order = NULL,
                                     gap_degree_after_sector = 5,
                                     track_height_molecules = 0.1,
                                     molecule_label_cex = 0.6,
                                     cell_label_cex = 0.9,
                                     link_transparency = 0.5,
                                     link_connection_rou = 0.7,
                                     link_arrowhead_type = "big.arrow",
                                     link_arrowhead_width = NULL,
                                     link_arrowhead_length = NULL,
                                     score_color_palette_fun = NULL,
                                     split_segments_for_links = TRUE,
                                     link_buffer_fraction = 0.1,
                                     scale_link_width_by_score = FALSE,
                                     score_transform_for_width = function(s) s,
                                     use_individual_molecule_colors = TRUE,
                                     default_ligand_color = "lightgreen",
                                     default_receptor_color = "lightblue",
                                     individual_ligand_palette_generator = NULL,
                                     individual_receptor_palette_generator = NULL,
                                     molecule_segment_border_col = NA,
                                     inter_molecule_segment_gap = 0.1) {

    if (!requireNamespace("circlize", quietly = TRUE)) stop("Package 'circlize' is needed.", call. = FALSE)
    if (!requireNamespace("RColorBrewer", quietly = TRUE)) stop("Package 'RColorBrewer' is needed.", call. = FALSE)
    if (nrow(lr_interactions_df) == 0) { warning("Input 'lr_interactions_df' is empty."); return(invisible(NULL)) }
    if (link_buffer_fraction >= 0.5 || link_buffer_fraction < 0) stop("'link_buffer_fraction' must be between 0 and < 0.5.", call. = FALSE)

    effective_lr_df <- lr_interactions_df
    if (!is.null(selected_cell_types) && length(selected_cell_types) > 0) {
        effective_lr_df <- lr_interactions_df[
            lr_interactions_df$source_cell_type %in% selected_cell_types &
            lr_interactions_df$target_cell_type %in% selected_cell_types,
        ]
        if (nrow(effective_lr_df) == 0) {
            warning("No interactions remain after filtering for selected_cell_types.")
            return(invisible(NULL))
        }
        current_cell_order <- cell_order
        if(!is.null(current_cell_order) && !all(current_cell_order %in% selected_cell_types)){
            warning("'cell_order' contains types not in 'selected_cell_types' or not in data after filtering. It will be adjusted.")
            current_cell_order <- current_cell_order[current_cell_order %in% unique(c(effective_lr_df$source_cell_type, effective_lr_df$target_cell_type))]
        }
        cell_order <- current_cell_order # Update cell_order based on filtering
    }
    if (nrow(effective_lr_df) == 0) { warning("No interaction data to plot after initial processing."); return(invisible(NULL)) }
    effective_lr_df$interaction_id <- 1:nrow(effective_lr_df)


    source_mols <- unique(effective_lr_df[, c("source_cell_type", "ligand")])
    if(nrow(source_mols)>0) {colnames(source_mols) <- c("cell_type", "molecule_name"); source_mols$molecule_type <- "ligand"
    } else { source_mols <- data.frame(cell_type=character(), molecule_name=character(), molecule_type=character())}

    target_mols <- unique(effective_lr_df[, c("target_cell_type", "receptor")])
    if(nrow(target_mols)>0) {colnames(target_mols) <- c("cell_type", "molecule_name"); target_mols$molecule_type <- "receptor"
    } else {target_mols <- data.frame(cell_type=character(), molecule_name=character(), molecule_type=character())}
    
    all_molecules_definition <- unique(rbind(source_mols, target_mols))
    if(nrow(all_molecules_definition) == 0 && nrow(effective_lr_df) > 0) { # Should not happen if effective_lr_df has rows
        warning("Could not define any molecules for segments, though interactions exist.")
        return(invisible(NULL))
    }


    prepared_data <- .prepare_circos_data_logic(
        lr_df = effective_lr_df, all_molecules_def = all_molecules_definition,
        split_segments_for_links = split_segments_for_links, link_buffer_fraction = link_buffer_fraction,
        scale_link_width_by_score = scale_link_width_by_score, score_transform_for_width = score_transform_for_width,
        inter_molecule_segment_gap = inter_molecule_segment_gap
    )

    if (is.null(prepared_data$bed_data) || nrow(prepared_data$bed_data) == 0) {
        warning("No molecule segments to plot after data preparation.")
        return(invisible(NULL))
    }

    # Determine plot_cell_order based on bed_data and user's cell_order preference
    unique_cells_in_bed <- sort(unique(prepared_data$bed_data$cell_type))
    current_plot_cell_order <- if (!is.null(cell_order) && length(cell_order) > 0) {
        # Ensure provided cell_order is valid for the cells actually in bed_data
        ordered_cells <- cell_order[cell_order %in% unique_cells_in_bed]
        # Append any missing cells from bed_data alphabetically
        missing_cells <- unique_cells_in_bed[!unique_cells_in_bed %in% ordered_cells]
        if (length(missing_cells) > 0) {
             warning(paste("Some cells in data were not in 'cell_order':", paste(missing_cells, collapse=", "), ". Appending them."))
        }
        c(ordered_cells, missing_cells)
    } else {
        unique_cells_in_bed # Alphabetical
    }
    if (length(current_plot_cell_order) == 0) { warning("No cell types to plot."); return(invisible(NULL)) }

    plot_colors <- .generate_circos_colors(
        molecules_in_plot_df = unique(prepared_data$bed_data[, c("molecule_name", "molecule_type")]),
        cell_types_in_plot_vector = current_plot_cell_order,
        use_individual_molecule_colors = use_individual_molecule_colors, default_ligand_color = default_ligand_color,
        default_receptor_color = default_receptor_color, individual_ligand_palette_generator = individual_ligand_palette_generator,
        individual_receptor_palette_generator = individual_receptor_palette_generator
    )

    .draw_circos_plot_elements(
        bed_data = prepared_data$bed_data, links_data = prepared_data$links_data,
        plot_cell_order = current_plot_cell_order, cell_type_colors = plot_colors$cell_type_colors,
        name_colors_ligand = plot_colors$name_colors_ligand, name_colors_receptor = plot_colors$name_colors_receptor,
        gap_degree_after_sector=gap_degree_after_sector, track_height_molecules=track_height_molecules,
        molecule_label_cex=molecule_label_cex, cell_label_cex=cell_label_cex,
        link_transparency=link_transparency, link_connection_rou=link_connection_rou,
        link_arrowhead_type=link_arrowhead_type,
        link_arrowhead_width=link_arrowhead_width, link_arrowhead_length=link_arrowhead_length,
        score_color_palette_fun=score_color_palette_fun, molecule_segment_border_col=molecule_segment_border_col,
        use_individual_molecule_colors=use_individual_molecule_colors,
        default_ligand_color=default_ligand_color, default_receptor_color=default_receptor_color
    )
    return(invisible(NULL))
}


# --- Top-Level Function 2: Source-to-Target Plot ---
#' Plot Ligand-Receptor Interactions from a Single Source to Target Cell Types
#'
#' Visualizes ligand-receptor interactions focusing on a single source cell type
#' and its outgoing interactions to a specified set of target cell types. Only
#' ligands from the source and relevant receptors on the targets are shown.
#' @inheritParams plot_cell_interaction_circos
#' @param lr_interactions_df A data.frame with columns: `ligand`, `receptor`,
#'   `source_cell_type`, `target_cell_type`, `score`.
#' @param source_cell_name Character, name of the source cell type.
#' @param target_cell_names Character vector, names of target cell types to show.
#' @param cell_order Optional character vector for specific cell type ordering.
#'   If NULL, source cell is first, then targets alphabetically.
#'
#' @return Invisibly returns NULL. The function is called for its side effect of creating a plot.
#' @export
#' @examples
#' \dontrun{
#' if (requireNamespace("circlize", quietly = TRUE) &&
#'     requireNamespace("RColorBrewer", quietly = TRUE)) {
#'   lr_data <- data.frame(
#'     ligand = c("LGF1", "LGF1", "LGF2", "LGF3", "LGF4", "LGF1", "LGF5", "LGF6", "LGF7"),
#'     receptor = c("REC1", "REC2A", "REC1", "REC3B", "REC1", "REC4", "REC4", "REC2A", "REC5"),
#'     source_cell_type = c("CellA", "CellA", "CellB", "CellC", 
#'                          "CellA", "CellD", "CellD", "CellB", "CellA"),
#'     target_cell_type = c("CellB", "CellC", "CellB", "CellA", 
#'                          "CellD", "CellA", "CellD", "CellC", "CellE"),
#'     score = c(4,0.9,0.7,0.95,0.6,0.1,0.88,2.5,3.0),
#'     stringsAsFactors = FALSE
#'   )
#'   # Plot interactions from CellA to CellB and CellC
#'   # plot_source_to_target_circos(lr_data,
#'   #                          source_cell_name = "CellA",
#'   #                          target_cell_names = c("CellB", "CellC"))
#'
#'   # Custom order and score-based link widths
#'   # score_pal <- circlize::colorRamp2(c(0, 4), c("white", "blue"))
#'   # plot_source_to_target_circos(lr_data,
#'   #                          source_cell_name = "CellD",
#'   #                          target_cell_names = c("CellA", "CellD"), # Include autocrine
#'   #                          cell_order = c("CellD", "CellA"),
#'   #                          scale_link_width_by_score = TRUE,
#'   #                          score_color_palette_fun = score_pal)
#'  }
#' }
#' @import circlize
#' @import RColorBrewer
#' 
#' @export
plot_source_to_target_circos <- function(lr_interactions_df,
                                     source_cell_name,
                                     target_cell_names,
                                     cell_order = NULL,
                                     gap_degree_after_sector = 5,
                                     track_height_molecules = 0.1,
                                     molecule_label_cex = 0.6,
                                     cell_label_cex = 0.9,
                                     link_transparency = 0.5,
                                     link_connection_rou = 0.7,
                                     link_arrowhead_type = "triangle",
                                     link_arrowhead_width = NULL,
                                     link_arrowhead_length = NULL,
                                     score_color_palette_fun = NULL,
                                     split_segments_for_links = TRUE,
                                     link_buffer_fraction = 0.1,
                                     scale_link_width_by_score = FALSE,
                                     score_transform_for_width = function(s) s,
                                     use_individual_molecule_colors = TRUE,
                                     default_ligand_color = "lightgreen",
                                     default_receptor_color = "lightblue",
                                     individual_ligand_palette_generator = NULL,
                                     individual_receptor_palette_generator = NULL,
                                     molecule_segment_border_col = NA,
                                     inter_molecule_segment_gap = 0.1) {

    if (nrow(lr_interactions_df) == 0) { warning("Input 'lr_interactions_df' is empty."); return(invisible(NULL)) }
    if (missing(source_cell_name) || length(source_cell_name) != 1) stop("'source_cell_name' must be a single string.")
    if (missing(target_cell_names) || length(target_cell_names) == 0) stop("'target_cell_names' must be provided.")

    effective_lr_df <- lr_interactions_df[
        lr_interactions_df$source_cell_type == source_cell_name &
        lr_interactions_df$target_cell_type %in% target_cell_names,
    ]
    if (nrow(effective_lr_df) == 0) {
        warning("No interactions found for the specified source and target cells.")
        return(invisible(NULL))
    }
    effective_lr_df$interaction_id <- 1:nrow(effective_lr_df)


    source_ligands <- unique(effective_lr_df[effective_lr_df$source_cell_type == source_cell_name, c("source_cell_type", "ligand")])
    if(nrow(source_ligands)>0) {colnames(source_ligands) <- c("cell_type", "molecule_name"); source_ligands$molecule_type <- "ligand"
    } else {source_ligands <- data.frame(cell_type=character(), molecule_name=character(), molecule_type=character())}


    target_receptors <- unique(effective_lr_df[effective_lr_df$target_cell_type %in% target_cell_names, c("target_cell_type", "receptor")])
    if(nrow(target_receptors)>0) {colnames(target_receptors) <- c("cell_type", "molecule_name"); target_receptors$molecule_type <- "receptor"
    } else {target_receptors <- data.frame(cell_type=character(), molecule_name=character(), molecule_type=character())}

    all_molecules_definition <- unique(rbind(source_ligands, target_receptors))
    if(nrow(all_molecules_definition) == 0){
        warning("No molecules defined for source/target cells after filtering for source-target view.")
        return(invisible(NULL))
    }

    prepared_data <- .prepare_circos_data_logic(
        lr_df = effective_lr_df, all_molecules_def = all_molecules_definition,
        split_segments_for_links = split_segments_for_links, link_buffer_fraction = link_buffer_fraction,
        scale_link_width_by_score = scale_link_width_by_score, score_transform_for_width = score_transform_for_width,
        inter_molecule_segment_gap = inter_molecule_segment_gap
    )
    if (is.null(prepared_data$bed_data) || nrow(prepared_data$bed_data) == 0) {
        warning("No molecule segments to plot after data preparation for source-target view.")
        return(invisible(NULL))
    }

    # Determine plot_cell_order for this mode
    unique_cells_in_bed <- sort(unique(prepared_data$bed_data$cell_type))
    default_plot_order <- c(source_cell_name[source_cell_name %in% unique_cells_in_bed],
                            sort(target_cell_names[target_cell_names %in% unique_cells_in_bed & target_cell_names != source_cell_name]))

    current_plot_cell_order <- if (!is.null(cell_order) && length(cell_order) > 0) {
        # Ensure provided cell_order is valid for the cells actually in bed_data for this mode
        ordered_cells <- cell_order[cell_order %in% unique_cells_in_bed]
        missing_cells <- unique_cells_in_bed[!unique_cells_in_bed %in% ordered_cells]
        if (length(missing_cells) > 0) {
             warning(paste("Some relevant cells were not in 'cell_order' for source-target plot:", paste(missing_cells, collapse=", "), ". Appending them."))
        }
        c(ordered_cells, missing_cells)
    } else {
        default_plot_order
    }
    current_plot_cell_order <- unique(current_plot_cell_order) # Ensure unique in case source was in targets
    if (length(current_plot_cell_order) == 0) { warning("No cell types to plot in source-target view."); return(invisible(NULL)) }


    plot_colors <- .generate_circos_colors(
        molecules_in_plot_df = unique(prepared_data$bed_data[, c("molecule_name", "molecule_type")]),
        cell_types_in_plot_vector = current_plot_cell_order,
        use_individual_molecule_colors = use_individual_molecule_colors, default_ligand_color = default_ligand_color,
        default_receptor_color = default_receptor_color, individual_ligand_palette_generator = individual_ligand_palette_generator,
        individual_receptor_palette_generator = individual_receptor_palette_generator
    )

    .draw_circos_plot_elements(
        bed_data = prepared_data$bed_data, links_data = prepared_data$links_data,
        plot_cell_order = current_plot_cell_order, cell_type_colors = plot_colors$cell_type_colors,
        name_colors_ligand = plot_colors$name_colors_ligand, name_colors_receptor = plot_colors$name_colors_receptor,
        gap_degree_after_sector=gap_degree_after_sector, track_height_molecules=track_height_molecules,
        molecule_label_cex=molecule_label_cex, cell_label_cex=cell_label_cex,
        link_transparency=link_transparency, link_connection_rou=link_connection_rou,
        link_arrowhead_type=link_arrowhead_type,
        link_arrowhead_width=link_arrowhead_width, link_arrowhead_length=link_arrowhead_length,
        score_color_palette_fun=score_color_palette_fun, molecule_segment_border_col=molecule_segment_border_col,
        use_individual_molecule_colors=use_individual_molecule_colors,
        default_ligand_color=default_ligand_color, default_receptor_color=default_receptor_color,
    )
    return(invisible(NULL))
}

#' Plot Ligand-Receptor Interactions from Multiple Source to a Single Target Cell Type
#'
#' Visualizes ligand-receptor interactions focusing on a single target cell type
#' and its incoming interactions from a specified set of source cell types. Only
#' relevant ligands from the source cells and receptors on the target cell are shown.
#' @inheritParams plot_source_to_target_circos
#' @param lr_interactions_df A data.frame with columns: `ligand`, `receptor`,
#'   `source_cell_type`, `target_cell_type`, `score`.
#' @param source_cell_names Character vector, names of source cell types to show.
#' @param target_cell_name Character, name of the single target cell type.
#' @param cell_order Optional character vector for specific cell type ordering.
#'   If NULL, target cell is first, then sources alphabetically.
#'
#' @return Invisibly returns NULL. The function is called for its side effect of creating a plot.
#' @export
#' @import circlize
#' @import RColorBrewer
#' @examples
#' \dontrun{
#' if (requireNamespace("circlize", quietly = TRUE) &&
#'     requireNamespace("RColorBrewer", quietly = TRUE)) {
#'   # Use the same test data from previous examples
#'   test_lr_data <- data.frame(
#'     ligand = c("LGF1","LGF1","LGF2","LGF3","LGF4","LGF1","LGF5","LGF6","LGF5"),
#'     receptor = c("REC1","REC2","REC1","REC1","REC5","REC4","REC4","REC6","REC2"),
#'     source_cell_type = c("CellA","CellA","CellB","CellC","CellA","CellD","CellD","CellE","CellD"),
#'     target_cell_type = c("CellB","CellC","CellA","CellD","CellD","CellA","CellD","CellF","CellA"),
#'     score = c(4.0,2.5,3.0,2.2,1.5,1.0,3.5,0.5,2.8),
#'     stringsAsFactors = FALSE
#'   )
#'   # Plot interactions from CellB and CellD converging on CellA
#'   # plot_target_from_sources_circos(test_lr_data,
#'   #                             source_cell_names = c("CellB", "CellD"),
#'   #                             target_cell_name = "CellA")
#'
#'   # Another example: Interactions from CellA and CellC targeting CellD
#'   # plot_target_from_sources_circos(test_lr_data,
#'   #                             source_cell_names = c("CellA", "CellC"),
#'   #                             target_cell_name = "CellD",
#'   #                             scale_link_width_by_score = TRUE)
#'  }
#' }
plot_target_from_sources_circos <- function(lr_interactions_df,
                                        source_cell_names,
                                        target_cell_name,
                                        cell_order = NULL,
                                        # Pass through all other parameters
                                        gap_degree_after_sector = 5,
                                        track_height_molecules = 0.1,
                                        molecule_label_cex = 0.6,
                                        cell_label_cex = 0.9,
                                        link_transparency = 0.5,
                                        link_connection_rou = 0.7,
                                        link_arrowhead_type = "triangle",
                                        link_arrowhead_width = 0.1, # Explicit default
                                        link_arrowhead_length = 0.1, # Explicit default
                                        score_color_palette_fun = NULL,
                                        split_segments_for_links = TRUE,
                                        link_buffer_fraction = 0.1,
                                        scale_link_width_by_score = FALSE,
                                        score_transform_for_width = function(s) s,
                                        use_individual_molecule_colors = TRUE,
                                        default_ligand_color = "lightgreen",
                                        default_receptor_color = "lightblue",
                                        individual_ligand_palette_generator = NULL,
                                        individual_receptor_palette_generator = NULL,
                                        molecule_segment_border_col = NA,
                                        inter_molecule_segment_gap = 0.1) {

    # --- Parameter Validation & Package Checks ---
    if (nrow(lr_interactions_df) == 0) { warning("Input 'lr_interactions_df' is empty."); return(invisible(NULL)) }
    if (missing(source_cell_names) || length(source_cell_names) == 0) stop("'source_cell_names' must be provided.")
    if (missing(target_cell_name) || length(target_cell_name) != 1) stop("'target_cell_name' must be a single string.")

    # --- 1. Filter interactions for sources -> single target ---
    effective_lr_df <- lr_interactions_df[
        lr_interactions_df$source_cell_type %in% source_cell_names &
        lr_interactions_df$target_cell_type == target_cell_name,
    ]
    if (nrow(effective_lr_df) == 0) {
        warning("No interactions found for the specified source and target cells.")
        return(invisible(NULL))
    }
    effective_lr_df$interaction_id <- 1:nrow(effective_lr_df)

    # --- 2. Define specialized all_molecules_definition ---
    # Source cells: only ligands involved in the filtered interactions
    source_ligands <- unique(effective_lr_df[effective_lr_df$source_cell_type %in% source_cell_names, c("source_cell_type", "ligand")])
    if(nrow(source_ligands)>0) {
      colnames(source_ligands) <- c("cell_type", "molecule_name"); source_ligands$molecule_type <- "ligand"
    } else {
      source_ligands <- data.frame(cell_type=character(), molecule_name=character(), molecule_type=character())
    }

    # Target cell: only receptors involved in the filtered interactions
    target_receptors <- unique(effective_lr_df[effective_lr_df$target_cell_type == target_cell_name, c("target_cell_type", "receptor")])
    if(nrow(target_receptors)>0) {
      colnames(target_receptors) <- c("cell_type", "molecule_name"); target_receptors$molecule_type <- "receptor"
    } else {
      target_receptors <- data.frame(cell_type=character(), molecule_name=character(), molecule_type=character())
    }
    
    all_molecules_definition <- unique(rbind(source_ligands, target_receptors))
    if(nrow(all_molecules_definition) == 0){
        warning("No molecules defined for source/target cells after filtering.")
        return(invisible(NULL))
    }

    # --- 3. Prepare Data using Helper ---
    prepared_data <- .prepare_circos_data_logic(
        lr_df = effective_lr_df,
        all_molecules_def = all_molecules_definition,
        split_segments_for_links = split_segments_for_links,
        link_buffer_fraction = link_buffer_fraction,
        scale_link_width_by_score = scale_link_width_by_score,
        score_transform_for_width = score_transform_for_width,
        inter_molecule_segment_gap = inter_molecule_segment_gap
    )
    if (is.null(prepared_data$bed_data) || nrow(prepared_data$bed_data) == 0) {
        warning("No molecule segments to plot after data preparation.")
        return(invisible(NULL))
    }

    # --- 4. Determine Cell Order for Plotting ---
    unique_cells_in_bed <- sort(unique(prepared_data$bed_data$cell_type))
    actual_source_cells_in_plot <- sort(source_cell_names[source_cell_names %in% unique_cells_in_bed])
    default_plot_order <- c(target_cell_name, actual_source_cells_in_plot)
    
    current_plot_cell_order <- if (!is.null(cell_order) && length(cell_order) > 0) {
        expected_cells <- default_plot_order
        if(!all(expected_cells %in% cell_order) || !all(cell_order %in% expected_cells)){
             warning("Custom 'cell_order' is inconsistent. Using default: target then sorted sources.")
             default_plot_order
        } else { cell_order }
    } else {
        default_plot_order
    }
    current_plot_cell_order <- current_plot_cell_order[current_plot_cell_order %in% unique_cells_in_bed]
    if (length(current_plot_cell_order) == 0) { warning("No cell types to plot."); return(invisible(NULL)) }

    # --- 5. Generate Colors using Helper ---
    plot_colors <- .generate_circos_colors(
        molecules_in_plot_df = unique(prepared_data$bed_data[, c("molecule_name", "molecule_type")]),
        cell_types_in_plot_vector = current_plot_cell_order,
        use_individual_molecule_colors = use_individual_molecule_colors,
        default_ligand_color = default_ligand_color,
        default_receptor_color = default_receptor_color,
        individual_ligand_palette_generator = individual_ligand_palette_generator,
        individual_receptor_palette_generator = individual_receptor_palette_generator
    )

    # --- 6. Draw Plot using Helper ---
    .draw_circos_plot_elements(
        bed_data = prepared_data$bed_data,
        links_data = prepared_data$links_data,
        plot_cell_order = current_plot_cell_order,
        cell_type_colors = plot_colors$cell_type_colors,
        name_colors_ligand = plot_colors$name_colors_ligand,
        name_colors_receptor = plot_colors$name_colors_receptor,
        # Pass through all relevant plotting params
        gap_degree_after_sector=gap_degree_after_sector, track_height_molecules=track_height_molecules,
        molecule_label_cex=molecule_label_cex, cell_label_cex=cell_label_cex,
        link_transparency=link_transparency, link_connection_rou=link_connection_rou,
        link_arrowhead_type=link_arrowhead_type,
        link_arrowhead_width=link_arrowhead_width, link_arrowhead_length=link_arrowhead_length,
        score_color_palette_fun=score_color_palette_fun,
        molecule_segment_border_col=molecule_segment_border_col,
        use_individual_molecule_colors = use_individual_molecule_colors,
        default_ligand_color = default_ligand_color,
        default_receptor_color = default_receptor_color
    )
    return(invisible(NULL))
}

## author: Atul Deshpande
## email: adeshpande@jhu.edu

#===================
#' @title Identify hotspots of spatial pattern influence
#' @description This function calculates 'hotspots' which are regions of high
#'  spatial influence based on an outlier threshold from a null distribution. 
#' @export
#' @family getIntGenes
#' @param    spPatterns    A data frame that contains the spatial coordinates 
#' and metrics for spatial features (cell types/cell processes). The column 
#' names must include 'x' and 'y' as well as the spatially varying features.
#' @param    params    a named vector of the optimal sigma and threshold for a 
#' given spatial pattern. The names are should be 'sigmaOpt' and 'threshOpt'.
#' The default value is NULL.
#' @param patternName     a character string that specifies the pattern of 
#' interest
#' @param    outlier    a character string specifying whether to apply the 
#' outlier threshold to the kernel density distribution in a one-sided manner
#' (specify 'positive' the default) or in a two sided manner (specify 
#' 'two.sided').
#' @param nullSamples a numeric values specifying the number of spatial patterns
#' to randomly sample for a null distribution.
#' @param    includeSelf    a logic value specifying whether to consider the
#' spatial influence the pattern has on surrounding regions only (set to FALSE),
#' or whether to also consider the influence of the pattern itself (set to TRUE
#' , the default).
#' @param ... Arguments passed to methods
#' @return a character vector with the spatial feature name if the spatial 
#' influence exceeded the threshold for that spot/cell, and NA otherwise
#' @examples 
#' library(SpaceMarkers)
#' #Visium data links
#' urls <- read.csv(system.file("extdata","visium_data.txt",
#'                            package="SpaceMarkers",mustWork = TRUE))
#' sp_url <- urls[["visium_url"]][2]
#' #Remove present Directories if any
#' unlink(basename(sp_url))
#' unlink("spatial", recursive = TRUE)
#' #Obtaining CoGAPS Patterns i.e Spatial Features
#' cogaps_result <- readRDS(system.file("extdata","CoGAPS_result.rds",
#'                                    package="SpaceMarkers",mustWork = TRUE))
#' spFeatures <- slot(cogaps_result,"sampleFactors")
#' #Obtaining Spatial Coordinates
#' download.file(sp_url, basename(sp_url), mode = "wb")
#' untar(basename(sp_url))
#' spCoords <- load10XCoords(visiumDir = ".", version = "1.0")
#' rownames(spCoords) <- spCoords$barcode
#' #Match Dimensions
#' barcodes <- intersect(rownames(spFeatures),spCoords$barcode)
#' spCoords <- spCoords[barcodes,]
#' spFeatures <- spFeatures[barcodes,]
#' spPatterns <- cbind(spCoords,spFeatures[barcodes,])
#' spPatterns<-spPatterns[c("barcode","y","x","Pattern_1","Pattern_5")]
#' data("optParams")
#' hotspots <- find_pattern_hotspots(
#' spPatterns = spPatterns,
#' patternName = "Pattern_1",
#' params = optParams[,"Pattern_1"],
#' outlier = "positive",nullSamples = 1000,includeSelf = TRUE)
#' #Remove present Directories if any
#' unlink(basename(sp_url))
#' unlink("spatial", recursive = TRUE)
#' 

find_pattern_hotspots <- function(
    spPatterns, params = NULL, patternName = "Pattern_1",
    outlier = "positive",
    nullSamples = 1000, includeSelf = TRUE,...){
    if (is.null(params)){
        sigma <- 10
        kernelthreshold <- 4
    } else {
        sigma <- params["sigmaOpt"]
        kernelthreshold <- params["threshOpt"]
    }
    
    allwin <- spatstat.geom::owin(
        xrange = c(min(spPatterns$x),max(spPatterns$x)),yrange =c(
            min(spPatterns$y),max(spPatterns$y)))
    patternVector <- as.matrix(spPatterns[,patternName])
    X <-spatstat.geom::ppp(
        x=spPatterns$x,y = spPatterns$y, window = allwin,marks = patternVector)
    Kact1 <- spatstat.explore::Smooth(
        X, at = "points", sigma = sigma[1], ...)
    if (includeSelf == TRUE){
      Kact1 <- spPatterns[,patternName] + Kact1
    } else {
      Kact1 <- Kact1
    }
    Karr1 <- vapply(seq(1,nullSamples),function(i){
        Xr<-X;
        spatstat.geom::marks(Xr) <- sample(spatstat.geom::marks(X));
        temp <- spatstat.explore::Smooth(
                    Xr, at="points", sigma = sigma, ...); 
                return(temp)}, numeric(length(Kact1)))
    Karr1 <- unlist(Karr1)
    mKvec <- mean(Karr1)
    sKvec <- sd(Karr1)
    upthresh <- mKvec+kernelthreshold*sKvec
    lothresh <- mKvec-kernelthreshold*sKvec
    if (outlier == "positive"){
        ind1 <- which(Kact1 > upthresh[1])
    }
    else if (outlier == "two.sided")
    {
        ind1 <- which((Kact1 > upthresh)|(Kact1 < lothresh))
    }
    region <- array(NA, length(Kact1))
    region[ind1] <- patternName
    return(region)
}

#===================
#' @title Find hotSpots for all spatial patterns
#' @description Convenience function to find hotspots for all spatial patterns
#' @inheritParams find_pattern_hotspots
#' @export

find_all_hotspots <- function(spPatterns, params = NULL, outlier = "positive",
                        nullSamples = 1000, includeSelf = TRUE,...){
    pattList <- setdiff(colnames(spPatterns),c("x","y","barcode"))
    hotspots <- matrix(NA, nrow=nrow(spPatterns), ncol=length(pattList))
    colnames(hotspots) <- pattList
    for (patternName in pattList){
        hotspots[,patternName] <- find_pattern_hotspots(
            spPatterns = spPatterns, params = params[,patternName],
            patternName = patternName, outlier = outlier,
            nullSamples = nullSamples, includeSelf = includeSelf,...)
    }
    hotspots <- cbind(spPatterns[c("barcode","y","x")],hotspots)
    row.names(hotspots) <- hotspots$barcode
    return(as.data.frame(hotspots))
}

.get_test_mat <- function(data,reconstruction,mode){
    if ("DE" %in% mode)
        testMat <- data
    else if ("residual" %in% mode)
        if (is.null(reconstruction))
            stop("Reconstruction matrix not provided for residual mode.")
        else if (all(dim(data)!=dim(reconstruction)))
            stop("Original and reconstruction have mismatched dimensions.")
        else if (any(dimnames(data)[[1]]!=dimnames(reconstruction)[[1]]))
            stop("Original and reconstruction have mismatched row names.")
        else if (any(dimnames(data)[[2]]!=dimnames(reconstruction)[[2]]))
            stop("Original and reconstruction have mismatched column names.")
        else 
            testMat <- data - reconstruction
    else
        stop("Invalid mode. mode must be either DE or residual.")
    return(testMat)
}

.get_spacemarkers_metric <- function(interacting.genes){
    interacting_genes <- lapply(interacting.genes, as.data.frame)
    if (length(interacting_genes) == 0)
    {
        message("No interacting genes found. Returning 
            result with only hotspots.")
        return(interacting_genes)
    }
        
    for (i in seq(1,length(interacting_genes))){
        interacting_genes[[i]]$KW.p.adj <- as.numeric(
            interacting_genes[[i]]$KW.p.adj)
        interacting_genes[[i]]$Dunn.pval_1_Int.adj <- as.numeric(
            interacting_genes[[i]]$Dunn.pval_1_Int.adj)
        interacting_genes[[i]]$Dunn.pval_2_Int.adj <- as.numeric(
            interacting_genes[[i]]$Dunn.pval_2_Int.adj)
    }
    for (i in seq(1,length(interacting_genes)))
    {
        if (all(dim(interacting_genes[[i]])>1))   {
            Zsign <- (2*(-1+((interacting_genes[[i]]$Dunn.zP1_Int<0)&
                        (interacting_genes[[i]]$Dunn.zP2_Int<0))*1)+1)
            Zmag <- abs((interacting_genes[[i]]$Dunn.zP1_Int)*
                    (interacting_genes[[i]]$Dunn.zP2_Int)/
                    (pmax(abs(interacting_genes[[i]]$Dunn.zP2_P1),1)))
                interacting_genes[[i]]$SpaceMarkersMetric <- Zsign*log2(Zmag+1)
                od <- order(
                    interacting_genes[[i]]$SpaceMarkersMetric,decreasing=TRUE)
                interacting_genes[[i]] <- interacting_genes[[i]][od,]
                interacting_genes[[i]] <- interacting_genes[[i]][!is.na(
                    interacting_genes[[i]]$SpaceMarkersMetric),]
        }
    }
    return(interacting_genes)
}


#===================
#' @title Calculate Interaction Regions and Associated Genes
#' @description This function calculates statistically significant genes using a 
#' non-parametric Kruskal-Wallis test for genes in any one region 
#' of influence and a post hoc Dunn's test is used for analysis of 
#' genes between regions.
#' @export
#' @family getIntGenes
#' @param    data    original spatial data matrix.
#' @param    reconstruction    reconstruction of the data matrix from latent 
#' spaces. Required for "residual" mode.
#' @param    spPatterns    A data frame that contains the spatial coordinates 
#' and metrics for spatial features (cell types/cell processes). The column 
#' names must include 'x' and 'y' as well as the spatially varying features.
#' @param    optParams    a matrix with dimensions 2 X N, where N is the number
#' of spatial patterns with optimal parameters. The first row contains the 
#' kernel width 'sigmaOpt' for each pattern, and the second row is the
#' threshOpt (outlier threshold) for each pattern. Users can also input their
#' preferred param values. The default value is NULL.
#' @param refPattern     a character string that specifies the pattern whose
#'  "interaction" with every other pattern we want
#' to study. The default value is "Pattern_1".
#' @param    mode    SpaceMarkers mode of operation. Possible values are
#'  "DE" (the default) or "residual".
#' @param    minOverlap    a number that specifies the minimum overlap between
#'  genes in two patterns to be considered for the statistical tests.
#'  The default is 50.
#' @param    hotspots    a vector that specifies the patterns to compare
#'  to the 'refPattern'. The default is NULL which indicates that all patterns
#'   would be compared to the 'refPattern'.
#' @param analysis a character string that specifies the type of downstream 
#' analysis to be performed. Possible values are "enrichment" (default) 
#' and "overlap". In enrichment mode, all genes are returned, ranked by 
#' the SpaceMarkers metric. In overlap mode, only the genes which are 
#' significantly overexpressed in the interaction region are returned.
#' @param ... Arguments passed to methods
#' @return a list of data frames with information about the interacting genes
#'  of the refPattern and each latent feature pattern matrix 
#'  (interacting_genes object). There is also a data frame with all of the
#'   regions of influence for any two of patterns (the hotspots object).
#' @examples 
#' library(SpaceMarkers)
#' #Visium data links
#' urls <- read.csv(system.file("extdata","visium_data.txt",
#' package="SpaceMarkers",mustWork = TRUE))
#' counts_url <- urls[["visium_url"]][1]
#' sp_url <- urls[["visium_url"]][2]
#' #Remove present Directories if any
#' unlink(basename(sp_url))
#' unlink("spatial", recursive = TRUE)
#' files <- list.files(".")[grepl(basename(counts_url),list.files("."))]
#' unlink(files)
#' download.file(counts_url,basename(counts_url), mode = "wb")
#' counts_matrix<-load10XExpr(visiumDir=".",h5filename = basename(counts_url))
#' #Obtaining CoGAPS Patterns
#' cogaps_result <- readRDS(system.file("extdata","CoGAPS_result.rds",
#' package="SpaceMarkers",mustWork = TRUE))
#' features <- intersect(rownames(counts_matrix),rownames(
#'     slot(cogaps_result,"featureLoadings")))
#' barcodes <- intersect(colnames(counts_matrix),rownames(
#'     slot(cogaps_result,"sampleFactors")))
#' counts_matrix <- counts_matrix[features,barcodes]
#' cogaps_matrix <- slot(cogaps_result,"featureLoadings")[features,]%*%
#'     t(slot(cogaps_result,"sampleFactors")[barcodes,])
#' #Obtaining Spatial Coordinates
#' download.file(sp_url, basename(sp_url), mode = "wb")
#' untar(basename(sp_url))
#' spCoords <- load10XCoords(visiumDir = ".", version = "1.0")
#' rownames(spCoords) <- spCoords$barcode
#' spCoords <- spCoords[barcodes,]
#' spPatterns <- cbind(spCoords,slot(cogaps_result,
#' "sampleFactors")[barcodes,])
#' data("curated_genes")
#' spPatterns<-spPatterns[c("barcode","y","x","Pattern_1","Pattern_5")]
#' counts_matrix <- counts_matrix[curated_genes,]
#' cogaps_matrix <- cogaps_matrix[curated_genes, ]
#' data("optParams")
#' SpaceMarkersMode <- "DE"
#' ref_Pattern <- "Pattern_1"
#' SpaceMarkers_test <- get_interacting_genes(
#'     data=counts_matrix,reconstruction=NULL,
#'     optParams = optParams,
#'     spPatterns = spPatterns,
#'     refPattern = "Pattern_1",
#'     mode="DE",analysis="overlap")
#' #Remove present Directories if any
#' unlink(basename(sp_url))
#' unlink("spatial", recursive = TRUE)
#' files <- list.files(".")[grepl(basename(counts_url),list.files("."))]
#' unlink(files)
#' 

get_interacting_genes <- function(data, spPatterns, refPattern="Pattern_1",
                                mode=c("DE","residual"), optParams=NULL,
                                reconstruction=NULL, hotspots=NULL,
                                analysis=c("enrichment","overlap"),
                                minOverlap=50,...) {

    testMat <- .get_test_mat(data,reconstruction,mode)
    pattList<- setdiff(colnames(spPatterns),c("barcode","x","y"))
    if (is.null(optParams)){
        stop("optParams not provided. Please run get_spatial_parameters() to get
        optParams and pass to the function.")
    } else {
        message("Using user provided optParams.")
        if (any(colnames(optParams)!=pattList)) stop(
            "Colnames of optParams must match Pattern names.")
        if (any(rownames(optParams)!=c("sigmaOpt","threshOpt"))) stop(
            "Rownames of optParams must match c(\"sigmaOpt\",\"threshOpt\")")
        if(any(!is.numeric(optParams))) stop("optParams must be numeric.")
    }
    if (is.null(hotspots)) {
        hotspots <- c()
        for (patternName in pattList) {
            hotspots <- cbind(
                hotspots,find_pattern_hotspots(
                    spPatterns=spPatterns,patternName=patternName,
                    params=optParams[,patternName],outlier = "positive") )
        }
        colnames(hotspots) <- pattList
    }
    else if (!((refPattern %in% colnames(hotspots)) && (nrow(
        hotspots)==ncol(data))))
        message("hotspots does not have refPattern column or dimension 
    does not match with data.")
    else 
        message("Using user provided hotspot regions.")
    interacting_genes <- list()
    for (pattern in setdiff(pattList,refPattern)){
        region <- hotspots[,refPattern]
        region <- ifelse(!is.na(region) & !is.na(
            hotspots[,pattern]),"Interacting",ifelse(
                !is.na(region),region,hotspots[,pattern]))
        region <- factor(region)
        if (length(levels(region))<3||any(table(region)<minOverlap))#def. 50
            message(refPattern," and ",pattern," do not sufficiently interact.
                Skipping statistical test for genes.")
        else {
            message("Calculating genes of interest for ",refPattern," and ",
                pattern)
            interacting_genes<-c(interacting_genes,.find_genes_of_interest(
                    testMat = testMat, region=region,...))
        }
    }
    interacting_genes <- .get_spacemarkers_metric(interacting_genes)
    return(list(interacting_genes=interacting_genes,hotspots=hotspots))
}

#' ================
#' @title get_pairwise_interacting_genes
#' @description Performs pairwise analysis to find genes associated with 
#' spatial interaction between pairs of spatially varying patterns. 
#' @export
#' @family getIntGenes
#' @inheritParams get_interacting_genes
#' @param pattern_pairs A matrix of pattern pairs to be analyzed. Default is
#' @param workers (optional) Number of workers to 
#' be used for parallel processing.
#' @return a list of data frames for each pattern with 1) names of the patterns 
#' (patterns object) 2) data frame with the hotspots of influence for the
#'  two patterns (the hotspots object). 3) data frame with the genes 
#'  associated with the interaction between the two patterns
#'   (interacting genes object, empty if insufficient interaction). 
#' @examples
#' library(SpaceMarkers)
#' #Visium data links
#' urls <- read.csv(system.file("extdata","visium_data.txt",
#' package="SpaceMarkers",mustWork = TRUE))
#' counts_url <- urls[["visium_url"]][1]
#' sp_url <- urls[["visium_url"]][2]
#' #Remove present Directories if any
#' unlink(basename(sp_url))
#' unlink("spatial", recursive = TRUE)
#' files <- list.files(".")[grepl(basename(counts_url),list.files("."))]
#' unlink(files)
#' download.file(counts_url,basename(counts_url), mode = "wb")
#' counts_matrix<-load10XExpr(visiumDir=".",
#' h5filename = basename(counts_url))
#' #Obtaining CoGAPS Patterns
#' cogaps_result <- readRDS(system.file("extdata","CoGAPS_result.rds",
#' package="SpaceMarkers",mustWork = TRUE))
#' features <- intersect(rownames(counts_matrix),rownames(
#'     slot(cogaps_result,"featureLoadings")))
#' barcodes <- intersect(colnames(counts_matrix),rownames(
#'     slot(cogaps_result,"sampleFactors")))
#' counts_matrix <- counts_matrix[features,barcodes]
#' cogaps_matrix <- slot(cogaps_result,"featureLoadings")[features,]%*%
#'     t(slot(cogaps_result,"sampleFactors")[barcodes,])
#' #Obtaining Spatial Coordinates
#' download.file(sp_url, basename(sp_url), mode = "wb")
#' untar(basename(sp_url))
#' spCoords <- load10XCoords(visiumDir = ".", version = "1.0")
#' rownames(spCoords) <- spCoords$barcode
#' spCoords <- spCoords[barcodes,]
#' spPatterns <- cbind(spCoords,
#' slot(cogaps_result,"sampleFactors")[barcodes,])
#' data("curated_genes")
#' spPatterns<-spPatterns[c("barcode","y","x","Pattern_1",
#' "Pattern_3","Pattern_5")]
#' counts_matrix <- counts_matrix[curated_genes,]
#' cogaps_matrix <- cogaps_matrix[curated_genes, ]
#' optParams <- matrix(c(6, 2, 6, 2, 6, 2), nrow = 2)
#' rownames(optParams) <- c("sigmaOpt","threshOpt")
#' colnames(optParams) <- c("Pattern_1","Pattern_3","Pattern_5")
#' SpaceMarkersMode <- "DE"
#' pattern_pairs <- matrix(c("Pattern_1", "Pattern_1", 
#'            "Pattern_3", "Pattern_5"), nrow=2)
#' SpaceMarkers <- get_pairwise_interacting_genes(
#'     data=counts_matrix,reconstruction=NULL,
#'     optParams = optParams,
#'     spPatterns = spPatterns,
#'     mode="DE",analysis="enrichment", pattern_pairs=pattern_pairs)
#' #Remove present Directories if any
#' unlink(basename(sp_url))
#' unlink("spatial", recursive = TRUE)
#' files <- list.files(".")[grepl(basename(counts_url),list.files("."))]
#' unlink(files)
#' 

get_pairwise_interacting_genes <- function(data, spPatterns, 
                                    mode=c("DE","residual"), 
                                    optParams=NULL, reconstruction=NULL, 
                                    hotspots=NULL, minOverlap=50,
                                    analysis=c("enrichment","overlap"),
                                    pattern_pairs=NULL ,..., workers=NULL) {
    # save params in a list for easy passing
    argsParams <- list(spPatterns=spPatterns, mode=mode, 
                        optParams=optParams, hotspots=hotspots, 
                        analysis=analysis, minOverlap=minOverlap)
    if (!exists("patternList"))
        patternList <- setdiff(colnames(spPatterns), c("x","y","barcode"))
    else {
        if (!all(patternList %in% colnames(spPatterns)))
            stop("patternList contains patterns not present in spPatterns.")
    }
    
    # check pattern_pairs if provided, if not generate them
    pattern_pairs <- .get_pattern_pairs(patternList=patternList, 
                                        pattern_pairs=pattern_pairs)

    input_list <- apply(pattern_pairs,1, .pair_args_list, argsParams)
    
    # Check if BiocParallel is installed
    use_biocparallel <- requireNamespace("BiocParallel", quietly = TRUE) &&
                            (length(input_list)>1)
    
    if (use_biocparallel) {
        
        # Determine the number of workers to use
        if (is.null(workers)) {
            workers <- BiocParallel::multicoreWorkers()  # Use default 
        } else if (workers <= 0) {
            stop("Invalid number of workers. #
                Please provide a positive integer.")
        }
        
        # Register parallel backend
        bpparam <- BiocParallel::MulticoreParam(workers = workers)
        
        # Run the loop with BiocParallel
        results <- BiocParallel::bplapply(input_list, function(args) {
            # call get_interacting_genes for a pair 
            do.call(get_interacting_genes, c(list(data = data), 
                list(reconstruction=reconstruction), args, ...))
        }, BPPARAM = bpparam)  # Use the specified parallel backend
    } else {
        # Use a regular for loop with input_list
        results <- vector("list", length = length(input_list))
        
        for (ii in seq(1,length(input_list))){
            results[[ii]] <- do.call(get_interacting_genes, c(list(data = data), 
                list(reconstruction=reconstruction), input_list[[ii]],...))
        }
    }
    for (ii in seq(1,length(results)))
        results[[ii]]$patterns <- pattern_pairs[ii,]
    names(results) <- apply(pattern_pairs,1,paste,collapse="_")
    return(results)
}

# Create a list of arguments for passing two patterns to getInteractingGenes
.pair_args_list <- function(patternPair, argsParams) {
    patcols <- c("x","y", "barcode",patternPair)
    argList <- list(
        spPatterns = argsParams$spPatterns[, patcols],
        hotspots = argsParams$hotspots[, patcols],
        optParams = argsParams$optParams[, patternPair],
        refPattern = patternPair[1],
        mode = argsParams$mode,
        analysis = argsParams$analysis,
        minOverlap = argsParams$minOverlap)
    return(argList)
}

.get_pattern_pairs <- function(patternList, pattern_pairs) {
    if (is.null(pattern_pairs)){
        message("pattern_pairs not provided. Calculating all 
            possible pairs.")
        pattern_pairs <- t(utils::combn(patternList,2,simplify = TRUE))
    } else {
        if (is.list(pattern_pairs)) {
            if (!all(vapply(pattern_pairs,length, FUN.VALUE = 1)==2)) 
                stop("Each item in the pattern_pairs list 
                    must be a vector of 2 patterns.")
            pattern_pairs <- do.call(rbind, pattern_pairs)
        } else if (is.matrix(pattern_pairs)) {
            if (ncol(pattern_pairs) != 2) 
                stop("pattern_pairs matrix must have 2 columns.")
        } else if(is.character(pattern_pairs)) {
            if (length(pattern_pairs)!=2){
                stop("A single pair be a character vector of length 2.")
            } else
                pattern_pairs <- matrix(pattern_pairs, nrow=1)
        }
        else
            stop("pattern_pairs must either be a 2-column matrix 
                or a list of vectors.")
        mess <- paste0(setdiff(pattern_pairs, patternList)," ")
        if (!all(pattern_pairs %in% patternList)) 
            stop("Following are not pattern names: ",mess )
    }
    return(pattern_pairs)
}

test_that("getInteracting genes return empty interacting_genes object when no interacting genes found", {
  library(testthat)
  # Create some sample data and patterns for testing
  set.seed(123)
  cells <- c()
  cell_num <- 500
  gene_num <- 100
  for(i in 1:cell_num){
    cells[length(cells)+1] <- paste0("cell_",i)
  }
  data <- matrix(rnorm(5), ncol = gene_num,nrow = cell_num)
  rownames(data) <- cells
  colnames(data) <- paste0("gene",1:gene_num)
  
  spPatterns <- data.frame(barcode = cells,
                           y = runif(cell_num, min=0, max=cell_num),
                           x = runif(cell_num , min=0, max=cell_num ),
                           "Pattern_1" = runif(cell_num , min=0, max=1),
                           "Pattern_2" = runif(cell_num , min=0, max=1))
  optParams <- NULL
  expect_error(output <- get_interacting_genes(data=data, spPatterns,
      reconstruction=NULL,
      optParams = optParams,
      spPatterns = spPatterns,
      refPattern = "Pattern_1",
      mode="DE",analysis="overlap"))
  
  optParams <- matrix(c(7,2.1,6.4,1.2), nrow=2, ncol=2)
  rownames(optParams) <- c("sigmaOpt","threshOpt")
  colnames(optParams) <- c("Pattern_1","Pattern_2")
  suppressWarnings(output <- get_interacting_genes(data=data, spPatterns,
                                                 reconstruction=NULL,
                                optParams = optParams,
                                spPatterns = spPatterns,
                                refPattern = "Pattern_1",
                                mode="DE",analysis="overlap"))
  # Checking result if no interacting genes found
  res<-evaluate_promise(output$interacting_genes)
  expect_equal(res$result, list())
  
})

test_that("test no interacting genes in nmf output", {
    expect_true(is.list(.get_spacemarkers_metric(list())))
})

# Sample data for testing
spPatterns <- data.frame(
  x = runif(100, 0, 10),
  y = runif(100, 0, 10),
  Pattern_1 = rnorm(100)
)

# Test with includeSelf = FALSE
test_that("findPatternHotspots works with includeSelf = FALSE", {
  result <- find_pattern_hotspots(spPatterns, patternName = "Pattern_1",
                                includeSelf = FALSE)
  expect_type(result, "character")
})

# Test behavior with different outlier types
test_that("findPatternHotspots handles outlier parameter correctly", {
  result_positive <- find_pattern_hotspots(spPatterns, patternName = "Pattern_1",
                                         outlier = "positive")
  result_two_sided <- find_pattern_hotspots(spPatterns, patternName = "Pattern_1",
                                          outlier = "two.sided")
  
  expect_true(all(is.na(result_positive) | result_positive == "Pattern_1"))
  expect_true(all(is.na(result_two_sided) | result_two_sided == "Pattern_1"))
})

# 1. Test with no 'pattern_pairs' provided
test_that("No pattern_pairs - computes all pairs", {
    # Create sample data (adjust to match your actual data structure)
    args <- .create_sample_data()
    # Call the function
    
    suppressMessages(
    result <- get_pairwise_interacting_genes(data=args$data,
        spPatterns=args$spPatterns,
        optParams=args$optParams, minOverlap = 0)
    )
    patnames <- setdiff(colnames(args$spPatterns), c("x", "y", "barcode"))
    # Check the number of results (should be 1 since there are 2 patterns)
    expect_equal(length(result), choose(length(patnames), 2))
    patcombs <- t(utils::combn(patnames, 2))
    patcombs <- apply(patcombs, 1, function(x) paste(x, collapse = "_"))
    # Check the names of the results (should be "pattern1_pattern2")
    expect_equal(names(result), patcombs)
})

# 2. Test with a matrix of 'pattern_pairs'
test_that("Matrix pattern_pairs - specific pairs", {
    # Create sample data
    args <- .create_sample_data()
    # Define specific pattern pairs
    pattern_pairs <- rbind(c("pattern1", "pattern2"), c("pattern1", "pattern3"))
    
    # Call the function
    suppressMessages(
    result <- get_pairwise_interacting_genes(data=args$data, 
        spPatterns=args$spPatterns, 
        optParams=args$optParams, 
        pattern_pairs = pattern_pairs, minOverlap = 0)
    )
    # Check the number of results (should be 1)
    expect_equal(length(result), 2)
    
    # Check the names of the results
    expect_equal(names(result), c("pattern1_pattern2", "pattern1_pattern3"))
})

# 3. Test with a list of 'pattern_pairs'
test_that("List pattern_pairs - specific pairs", {
    # Create sample data
    args <- .create_sample_data()
    # Define specific pattern pairs as a list
    pattern_pairs <- list(c("pattern1", "pattern2"))
    
    # Call the function
    suppressMessages(
    result <- get_pairwise_interacting_genes(data=args$data, 
        spPatterns=args$spPatterns, 
        optParams=args$optParams, 
        pattern_pairs = pattern_pairs, minOverlap = 0)
    )
    # Check the number of results (should be 1)
    expect_equal(length(result), 1)
    
    # Check the names of the results
    expect_equal(names(result), "pattern1_pattern2")
})

# 4. Test with invalid 'pattern_pairs'
test_that("Invalid pattern_pairs - throws error", {
    # Create sample data
    args <- .create_sample_data()
    
    # Define invalid pattern pairs
    pattern_pairs <- matrix(c("pattern1", "invalid_pattern"), ncol = 2)
    
    # Expect an error
    expect_error(result <- get_pairwise_interacting_genes(data=args$data, 
        spPatterns=args$spPatterns, 
        optParams=args$optParams, 
        pattern_pairs = pattern_pairs, minOverlap = 0), "not pattern names")
})

# 5. Test without BiocParallel
test_that("No BiocParallel - sequential execution", {
    # Mock 'requireNamespace' to always return FALSE
    myRequire <- function(...) FALSE
    local_mocked_bindings(requireNamespace = myRequire, .package = "base")
        # Create sample data
        args <- .create_sample_data()
        # Define specific pattern pairs
        pattern_pairs <- rbind(c("pattern1", "pattern2"), 
                                    c("pattern1", "pattern3"))
        
        # Call the function
        suppressMessages(
            result <- get_pairwise_interacting_genes(data=args$data, 
                spPatterns=args$spPatterns, 
                optParams=args$optParams, 
                pattern_pairs = pattern_pairs, minOverlap = 0)
        )
        # Check the number of results (should be 1)
        expect_equal(length(result), 2)
        
        # Check the names of the results
        expect_equal(names(result), c("pattern1_pattern2", 
            "pattern1_pattern3"))
})

#6. Test for single pair of patterns
test_that("Single pair of patterns", {
    # Create sample data
    args <- .create_sample_data()
    # Define specific pattern pairs
    pattern_pairs <- c("pattern1", "pattern2")
    
    # Call the function
    suppressMessages(
    result <- get_pairwise_interacting_genes(data=args$data, 
            spPatterns=args$spPatterns, 
            optParams=args$optParams, 
            pattern_pairs = pattern_pairs, minOverlap = 0)    
    )
    
    # Check the number of results (should be 1)
    expect_equal(length(result), 1)
    
    # Check the names of the results
    expect_equal(names(result), "pattern1_pattern2")
})

test_that("getPairwiseInteractingGenes works with specified hotspots", {
    args <- .create_sample_data()
    spHotspots <- find_all_hotspots(spPatterns = args$spPatterns, params = args$optParams,
        outlier = "positive", nullSamples = 1000, includeSelf = TRUE)

    suppressMessages({
    interactingGenes <- get_pairwise_interacting_genes(
            data=args$data,
            spPatterns=args$spPatterns,
            optParams=args$optParams,
            minOverlap = 0,
            hotspots = spHotspots)})
    expect_true(is.list(interactingGenes))

})

#' @title calculate_overlap_undirected
#' @description Calculate the overlap scores between patterns in hotspots
#' @param hotspots A data frame with columns x, y, barcode and pattern names
#' @param patternList A character vector of pattern names to calculate overlap 
#' scores for
#' @param method The method to calculate overlap scores. Options are
#' "Szymkiewicz-Simpson", "Jaccard", "Sorensen-Dice", "Ochiai" and "absolute"
#' @details The function calculates the overlap scores between patterns hotspots
#' using the specified method. The default method is "Szymkiewicz-Simpson"
#' overlap coefficient.
#' @return A data frame with columns pattern1, pattern2 and overlapScore
#' @export
#' @examples
#' hotspots <- data.frame(x = c(1,2,3,4,5),
#'                         y = c(1,2,3,4,5),
#'                         barcode = c("A","B","C","D","E"),
#'                         pattern1 = c("pattern1",NA,"pattern1",NA,"pattern1"),
#'                         pattern2 = c("pattern2","pattern2",NA,NA,"pattern2"))
#' calculate_overlap_undirected(hotspots)   
#' calculate_overlap_undirected(hotspots, c("pattern1","pattern2"))
#' @importFrom ggplot2 ggplot geom_tile geom_text theme_minimal
#' @importFrom reshape2 melt
#' @importFrom stats complete.cases
calculate_overlap_undirected <- function(hotspots,
                             patternList = NULL, method = c("Szymkiewicz-Simpson",
                                                            "Jaccard", "Sorensen-Dice",
                                                            "Ochiai", "absolute") ) {
    
    #stop if more than one method is supplied, do not warn by default
    if(length(method) > 1){
        method <- method[1]
        message("Only one method can be used at a time. Using ", method)}

    if (is.null(patternList)) {
        patternList <- setdiff(colnames(hotspots),c("x","y","barcode"))
    } else if (!all(patternList %in% colnames(hotspots))) {
        stop("Pattern names not found in hotspots")
    }

    binarized <- (!is.na(hotspots[,patternList]))*1
    intersects <- t(binarized) %*% binarized
    nHotspots <- colSums(binarized)
    nHotsP1 <- t(t(nHotspots)) %*% array(1, length(patternList))
    nHotsP2 <- t(nHotsP1)
    overlapScore <- switch(method,
        "Szymkiewicz-Simpson" = intersects/pmin(nHotsP1,nHotsP2),
        "Jaccard" = intersects/(nHotsP1 + nHotsP2 - intersects),
        "Sorensen-Dice" = 2*intersects/(nHotsP1 + nHotsP2),
        "Ochiai" = intersects/sqrt(nHotsP1*nHotsP2),
        "absolute" = intersects,
        stop("Method not supported")
    )

    overlapScore[upper.tri(overlapScore,diag = TRUE)] <- NA
  
    # Melt normalized Jaccard for output
    dfOverlap <- reshape2::melt(overlapScore)
    dfOverlap <- dfOverlap[stats::complete.cases(dfOverlap),]
    # Due to melting in lower triangular orientation, the column names are flipped
    colnames(dfOverlap) <- c("pattern2", "pattern1", "overlapScore")
    dfOverlap <- dfOverlap[,c(2,1,3)]
    return(dfOverlap)
}

#' @title plot_overlap_scores
#' @description Plot the overlap scores between patterns in hotspots
#' @param df A data frame with columns pattern1, pattern2 and overlapScore
#' @param title The title of the plot
#' @param fontsize The font size of the plot
#' @param out The output path for the plot
#' @return A ggplot object
#' @export
#' @examples
#' df <- data.frame(pattern1 = c("pattern1","pattern1","pattern2","pattern2"), 
#'                  pattern2 = c("pattern1","pattern2","pattern1","pattern2"),
#'                  overlapScore = c(0.5,0.7,0.3,0.9))
#' plot_overlap_scores(df)
#' plot_overlap_scores(df, "Overlap Scores", "overlapScores.png", 15)
#' @import ggplot2
#'
plot_overlap_scores <- function(df, title = "Spatial Overlap Scores", out = NULL,fontsize = 15) {
    p <- ggplot2::ggplot(data = df, aes(pattern1, pattern2, fill = overlapScore)) +
        geom_tile(color = "black", size = 0.8) +
        geom_text(aes(label = round(overlapScore, 2)), size = 6) +  # Display values on the plot
        scale_fill_gradient2(low = "#FFF7EC", mid = "#FDBB84", high = "#D7301F", midpoint = 0.5) +
        scale_y_discrete(limits = rev, guide = guide_axis(angle = 45)) +
        theme_minimal() +
        theme(
            axis.text.x = element_text(angle = 45, vjust = 1, size = fontsize, hjust = 1),
            axis.text.y = element_text(size = fontsize)
        ) +
        coord_fixed() +
        labs(x = NULL, y = NULL, fill = "overlapScore", title = title) +
        theme(
            panel.background = element_blank(),
            panel.grid.major = element_blank(),
            panel.border = element_blank()
        )
    if(!is.null(out)){
        ggplot2::ggsave(filename = out, plot = p)
    }
    return(p)
}

#' @title get_im_scores
#' @description Get the interaction scores for SpaceMarkers
#' @param SpaceMarkers A list of SpaceMarkers objects
#' @return A data frame with columns Gene and SpaceMarkersMetric
#' @export
#' @examples
#' example(get_pairwise_interacting_genes)
#' get_im_scores(SpaceMarkers)
#' @importFrom stats setNames
#' 
get_im_scores <- function(SpaceMarkers){
    smi <- SpaceMarkers[which(sapply(SpaceMarkers, function(x) length(x[['interacting_genes']]))>0)]
    fields <- c('Gene', 'SpaceMarkersMetric')

    imscores <- lapply(seq_along(smi), function(x) {
        df <- smi[[x]][['interacting_genes']][[1]][,fields]
        #rename to metric to its parent item name
        stats::setNames(df, c('Gene', names(smi)[x]))
    })

    imscores <- Reduce(function(x, y) {
                merge(x, y, by="Gene", all=TRUE)
            }, x=imscores, right=FALSE)
    
    if(is.null(imscores)) {
        imscores <- data.frame(Gene=character(0))
    }
    return(imscores)
}


#' @title plot_im_scores
#' @description Plot the top SpaceMarkers IMScores
#' @param df A data frame with columns Gene and SpaceMarkersMetric
#' @param interaction The interaction to plot
#' @param cutOff The cut off value for the plot
#' @param nGenes The number of genes to plot
#' @param geneText The font size for the gene text
#' @param metricText The font size for the metric text
#' @param increments The increments for the y-axis
#' @param out The output path for the plot
#' @export
#' @examples 
#' example(get_pairwise_interacting_genes)
#' plot_im_scores(get_im_scores(SpaceMarkers), "Pattern_1_Pattern_3")
#' @import ggplot2
#' @importFrom stats reorder
#' @importFrom utils head
plot_im_scores <- function(df, interaction, cutOff = 0, nGenes = 20,
    geneText = 12, metricText = 12, increments = 1, out = NULL) {
    df$genes <- df$Gene
    df <- df[order(df[[interaction]], decreasing = TRUE),]
    df <- utils::head(df,nGenes)
    df[[interaction]] <- round(df[[interaction]],2)
    
    p1 <- ggplot2::ggplot(df, ggplot2::aes(x = stats::reorder(Gene,!!sym(interaction)), y = !!sym(interaction))) +
                geom_bar(stat = "identity",
                show.legend = FALSE,
                fill = "blue",      # Background color
                color = "blue") + 
        theme(axis.text.x = element_text(size = metricText, angle=0), axis.text.y = element_text(angle = 0, size = geneText)) +
        xlab("Genes") +
        ylab("SpaceMarkers Metric") +
        ggtitle(interaction) + 
        scale_y_continuous(breaks= seq(0, max(df[[interaction]]),
            by = increments),
            limits = c(0, max(df[[interaction]]) + 0.2)) +
        coord_flip()
    if (!is.null(out)){
        ggplot2::ggsave(filename = out,plot = p1)
    }
    return(p1)
}

#' @title calculate_gene_set_score
#' @description Calculate the mean interaction score for a set of genes
#' @param IMscores A matrix of interaction scores
#' @param gene_sets A list of gene sets, where each set is a vector of gene names
#' @param weighted Logical; if TRUE, gene scores are weighted by their occurrence in multiple gene sets
#' @param method Character; specifies the aggregation method for gene set scores. Options are "geometric_mean" or "arithmetic_mean"
#' @details This function computes mean interaction scores for given gene sets across cell interactions.
#' It supports both geometric and arithmetic means, and can weight gene contributions based on their presence in multiple gene sets.
#' @return A matrix of mean interaction scores for genes in each gene set, with 
#' attributes for log p-value sums and number of genes for later fisher combination
#' @export
calculate_gene_set_score <- function(IMscores, gene_sets, weighted = TRUE, method = c("geometric_mean", "arithmetic_mean")) {
    method <- match.arg(method[1], choices = c("geometric_mean", "arithmetic_mean"))

    IMS <- split(IMscores, IMscores$cell_interaction)

    # Pre-calculate gene overlap counts
    # How many complexes does each gene appear in?
    all_genes <- unique(unlist(gene_sets))
    gene_complex_count <- sapply(all_genes, function(g) {
        sum(sapply(gene_sets, function(gs) g %in% gs))
    })

    scores <- matrix(NA, nrow=length(gene_sets), ncol=length(IMS))
    rownames(scores) <- names(gene_sets)
    colnames(scores) <- names(IMS)

    for (i in seq_along(IMS)) {
        temp <- lapply(gene_sets, function(geneSet) {
            if (length(geneSet) == 0) return(NA)
            ims <- IMS[[i]]
            geneSet <- intersect(geneSet, ims$gene)
            if (length(geneSet) == 0) return(NA)

            subset_data <- ims[ims$gene %in% geneSet,]
            
                        # Calculate uniqueness weight for each gene
            # Weight = 1 / (number of complexes containing this gene)
            if (!weighted) {
                gene_weights <- rep(1, nrow(subset_data))
            } else {
                gene_weights <- 1 / gene_complex_count[subset_data$gene]
                # Normalize weights to sum to number of genes
                # (preserves interpretation of the score)
                gene_weights <- gene_weights * length(gene_weights) / sum(gene_weights)
            }

            # Calculate weighted effect size
            weighted_effect <- switch(method,
                "geometric_mean" = exp(weighted.mean(log(subset_data$effect_size),gene_weights)),
                "arithmetic_mean" = weighted.mean(subset_data$effect_size, gene_weights),
                stop("Unknown method for gene set score calculation")
                )

            weighted_effect

        })
        scores[,i] <- unlist(temp)
    }
    
    scores <- .call(scores, 2, as.numeric)
    colnames(scores) <- names(IMS)
    rownames(scores) <- names(gene_sets)
        # Add gene overlap information as an attribute
    attr(scores, "gene_complex_count") <- gene_complex_count
    
    return(scores)
}


#' @title .pick_image
#' @description The function picks the appropriate histology image file from the
#' spatial directory based on the specified resolution.
#' @param sp_dir path to the spatial directory
#' @param res a character string specifying the resolution of the image
#' @return a character string of the image file name
.pick_image <- function(sp_dir, res) {
  files <- list.files(sp_dir, full.names = TRUE)
  low   <- grep("^tissue_.*lowres.*\\.(png|jpg|jpeg|tif|tiff)$",
                basename(files), ignore.case = TRUE, value = TRUE)
  high  <- grep("^tissue_.*hires.*\\.(png|jpg|jpeg|tif|tiff)$",
                basename(files), ignore.case = TRUE, value = TRUE)
  anyi  <- grep("\\.(png|jpg|jpeg|tif|tiff)$",
                basename(files), ignore.case = TRUE, value = TRUE)
  want <- switch(res,lowres = low,hires  = high,fullres = high)
  if (!length(want)) want <- if (res == "lowres") high else low
  if (!length(want)) want <- anyi
  if (!length(want)) stop("No histology image found in ", sp_dir)
  return(file.path(sp_dir, want[[1]]))
}

#' @title plotSpatialDataOverImage
#' @description This function plots spatial data over the complementary 
#' histology image of varing resolutions
#' @param visiumDir directory with a spatial folder containing 
#' scalefactors_json.json, images (lowres,or hires), and 
#' coordinates (tissue_positons_(list).csv or probe.csv)
#' @param df a dataframe with the features of interest. For example,
#' can behotspots (character), and/or influence (numeric))
#' @param feature_col feature to plot over spots, Default: NULL
#' @param barcode_col barcode column name to match with coordinates,
#' Default: 'barcode'
#' @param resolution Image resoultion to scale coordinates too, 
#' Default: c("lowres", "hires", "fullres")
#' @param version Visium version. Automatically infers from load10XCoords if 
#' NULL,Default: NULL
#' @param colors colors to be displayed over spots. If set to NULL, it
#' automatically colors the spots red for character values and uses viridis for 
#' numeric values. Default: NULL
#' @param point_size size of spots displayed on the plot, Default: 2.5
#' @param stroke thickness of spot outline, Default: 0.05
#' @param alpha Transparency of the spots, Default: 0.5
#' @param title Title displayed on the plot, Default: 'Spatial Heatmap'
#' @param bg_color background color of ggplot box, Default: NULL
#' @param crop crop spatial plot to a zoomed in window, Default: TRUE
#' @param text_size size of text on the plot, Default: 15
#' @return a ggplot object
#
#' @export 
#' @importFrom rlang sym
#' @importFrom SpaceMarkers load10XCoords
#' @importFrom readbitmap read.bitmap
#' @importFrom viridis scale_fill_viridis
#' @importFrom stats na.omit setNames
#' @importFrom RColorBrewer brewer.pal
#' @importFrom ggplot2 scale_fill_gradientn ggplot annotation_raster 
#' geom_point aes coord_fixed labs theme_bw theme element_rect element_blank
#' @importFrom dplyr mutate rename

plot_spatial_data_over_image <- function(
    visiumDir, df, feature_col, barcode_col="barcode",
    resolution=c("lowres","hires","fullres"), version=NULL, colors=NULL,
    point_size=2.5, stroke=0.05, alpha=0.5, title="Spatial Heatmap",
    bg_color=NULL, crop=TRUE, text_size = 15) {
  resolution <- match.arg(resolution)
  if (is.null(barcode_col)) {
    if (!is.null(rownames(df))) df$barcode <- rownames(df) else
      stop("barcode_col is NULL and df has no rownames.")
  } else if (barcode_col != "barcode") 
    df <- dplyr::rename(
    df, barcode = !!rlang::sym(barcode_col))
  pos <- SpaceMarkers::load10XCoords(visiumDir, resolution, version)
  names(pos) <- c("barcode","y","x"); df <- merge(
    df[, c("barcode", feature_col)], pos, by="barcode")
  img <- readbitmap::read.bitmap(.pick_image(
    file.path(visiumDir, "spatial"), resolution))
  if (crop) {xr <- range(df$x, na.rm=TRUE); yr <- range(df$y, na.rm=TRUE)
  xmin <- max(1L, floor(xr[1])); xmax <- min(ncol(img), ceiling(xr[2]))
  ymin <- max(1L, floor(yr[1])); ymax <- min(nrow(img), ceiling(yr[2]))
  img <- img[ymin:ymax, xmin:xmax,, drop=FALSE]
  df <- dplyr::mutate(df, x_c=x-xmin+1L, y_c=y-ymin+1L)
  xl <- c(0, xmax-xmin+1L); yl <- c(0, ymax-ymin+1L)
  } else {
    df <- dplyr::mutate(df, x_c=x, y_c=y);xl<-c(0, ncol(img));yl<-c(0, nrow(img))}
    p <- ggplot2::ggplot() +
      ggplot2::annotation_raster(as.raster(img), 0, diff(xl), 0, diff(yl)) +
      ggplot2::geom_point(
        data = df,
        ggplot2::aes(x_c, yl[2] - y_c, fill = .data[[feature_col]]),
        shape = 21, color = "black", size = point_size,
        stroke = stroke, alpha = alpha
      ) +
      ggplot2::coord_fixed(xlim = xl, ylim = yl, expand = FALSE) +
      ggplot2::labs(fill = feature_col, x = NULL, y = NULL, title = title) +
      ggplot2::theme_bw(text_size) +
      ggplot2::theme(
        plot.background = if (!is.null(bg_color))
          ggplot2::element_rect(fill = bg_color, color = NA)
        else ggplot2::element_blank()
      )
  if (is.numeric(df[[feature_col]])) {
    p <- p + (if (!is.null(colors)) ggplot2::scale_fill_gradientn(colours=colors)
              else viridis::scale_fill_viridis())
  } else {
    vals <- unique(stats::na.omit(df[[feature_col]]))
    p <- p + if (!is.null(colors)) ggplot2::scale_fill_manual(values=colors) else
      if (length(vals) > 1) ggplot2::scale_fill_manual(values = stats::setNames(
        RColorBrewer::brewer.pal(max(3, min(length(vals), 9)), "Set1")
        [seq_along(vals)], vals)) else ggplot2::scale_fill_manual(values="red")
  }
  return(p)
}



#' @title calculate_lr_scores
#' @description Calculate L-R pair scores using Fisher's method
#' @param ligand_scores Output from getGeneSetScore for ligands
#' @param receptor_scores Output from getGeneSetScore for receptors
#' @param lr_pairs Data frame with columns 'ligand' and 'receptor'
#' @param ligand_test Character; specifies the type of test for ligand overexpression. Options are "greater" or "two.sided"
#' @param method Character; specifies the aggregation method for L-R scores. Options are "
#' geometric_mean" or "arithmetic_mean"
#' @param weighted Logical; if TRUE, L-R scores are weighted by their occurrence in
#' multiple L-R pairs
#' @details This function computes L-R pair scores by combining ligand and receptor
#' overexpression scores using either geometric or arithmetic mean. It can also
#' weight L-R pairs based on their presence in multiple pairs to reduce bias from
#' promiscuous ligands or receptors.
#' @return Data frame with L-R scores and p-values
#' @export
calculate_lr_scores <- function(ligand_scores, receptor_scores, lr_pairs,
                              ligand_test = c("greater", "two.sided"), method = c("geometric_mean", "arithmetic_mean"),
                              weighted = TRUE) {

    method <- match.arg(method[1], choices = c("geometric_mean", "arithmetic_mean"))
       # parameter checks
    ligand_test <- match.arg(ligand_test[1], choices = c("greater", "two.sided"))
    
    ## Scoring ligand overexpression near target cell type and receptor overexpression in target cell type
    if (!all(grepl("near",colnames(receptor_scores)))) {
        target_cells <- gsub("^.*_","",colnames(ligand_scores))
        if (!any(target_cells %in% colnames(receptor_scores))) {
            stop("Receptor scores do not have expected cell type names in column names.")
        }
        ligand_cols <- colnames(ligand_scores)[grepl(paste0("near_(", paste(target_cells, collapse="|"), ")"), colnames(ligand_scores))]
        names(ligand_cols) <- ligand_cols
        # Map ligand columns to receptor columns
        mapped_receptor_cols <- sapply(ligand_cols, function(lc) gsub("^.*_","",lc))
        names(mapped_receptor_cols) <- ligand_cols
        lr_scores <- matrix(0, nrow=nrow(lr_pairs), ncol=length(ligand_cols))
        if (weighted) {
            ligand_counts <- table(lr_pairs$ligand.symbol)
            receptor_counts <- table(lr_pairs$receptor.symbol)
            ligand_weights <- 1 / ligand_counts[lr_pairs$ligand.symbol]
            receptor_weights <- 1 / receptor_counts[lr_pairs$receptor.symbol]
            ligand_weights <- matrix(ligand_weights * length(ligand_weights) / sum(ligand_weights), nrow=nrow(lr_pairs), ncol=1)
            receptor_weights <- matrix(receptor_weights * length(receptor_weights) / sum(receptor_weights), nrow=nrow(lr_pairs), ncol=1)
            rownames(ligand_weights) <- rownames(receptor_weights) <- rownames(lr_pairs)
            weights <- cbind(ligand_weights, receptor_weights)
            colnames(weights) <- c("ligand_weights", "receptor_weights")
            rownames(weights) <- rownames(lr_pairs)
        } else {
            weights <- matrix(1, nrow=nrow(lr_pairs), ncol=2)
            colnames(weights) <- c("ligand_weights", "receptor_weights")
            rownames(weights) <- rownames(lr_pairs)
        }

        lr_scores <- matrix(NA, nrow=nrow(lr_pairs), ncol=length(ligand_cols))
        rownames(lr_scores) <- rownames(lr_pairs)
        mapped_lr_cols <- gsub("near_","to_",ligand_cols)
        names(mapped_lr_cols) <- ligand_cols
        colnames(lr_scores) <- mapped_lr_cols
            
        for (i in seq_along(ligand_cols)) {
            lc <- ligand_cols[i]
            rc <- mapped_receptor_cols[i]
            scores <- cbind(ligand_scores[,lc], receptor_scores[,rc])
            colnames(scores) <- c("ligand_score", "receptor_score")
            rownames(scores) <- rownames(lr_pairs)
            lr_scores[,i] <- switch(method,
                "geometric_mean" = exp(sapply(rownames(scores), function(r) {weighted.mean(log(scores[r, ]), w=weights[r,])})),
                "arithmetic_mean" = sapply(rownames(scores), function(r) {weighted.mean(scores[r, ], w=weights[r,])}),
                stop("Unknown method for L-R score calculation")
            )
        }
        colnames(lr_scores) <- mapped_lr_cols
        rownames(lr_scores) <- rownames(lr_pairs)
        return(lr_scores)
    } else {
        stop("Receptor scores have been calculated using calculate_gene_set_score (overexpression) of receptors near source cell; use calculate_gene_set_specificity for receptors instead.")
    }

}

#' Calculate Gene Set Specificity Scores
#' @title calculate_gene_set_specificity
#' @description
#' This function computes specificity scores for given gene sets across cell types or spatial patterns.
#' It uses fold-change scores and p-values to weight gene contributions, and supports both geometric and arithmetic means.
#'
#' @param data A numeric matrix or data frame of gene expression values (genes x samples).
#' @param spPatterns A data frame or matrix containing spatial pattern information, with columns for cell types and optionally "x", "y", "barcode".
#' @param gene_sets A named list of character vectors, where each vector contains gene names for a gene set.
#' @param weighted Logical; if TRUE, gene scores are weighted by their occurrence in multiple gene sets.
#' @param method Character; specifies the aggregation method for gene set scores. Options are "geometric_mean" or "arithmetic_mean".
#'
#' @return A numeric matrix of gene set specificity scores (gene sets x cell types).
#'
#' @details
#' - Genes not present in the data are excluded.
#' - Genes with all zero expression are removed.
#' - Fold-change scores and p-values are calculated using `.calculate_all_fc_scores`.
#' - Scores are normalized and weighted by p-value significance.
#' - For each gene set, scores are aggregated using the specified method and gene weights.
#'
#' @examples
#' # Example usage:
#' # gene_set_scores <- calculate_gene_set_specificity(expr_matrix, spPatterns, gene_sets)
#'
#' @export
calculate_gene_set_specificity <- function(data, spPatterns, gene_sets, weighted = TRUE, method = c("geometric_mean", "arithmetic_mean")) {
    method <- match.arg(method[1], choices = c("geometric_mean", "arithmetic_mean"))
    genes <- unique(unlist(gene_sets))
    genes <- intersect(genes, rownames(data))
    if (length(genes) == 0) {
        stop("No genes from gene sets found in data")
    }
    expr <- data[genes, , drop = FALSE]
    expr[is.na(expr)] <- 0

    expr <- expr[apply(expr, 1, function(x) any(x > 0)), , drop = FALSE]
    
    genes <- rownames(expr)

    gene_complex_count <- sapply(genes, function(g) {
        sum(sapply(gene_sets, function(gs) g %in% gs))
    })
    if (weighted) {
        gene_weights <- 1 / gene_complex_count[genes]
            # (preserves interpretation of the score)
        gene_weights <- gene_weights * length(gene_weights) / sum(gene_weights)
    } else {
        gene_weights <- rep(1, length(genes))
    }
    names(gene_weights) <- genes
            # (preserves interpretation of the score)

    if (nrow(expr) == 0) {
        return(matrix(0, nrow=length(gene_sets), ncol=ncol(spPatterns)))
    }

    # Group by cell type
    patnames <- setdiff(colnames(spPatterns),c("x","y","barcode"))
    cell_types <- unique(patnames)

    # Initialize result matrix
    gene_set_scores <- matrix(0, nrow = length(gene_sets), ncol = length(cell_types))
    rownames(gene_set_scores) <- names(gene_sets)
    colnames(gene_set_scores) <- cell_types

    gene_scores <- .calculate_all_fc_scores(expr, spPatterns, low_thr = 0.2, high_thr = 0.8)


    for (gene_set in names(gene_sets)) {
        genes <- gene_sets[[gene_set]]
        valid_genes <- intersect(genes, rownames(gene_scores))
        if (length(valid_genes) > 1) {
            
            # Calculate weighted scores
            gene_set_scores[gene_set, ] <- switch(method,
                "geometric_mean" = exp(apply(log(gene_scores[valid_genes, ]), 2, weighted.mean, w = gene_weights[valid_genes])),
                "arithmetic_mean" = apply(gene_scores[valid_genes, ], 2, weighted.mean, w = gene_weights[valid_genes]),
                stop("Unknown method for gene set score calculation")
            )
        } else if (length(valid_genes) == 1) {
        gene_set_scores[gene_set, ] <- gene_scores[valid_genes, ]
        } else {
        gene_set_scores[gene_set, ] <- 0
        }
    }

    return(gene_set_scores)
}

.calculate_fc_score <- function(expr, spPatterns, gene, ct,
                              low_thr = 0.2, high_thr = 0.8) {

  # Get thresholds
  low_thr <- quantile(spPatterns[, ct], probs = low_thr, na.rm = TRUE)
  high_thr <- quantile(spPatterns[, ct], probs = high_thr, na.rm = TRUE)

  # Get high and low bins
  high_bins <- which(spPatterns[, ct] > high_thr)
  low_bins <- which(spPatterns[, ct] < low_thr)
  
  # Calculate means
  mean_high <- mean(expr[gene, high_bins])
  mean_low <- mean(expr[gene, low_bins])
  
  # Log fold change
  lfc <- mean_high - mean_low
  
  # Get p-value
  if (all(expr[gene, c(high_bins, low_bins)] == 0)) {
    score <- NA
    attr(score, "p_value") <- 1
    return(score)
  }
  w_test <- wilcox.test(as.matrix(expr[gene, high_bins]), as.matrix(expr[gene, low_bins]))

  score <- lfc
  attr(score, "p_value") <- w_test$p.value
  return(score)
}

# Wrapper for all genes and cell types
# importFrom BiocParallel bplapply
.calculate_all_fc_scores <- function(expr, spPatterns, 
                                    low_thr = 0.2, high_thr = 0.9, ..., workers = NULL) {

  genes <- rownames(expr)
  cell_types <- setdiff(colnames(spPatterns), c("x", "y", "barcode"))
  
  # Initialize results
  score_matrix <- matrix(NA, nrow = length(genes), ncol = length(cell_types))
  rownames(score_matrix) <- genes
  colnames(score_matrix) <- cell_types
  
  gene_scores <- lfc_matrix <- p_values <- score_matrix
  use_biocparallel <- requireNamespace("BiocParallel", quietly = TRUE)
  # Calculate for each combination
  if (!use_biocparallel) {
    for (i in seq_along(genes)) {
        for (ct in cell_types) {
            result <- .calculate_fc_score(expr, spPatterns, 
                                    genes[i], ct,
                                    low_thr, high_thr)
            lfc_matrix[i, ct] <- result
            p_values[i, ct] <- attr(result, "p_value")
        }
    }
  } else {
    if (is.null(workers) || workers < 1) {
        workers <- BiocParallel::bpworkers(BiocParallel::bpparam())
    }
    BiocParallel::register(BiocParallel::MulticoreParam(workers))
    lfc <- BiocParallel::bplapply(cell_types, function(ct) {
        lfc_col <- p_val_col <- numeric(length(genes))
        names(lfc_col) <- names(p_val_col) <- genes
        for (i in seq_along(genes)) {
            result <- .calculate_fc_score(expr, spPatterns, 
                                genes[i], ct,
                                low_thr, high_thr)
            lfc_col[i] <- result
            p_val_col[i] <- attr(result, "p_value")
        }
        return(list(lfc = lfc_col, p_value = p_val_col))
    })
    for (i in seq_along(cell_types)) {
        ct <- cell_types[i]
        lfc_matrix[, ct] <- lfc[[i]]$lfc
        p_values[, ct] <- lfc[[i]]$p_value
    }
  }
    p_adj <- apply(p_values,2,p.adjust,method="BH")
    p_weights <- 1 / (1 + exp(2 * (log10(p_adj) - log10(0.05))))

    norm_scores <- 1/(1 + exp(-40 * (lfc_matrix-median(lfc_matrix[lfc_matrix>0], na.rm = TRUE))))
    gene_scores <- norm_scores * p_weights
    gene_scores[is.na(gene_scores)] <- 0
    attr(gene_scores,"p_values") <- p_values
    attr(gene_scores,"p_adj") <- p_adj
    attr(gene_scores,"p_weights") <- p_weights
    attr(gene_scores,"lfc") <- lfc_matrix
  return(gene_scores)
}

.call <- function(x, MARGIN = NULL, FUN, ...) {
    # Save attributes
    saved_attrs <- attributes(x)

    # Apply function
    if (is.null(MARGIN)) {
        result <- FUN(x, ...)
    } else {
        result <- apply(x, MARGIN, FUN, ...)
    }

    # Restore custom attributes
    for (attr_name in names(saved_attrs)) {
        attr(result, attr_name) <- saved_attrs[[attr_name]]
    }
    
    return(result)
}

test_that("getOverlapScores works correctly", {
    # Create a sample hotspots data frame
    hotspots <- data.frame(
        x = c(1, 2, 3, 4, 5),
        y = c(1, 2, 3, 4, 5),
        barcode = c("A", "B", "C", "D", "E"),
        pattern1 = c("pattern1", NA, "pattern1", NA, "pattern1"),
        pattern2 = c("pattern2", "pattern2", NA, "pattern2", "pattern2")
    )
    
    # Test default method (Szymkiewicz–Simpson)
    result <- calculate_overlap_undirected(hotspots)
    expect_equal(nrow(result), 1)
    expect_equal(as.character(result$pattern1), "pattern1")
    expect_equal(as.character(result$pattern2), "pattern2")
    expect_equal(result$overlapScore, 0.6666667,
                 tolerance = 1e-7) 
    # Test Jaccard method
    result_jaccard <- calculate_overlap_undirected(hotspots, method = "Jaccard")
    expect_equal(nrow(result_jaccard), 1)
    expect_equal(result_jaccard$overlapScore, 0.4)
    # Test Sørensen–Dice method
    result_sorensen <- calculate_overlap_undirected(hotspots, method = "Sorensen-Dice")
    expect_equal(nrow(result_sorensen), 1)
    expect_equal(result_sorensen$overlapScore, 0.5714286,
                 tolerance = 1e-7)
    # Test Ochiai method
    result_ochiai <- calculate_overlap_undirected(hotspots, method = "Ochiai")
    expect_equal(nrow(result_ochiai), 1)
    expect_equal(result_ochiai$overlapScore, 0.5773503,
                 tolerance = 1e-7)
    # Test absolute method
    result_absolute <- calculate_overlap_undirected(hotspots, method = "absolute")
    expect_equal(nrow(result_absolute), 1)
    expect_equal(result_absolute$overlapScore, 2)

    # Test with patternList
    result_patternList <- calculate_overlap_undirected(hotspots, patternList = c("pattern1", "pattern2"))
    expect_equal(nrow(result_patternList), 1)
    expect_equal(as.character(result_patternList$pattern1), "pattern1")
    expect_equal(as.character(result_patternList$pattern2), "pattern2")
    expect_equal(result_patternList$overlapScore, 0.6666667,
                 tolerance = 1e-7)

    # Test invalid pattern names
    expect_error(calculate_overlap_undirected(hotspots, patternList = c("invalidPattern")))

    # Test with multiple patterns
    hotspots$pattern3 <- c(NA, "pattern3", "pattern3", NA, NA)
    result_multiple <- calculate_overlap_undirected(hotspots, patternList = c("pattern1", "pattern2", "pattern3"))
    expect_true(nrow(result_multiple) > 1)

    # Test with multiple methods
    expect_message(calculate_overlap_undirected(hotspots, method = c("Jaccard", "absolute")),"Only one method")

})

## ----global.options, include = FALSE------------------------------------------
knitr::opts_knit$set(
    collapse = TRUE,
    comment = "#>",
    fig.align   = 'center'
)

knitr::opts_chunk$set(out.extra = 'style="display:block; margin:auto;"')


## ----eval = FALSE-------------------------------------------------------------
# if (!require("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# 
# BiocManager::install("SpaceMarkers")

## ----message = FALSE, warning = FALSE-----------------------------------------
library(SpaceMarkers)

## -----------------------------------------------------------------------------
data_dir <- "visiumBrCA"
unlink(file.path(data_dir), recursive = TRUE)
dir.create(data_dir,showWarnings = FALSE)
main_10xlink <- "https://cf.10xgenomics.com/samples/spatial-exp/1.3.0"
counts_folder <- "Visium_Human_Breast_Cancer"
counts_file <- "Visium_Human_Breast_Cancer_filtered_feature_bc_matrix.h5"
counts_url<-paste(c(main_10xlink,counts_folder,counts_file), collapse = "/")
sp_folder <- "Visium_Human_Breast_Cancer"
sp_file <- "Visium_Human_Breast_Cancer_spatial.tar.gz"
sp_url<-paste(c(main_10xlink,sp_folder,sp_file),collapse = "/")

## -----------------------------------------------------------------------------
download.file(counts_url,file.path(data_dir,basename(counts_url)), mode = "wb")
counts_matrix <- load10XExpr(visiumDir = data_dir, h5filename = counts_file)
good_gene_threshold <- 3
goodGenes <- rownames(counts_matrix)[
    apply(counts_matrix,1,function(x) sum(x>0)>=good_gene_threshold)]
counts_matrix <- counts_matrix[goodGenes,]

## -----------------------------------------------------------------------------
cogaps_result <- readRDS(system.file("extdata","CoGAPS_result.rds",
    package="SpaceMarkers",mustWork = TRUE))
features <- intersect(rownames(counts_matrix),rownames(
    slot(cogaps_result,"featureLoadings")))
barcodes <- intersect(colnames(counts_matrix),rownames(
    slot(cogaps_result,"sampleFactors")))
counts_matrix <- counts_matrix[features,barcodes]
cogaps_matrix<-slot(cogaps_result,"featureLoadings")[features,]%*%
    t(slot(cogaps_result,"sampleFactors")[barcodes,])

## -----------------------------------------------------------------------------
download.file(sp_url, file.path(data_dir,basename(sp_url)), mode = "wb")
untar(file.path(data_dir,basename(sp_url)), exdir = file.path(data_dir))
spCoords <- load10XCoords(visiumDir = data_dir, 
                          resolution="lowres", version = "1.0")
rownames(spCoords) <- spCoords$barcode
spCoords <- spCoords[barcodes,]
spPatterns <- cbind(spCoords,slot(cogaps_result,"sampleFactors")[barcodes,])
head(spPatterns)

## -----------------------------------------------------------------------------
data("curated_genes")
spPatterns <- spPatterns[c("barcode","y","x","Pattern_1","Pattern_5")]
counts_matrix <- counts_matrix[curated_genes,]
cogaps_matrix <- cogaps_matrix[curated_genes, ]

## -----------------------------------------------------------------------------
optParams <- get_spatial_params_morans_i(spPatterns,visiumDir = data_dir,
                                          resolution = "lowres")

## -----------------------------------------------------------------------------
SpaceMarkers <- get_pairwise_interacting_genes(data = counts_matrix,
                                    reconstruction = cogaps_matrix,
                                    optParams = optParams,
                                    spPatterns = spPatterns,
                                    mode ="residual",analysis="overlap")


## -----------------------------------------------------------------------------
print(head(SpaceMarkers[[1]]$interacting_genes[[1]]))
print(head(SpaceMarkers[[1]]$hotspots))

## -----------------------------------------------------------------------------
SpaceMarkers_DE <- get_pairwise_interacting_genes(
    data=counts_matrix,reconstruction=NULL,
    optParams = optParams,
    spPatterns = spPatterns,
    mode="DE",analysis="overlap")

## -----------------------------------------------------------------------------
residual_p1_p5<-SpaceMarkers[[1]]$interacting_genes[[1]]
DE_p1_p5<-SpaceMarkers_DE[[1]]$interacting_genes[[1]]

## -----------------------------------------------------------------------------
paste(
    "Residual mode identified",dim(residual_p1_p5)[1],
        "interacting genes,while DE mode identified",dim(DE_p1_p5)[1],
        "interacting genes",collapse = NULL)

## -----------------------------------------------------------------------------

compare_genes <- function(ref_list, list2,ref_name = "mode1",
                            list2_name = "mode2", sub_slice = NULL){
    ref_rank <- seq(1,length(ref_list),1)
    list2_ref_rank <- which(list2 %in% ref_list)
    list2_ref_genes <- list2[which(list2 %in% ref_list)]
    ref_genes_only <- ref_list[ !ref_list  %in% list2_ref_genes ]
    mode1 <- data.frame("Gene" = ref_list,"Rank" = ref_rank,"mode"= ref_name)
    mode2 <- data.frame("Gene" = c(list2_ref_genes, ref_genes_only),"Rank" = c(
        list2_ref_rank,rep(NA,length(ref_genes_only))),"mode"= list2_name)
    mode1_mode2 <- merge(mode1, mode2, by = "Gene", all = TRUE) 
    mode1_mode2 <- mode1_mode2[order(mode1_mode2$Rank.x),]
    mode1_mode2 <- subset(mode1_mode2,select = c("Gene","Rank.x","Rank.y"))
    colnames(mode1_mode2) <- c("Gene",paste0(ref_name,"_Rank"),
                                paste0(list2_name,"_Rank"))
    return(mode1_mode2)
}

## -----------------------------------------------------------------------------
res_to_DE <- compare_genes(head(residual_p1_p5$Gene, n = 20),DE_p1_p5$Gene,
                            ref_name="residual",list2_name="DE")
DE_to_res <- compare_genes(head(DE_p1_p5$Gene, n = 20),residual_p1_p5$Gene,
                            ref_name = "DE",list2_name = "residual")

## -----------------------------------------------------------------------------
res_to_DE

## -----------------------------------------------------------------------------
DE_to_res

## -----------------------------------------------------------------------------
SpaceMarkers_enrich <- get_pairwise_interacting_genes(data = counts_matrix,
                                    reconstruction = cogaps_matrix,
                                    optParams = optParams,
                                    spPatterns = spPatterns,
                                    mode ="residual",analysis="enrichment")
SpaceMarkers_DE_enrich <- get_pairwise_interacting_genes(
    data=counts_matrix,reconstruction=NULL,
    optParams = optParams,
    spPatterns = spPatterns,
    mode="DE",analysis="enrichment")
residual_p1_p5_enrichment<-SpaceMarkers_enrich[[1]]$interacting_genes[[1]]$Gene
DE_p1_p5_enrichment<-SpaceMarkers_DE_enrich[[1]]$interacting_genes[[1]]$Gene


## -----------------------------------------------------------------------------
enrich_res_to_de<-compare_genes(
    head(DE_p1_p5_enrichment, 20),
    residual_p1_p5_enrichment,
    ref_name="DE_Enrich",list2_name = "res_Enrich")
enrich_res_to_de

## -----------------------------------------------------------------------------
overlap_enrich_de<-compare_genes(
    head(DE_p1_p5_enrichment,20),
    DE_p1_p5$Gene,
    ref_name="DE_Enrich",
    list2_name="DE_Overlap")
overlap_enrich_de

## -----------------------------------------------------------------------------
tail(SpaceMarkers_DE_enrich[[1]]$interacting_genes[[1]])

## -----------------------------------------------------------------------------
overlap_enrich_res<-compare_genes(
    head(residual_p1_p5$Gene, 20),
    residual_p1_p5_enrichment,
    ref_name ="res_overlap",list2_name="res_enrich")
overlap_enrich_res

## ----message = FALSE, warning=FALSE-------------------------------------------
library(Matrix)
library(rjson)
library(cowplot)
library(RColorBrewer)
library(grid)
library(readbitmap)
library(dplyr)
library(data.table)
library(viridis)
library(ggplot2)

## -----------------------------------------------------------------------------
res_enrich <- SpaceMarkers_enrich[[1]]$interacting_genes[[1]]
hotspots <- SpaceMarkers_enrich[[1]]$hotspots
top <- res_enrich %>% arrange(-SpaceMarkersMetric)
print(head(top))

## -----------------------------------------------------------------------------
createInteractCol <- function(spHotspots, 
                              interaction_cols = c("T.cells","B-cells")){
  col1 <- spHotspots[,interaction_cols[1]]
  col2 <- spHotspots[,interaction_cols[2]]
  one <- col1
  two <- col2
  one[!is.na(col1)] <- "match"
  two[!is.na(col2)] <- "match"
  both_idx <- which(one == two)
  both <- col1
  both[both_idx] <- "interacting"
  one_only <- setdiff(which(!is.na(col1)),unique(c(which(is.na(col1)),
                                                   both_idx)))
  two_only <- setdiff(which(!is.na(col2)),unique(c(which(is.na(col2)),
                                                   both_idx)))
  both[one_only] <- interaction_cols[1]
  both[two_only] <- interaction_cols[2]
  both <- factor(both,levels = c(interaction_cols[1],"interacting",
                                 interaction_cols[2]))
  return(both)
}

#NB: Since we are likely to plot multipe genes, this function assumes an
#already transposed counts matrix. This saves time and memory in the long run
#for larger counts matrices
plotSpatialExpr <- function(data,gene,hotspots,patterns,
                               remove.na = TRUE,
                               title = "Expression (Log)", text_size = 15){
  counts <- data
  interact <- createInteractCol(spHotspots = hotspots,
                                interaction_cols = patterns)
  df <- cbind(counts,hotspots,data.frame("region" = interact))
  if (remove.na){
    df <- df[!is.na(df$region),]
  }
  p <- df %>% ggplot( aes_string(x='region',y=gene,
                                            fill='region')) + geom_violin() +
    scale_fill_viridis(discrete = TRUE,alpha=0.6) +
    geom_jitter(color="black",size=0.4,alpha=0.9) +
    theme(legend.position="none",plot.title = element_text(size=text_size),
            axis.text.x = element_text(angle = 90, vjust = 0.5, hjust=1)) +
    ggtitle(paste0(gene,": ",title)) + xlab("")
  return(p)
}




## -----------------------------------------------------------------------------
genes <- top$Gene
counts_df <- as.data.frame(as.matrix(
  t(counts_matrix[rownames(counts_matrix) %in% genes,])))


## ----suppressMessages=TRUE, warning=FALSE-------------------------------------
spatialMaps <- list()
exprPlots <- list()

for (g in genes){
  
    spatialMaps[[length(spatialMaps)+1]] <- suppressMessages(
        plot_spatial_data_over_image(visiumDir = data_dir,
                                                         df = cbind(spPatterns, counts_df),feature_col = g,
                                                         resolution="lowres",title = g))
  exprPlots[[length(exprPlots)+1]] <- plotSpatialExpr(
    data = counts_df,gene = g,hotspots = hotspots,
                   patterns = c("Pattern_1","Pattern_5"))
}

## ----message=FALSE, warning=FALSE, dpi=60, fig.width=6------------------------

plot_spatial_data_over_image(visiumDir = data_dir,
                         df = cbind(spPatterns, counts_df),
                         feature_col = "Pattern_1",
                         resolution="lowres",title = "Pattern_1")

## ----message=FALSE, warning=FALSE, dpi=60, fig.width=6------------------------


plot_spatial_data_over_image(visiumDir = data_dir,
                         df = cbind(spPatterns, counts_df),
                         feature_col = "Pattern_5",
                         resolution="lowres",title = "Pattern_5")


## ----message=FALSE, warning=FALSE, dpi=60, fig.width=6------------------------
plot_grid(plotlist = list(exprPlots[[1]],spatialMaps[[1]]))


## ----message=FALSE,dpi=60, fig.width=6----------------------------------------
plot_grid(plotlist = list(exprPlots[[3]],spatialMaps[[3]]))

## -----------------------------------------------------------------------------
bottom <- res_enrich %>% arrange(SpaceMarkersMetric)
print(head(bottom))

## ----warning=FALSE------------------------------------------------------------
g <- bottom$Gene[1]
p1 <- plotSpatialExpr(
    data = counts_df,gene = g,hotspots = hotspots, 
                   patterns = c("Pattern_1","Pattern_5"))
p2 <- plot_spatial_data_over_image(visiumDir = data_dir,
                         df = cbind(spPatterns, counts_df),
                         feature_col = g,
                         resolution="lowres",title = g)

plot_grid(plotlist = list(p1,p2))


## -----------------------------------------------------------------------------
unlink(file.path(data_dir), recursive = TRUE)

## ----echo=FALSE---------------------------------------------------------------
parameters = c('visiumDir', 'h5filename')
paramDescript = c('A string path to the h5 file with expression information',
                    'A string of the name of the h5 file in the directory')
paramTable = data.frame(parameters, paramDescript)
knitr::kable(paramTable, col.names = c("Argument","Description"))


## ----echo=FALSE---------------------------------------------------------------
parameters = c('visiumDir', 'resolution')
paramDescript = c(
'A path to the location of the the spatial coordinates folder.',
'String values to look for in the .json object;lowres or highres.')
paramTable = data.frame(parameters, paramDescript)
knitr::kable(paramTable, col.names = c("Argument","Description"))


## ----echo=FALSE---------------------------------------------------------------
parameters = c('spPatterns','visiumDir','spatialDir','pattern','sigma',
               'threshold','resolution')
paramDescript = c('A data frame of spatial coordinates and patterns.',
                  'A directory with the spatial and expression data for 
                  the tissue sample',
                  'A directory with spatial data for the tissue sample',
                  'A string of the .json filename with the image parameters',
                  'A numeric value specifying the kernel distribution width',
                  'A numeric value specifying the outlier threshold for the 
                  kernel',
                  'A string specifying the image resolution to scale')
paramTable = data.frame(parameters, paramDescript)
knitr::kable(paramTable, col.names = c("Argument","Description"))


## ----echo=FALSE---------------------------------------------------------------
parameters = c(
        'data','reconstruction', 'optParams','spPatterns',
        'mode', 'minOverlap','hotspotRegions','analysis')
paramDescript = c(
        'An expression matrix of genes and columns being the samples.',
        'Latent feature matrix. NULL if \'DE\' mode is specified',
        'A matrix of sigmaOpts (width) and the thresOpt (outlierthreshold)',
        'A data frame that contains of spatial coordinates and patterns.',
        'A string of the reference pattern for comparison to other patterns',
        'A string specifying either \'residual\' or \'DE\' mode.',
        'A value that specifies the minimum pattern overlap. 50 is the default',
        'A string specifying the type of analysis')
paramTable = data.frame(parameters, paramDescript)
knitr::kable(paramTable, col.names = c("Argument","Description"))


## -----------------------------------------------------------------------------
sessionInfo()

#' @importFrom hdf5r h5file
#' @importFrom jsonlite read_json
#' @importFrom nanoparquet read_parquet
#' @importFrom utils read.csv
#' @importFrom Matrix sparseMatrix
#' @importFrom methods slot
#import description end
0

## author: Atul Deshpande
## email: adeshpande@jhu.edu

#
#===================
#' @title Load 10X Visium Expression Data
#' @description This loads log-transformed 10X Visium expression data from
#'  standard 10X 
#' Visium folder.
#' @export
#' @param visiumDir  A string path to the h5 file with expression information.
#' @param h5filename  A string of the name of the h5 file in the directory.
#' @return A matrix of class dgeMatrix or Matrix that contains the expression 
#' info for each sample (cells) across multiple features (genes)
#' @examples
#' library(SpaceMarkers)
#' #Visium data links
#' urls <- read.csv(system.file("extdata","visium_data.txt",
#' package = "SpaceMarkers",mustWork = TRUE))
#' counts_url <- urls[["visium_url"]][1]
#' #Remove present Directories if any
#' files <- list.files(".")[grepl(basename(counts_url),list.files("."))]
#' unlink(files)
#' download.file(counts_url,basename(counts_url), mode = "wb")
#' counts_matrix<-load10XExpr(visiumDir=".",h5filename = basename(counts_url))
#' files <- list.files(".")[grepl(basename(counts_url),list.files("."))]
#' unlink(files)
#' 

load10XExpr<- function(visiumDir=NULL,
                       h5filename='filtered_feature_bc_matrix.h5'){
  
    h5FilePath <- dir(path = visiumDir,pattern = h5filename,full.names = TRUE)
    hf <- hdf5r::h5file(filename = h5FilePath, mode='r')
    mat <- names(hf)
    counts <- hf[[paste0(mat, '/data')]]
    indices <- hf[[paste0(mat, '/indices')]]
    indptr <- hf[[paste0(mat, '/indptr')]]
    shp <- hf[[paste0(mat, '/shape')]]
    features <- hf[[paste0(mat, '/features/name')]][]
    barcodes <- hf[[paste0(mat, '/barcodes')]][]
    spMat <- Matrix::sparseMatrix(
        i = indices[] + 1,
        p = indptr[],
        x = as.numeric(x = counts[]),
        dims = shp[],
        repr = "C"
    )
    spMat@x <- log2(1+spMat@x)
    features <- make.unique(names = features)
    rownames(spMat) <- features
    colnames(spMat) <- barcodes
    hf$close_all()
    return(spMat)
}

#===================
#' @title Load 10x Visium Spatial Coordinates
#' @description This function loads spatial coordinates for each cell from a
#' 10X Visium 
#' spatial folder.
#' @export
#' @param visiumDir A string path to the location of the folder containing the 
#' spatial coordinates. The folder in your visiumDir must be named 'spatial' 
#' and must contain files 'scalefactors_json.json' 
#' and 'tissue_positions_list.csv.'
#' @param resolution A string specifying which values to look for in the .json 
#' object. Can be either fullres (default), lowres or hires.
#' @param version A string specifying the version of the spaceranger data.
#' @return a data frame of the spatial coordinates 
#' ( x and y) for each spot/cell
#' @examples
#' library(SpaceMarkers)
#' #Visium data links
#' urls <- read.csv(system.file("extdata","visium_data.txt",
#' package = "SpaceMarkers",mustWork = TRUE))
#' sp_url <- urls[["visium_url"]][2]
#' # Spatial Coordinates
#' download.file(sp_url, basename(sp_url), mode = "wb")
#' untar(basename(sp_url))
#' spCoords <- load10XCoords(visiumDir = ".", version = "1.0")
#' unlink("spatial", recursive = TRUE)
#' unlink("Visium_Human_Breast_Cancer_spatial.tar.gz")
#' 

load10XCoords <- function(visiumDir, resolution = c("fullres","lowres","hires"), version = NULL){

    #resolve resolution parameter
    resolution <- match.arg(resolution, several.ok = FALSE)
    message("resolution: ", resolution)
    #determine spacerager version
    if(is.null(version)){
        message("Version not provided. Trying to infer.")
        if("probe_set.csv" %in% dir(visiumDir)){
            config_line <- readLines(paste0(visiumDir,"/probe_set.csv"), 1)
            version <- strsplit(config_line, "=")[[1]][2]
        } else if ("tissue_positions.parquet" %in% 
        dir(file.path(visiumDir,"spatial"))) {
          version <- "HD"
          visiumDir <- file.path(visiumDir)
          message(".parquet file found.
                  Detected VisiumHD.")
        } else {
            message(
              "probe_set.csv or .parquet not found.Assuming version 1.0.")
            version <- "1.0"
        }
    }
    spatial_dir <- paste0(visiumDir,"/spatial")
    #account for different versions of visium data
    if(version == "1.0"){
      has_header <- FALSE
      tissue_pos_name <- "tissue_positions_list.csv"
      coord_reader <- read.csv
    } else if (version == "2.0") {
      has_header <- TRUE
      tissue_pos_name <- "tissue_positions.csv"
      coord_reader <- read.csv
    } else if (version == "HD") {
      has_header <- TRUE
      tissue_pos_name <- "tissue_positions.parquet"
      coord_reader <- nanoparquet::read_parquet
    }
    coord_file <- dir(spatial_dir,pattern = tissue_pos_name, full.names = TRUE)
    if(!is.null(formals(coord_reader)["header"])) 
      formals(coord_reader)["header"] <- has_header
    coord_values <- coord_reader(coord_file)
    scale_json <- dir(spatial_dir,
                        pattern = "scalefactors_json.json",full.names = TRUE)
    scale_values <- jsonlite::read_json(scale_json)
    if (resolution == "fullres"){
        scale_factor <- 1
    } else {
        scale_factor <- scale_values[grepl(resolution, names(scale_values))][[1]]
    }
    
    coord_values <- coord_values[,c(1,5,6)]
    coord_values[,2:3] <- coord_values[,2:3]*scale_factor
    names(coord_values) <- c("barcode","y","x")
    return(coord_values)
}

#===================
#' @title Load spatial features
#' @description This function loads spatial features from a file containing
#' spatial features
#' @export
#' @param filePath A string path to the location of the file containing the 
#' spatial features. 
#' @param method A string specifying the type of object to obtain spatial
#' feature from. Default NULL, where the method is inferred based on object
#' type. Other methods are: "CoGAPS", "Seurat", or "BayesTME".
#' @param featureNames An array of strings specifying the column names 
#' corresponding to the feature names or a regex string. In the case of Seurat,
#' all metadata columns with "_Feature" suffix are selected.
#' @return a matrix of spatial features with barcodes associated 
#' with individual coordinates
#' @examples
#' library(SpaceMarkers)
#' #CoGAPS data filePath
#' filePath <- system.file("extdata","CoGAPS_result.rds", 
#' package = "SpaceMarkers",mustWork = TRUE)
#' spFeatures <- get_spatial_features(filePath, method = "CoGAPS")
#' head(spFeatures)
#' 

get_spatial_features <- function(filePath, method = NULL, featureNames = "."){

    #read the features object based on the format
    spObject <- .read_format(filePath)

    #determine the method to use for feature extractioin
    method <- .infer_method(spObject, method)

    spFun <- c("CoGAPS"=.get_cogaps_features,
                "BayesTME"=.get_BTME_features,
                "Seurat"=.get_seurat_features,
                "CSV"=.get_csv_features)

    spFeatures <- spFun[[method]](spObject)

    dataNames <- colnames(spFeatures)

    #subset the features based on the featureNames
    if(length(featureNames) == 1) {
        #assume regex is provided
        namePattern <- featureNames
        featureNames <- dataNames[grepl(pattern = namePattern,
                                        dataNames, ignore.case = TRUE)]
        if(length(featureNames) == 0) {
           stop(sprintf("Regex %s does not match any feature.", namePattern))
        }
    } else if(!all(featureNames %in% dataNames)) {
    stop("Some of the features were not found:",
            sprintf(" %s", setdiff(featureNames, dataNames)))
    }

    featureNames <- intersect(featureNames, dataNames)
    spFeatures <- spFeatures[,featureNames, drop = FALSE]

    return(spFeatures)
}

#' readFormat
#' Reads a format into an R object
#' @keywords internal
#' 
.read_format <- function(path){
    if(grepl(".rds",path)){
        obj <- readRDS(path)
    } else if (grepl(".h5ad",path)){
        obj <- hdf5r::h5file(filename = path, mode='r')
    } else if (grepl(".csv",path)){
        obj <- read.csv(path)
    } else
    {
        stop("File format not supported.")
    }
    return(obj)
}

#' inferMethod
#' Infer the method used to obtain spatial features
#' @keywords internal
.infer_method <- function(spObject, method){
    if(is.null(method)){
        if(inherits(spObject, "H5File")){
            method <- "BayesTME"
        } else if(inherits(spObject, "CogapsResult")){
            method <- "CoGAPS"
        } else if(inherits(spObject, "Seurat")){
            method <- "Seurat"
        } else if(inherits(spObject, "data.frame")){
            method <- "CSV"
        } else {
            stop("Method not supported.")
        }
    }
    return(method)
}

#' .get_cogaps_features
#' Load features CoGAPS object
#' @keywords internal
#' 
.get_cogaps_features <- function(obj){
    spFeatures <- slot(obj, "sampleFactors")
    return(spFeatures)
}

#' .get_BTME_features
#' Load features BayesTME object
#' 
#' @keywords internal
#' 
.get_BTME_features <- function(hf){
    feat_loc <- "obsm/bayestme_cell_type_counts"
    barc_loc <- "obs/_index"
    spFeatures <- t(hdf5r::readDataSet(hf[[feat_loc]]))
    barcodes <- hdf5r::readDataSet(hf[[barc_loc]])
    rownames(spFeatures) <- barcodes
    if (is.null(colnames(spFeatures))) {
        colnames(spFeatures)<-paste0("BayesTME_",seq(1,ncol(spFeatures)))
    }
    
    return(spFeatures)
}

#' .get_seurat_features
#' Load features Seurat object
#' @keywords internal
#' 
.get_seurat_features <- function(obj){
    spFeatures <- slot(obj, "meta.data")
    selection <- grepl("_Feature",colnames(spFeatures), ignore.case = TRUE)
    if (!any(selection)){
        stop("No _Feature columns found in Seurat object.")
    }
    spFeatures <- spFeatures[,selection, drop = FALSE]
    return(spFeatures)
}

#' .get_csv_features
#' Load features from dataframe
#' @keywords internal
#' 
.get_csv_features <- function(obj){
    spFeatures <- obj
    if ("barcode" %in% colnames(spFeatures)){
        rownames(spFeatures) <- spFeatures$barcode
    } else {
        if(!colnames(spFeatures)[1]=="X"){
            stop("No barcode column found and first colname is not blank.
                    Stopping.")
        } else {
            rownames(spFeatures) <- spFeatures[,"X"]
        }
    }
    removeCols <- c("NA","barcode","in_tissue","array_row","array_col","pxl_col_in_fullres","pxl_row_in_fullres")
    spFeatures <- spFeatures[,-which(startsWith(colnames(spFeatures),"X") | colnames(spFeatures) %in% removeCols)]
    return(spFeatures)
}

test_that("load10XExpr loads data correctly", {
  # Create a temporary directory for testing
  temp_dir <- "."
  # Generate a test h5 file
  file.create("test.h5")
  h5_file <- file.path("test.h5")
  hf <- hdf5r::H5File$new(h5_file , mode = "w")

  # Create test data
  counts <- c(1, 2, 3, 4, 5, 6)
  indices <- c(0, 1, 2, 0, 1, 2)
  indptr <- c(0, 3, 6)
  shp <- c(3, 2)
  features <- c("gene1", "gene2", "gene3")
  barcodes <- c("cell1", "cell2")

  # Write test data to h5 file
  hf$create_group("matrix")
  hf$create_group("matrix/features")

  hf[["matrix/data"]] <- counts
  hf[["matrix/indices"]] <- indices
  hf[["matrix/indptr"]] <- indptr
  hf[["matrix/shape"]] <- shp
  hf[["matrix/features/name"]] <- features 
  hf[["matrix/barcodes"]] <- barcodes
  
  # Close the h5 file
  hf$close_all()

  # Call the load10XExpr function with the test h5 file
  spMat <- load10XExpr(visiumDir = temp_dir, h5filename = "test.h5")
  
  # Perform assertions to check if the data is loaded correctly
  expect_equal(length(grepl(h5_file,list.files())[grepl(h5_file,list.files())]),1,
               info = paste0("More than one file with ", h5_file))
  expect_equal(dim(spMat), c(3, 2), info = "Incorrect matrix dimensions")
  expect_equal(rownames(spMat), make.unique(features), info = "Incorrect row names")
  expect_equal(colnames(spMat), barcodes, info = "Incorrect column names")
  expect_equal(spMat[1, 1], log2(1 + counts[1]), info = "Incorrect matrix value")
  expect_equal(spMat[3, 2], log2(1 + counts[6]), info = "Incorrect matrix value")
  expect_true(class(spMat) %in% c("dgTMatrix","dgCMatrix"), info = "Incorrect matrix class")
  
  # Clean up the temporary directory
  unlink("test.h5")
})

#reading input files and extracting features

test_that(".read_format can read cogaps and btme files", {
    expect_no_error(.read_format("assets/cogaps.rds"))
    expect_no_error(.read_format("assets/btme.h5ad"))
})

test_that(".get_cogaps_features can read features from a CoGAPS object",{
    cg <- .read_format("assets/cogaps.rds")
    sf <- .get_cogaps_features(cg)
    expect_equal(ncol(sf), 3)
})

test_that(".get_BTME_features can read features from Anndata object",{
    bt <- .read_format("assets/btme.h5ad")
    sf <- .get_BTME_features(bt)
    expect_equal(ncol(sf), 3)
})

test_that(".infer_method can infer the method used to obtain spatial features", {
    expect_equal(.infer_method(.read_format("assets/cogaps.rds"), NULL), "CoGAPS")
    expect_equal(.infer_method(.read_format("assets/btme.h5ad"), NULL), "BayesTME")
})

#main function tests
test_that("get_spatial_features fails with unsupported method",{
    expect_error(get_spatial_features("assets/cogaps.rds", method = "unsupported"))
})

test_that("get_spatial_features fails with no matching feature names",{
    expect_error(get_spatial_features("assets/cogaps.rds", method = "CoGAPS", featureNames = "no_match"),
                 "Regex no_match does not match any feature.")
})

test_that("get_spatial_features work with custom regex", {
    sf <- get_spatial_features("assets/cogaps.rds", method = "CoGAPS", featureNames = "_1")
    expect_equal(ncol(sf), 1)
})

test_that("get_spatial_features works with a feature name set", {
    sf <- get_spatial_features("assets/cogaps.rds", method = "CoGAPS", featureNames = c("Pattern_1", "Pattern_2"))
    expect_equal(ncol(sf), 2)
})

test_that("get_spatial_features warns if some of the features are not found", {
    expect_error(get_spatial_features("assets/cogaps.rds", method = "CoGAPS", 
                                    featureNames = c("Pattern_1", "Pattern_2", "Pattern_4")),
                                    "Some of the features were not found: Pattern_4")
})

test_that("get_spatial_features warns if some of the features are not found", {
    expect_error(get_spatial_features("assets/cogaps.rds", method = "CoGAPS",
                                    featureNames = c("Pattern_1", "Pattern_2", "Pattern_3", "qq", "ww")),
                                    "Some of the features were not found: qq ww")
})

test_that("get_spatial_features works in infer mode with Cogaps object", {
    sf <- get_spatial_features("assets/cogaps.rds")
    expect_equal(ncol(sf), 3)
})

test_that("get_spatial_features works in infer mode with Cogaps object", {
    sf <- get_spatial_features("assets/btme.h5ad")
    expect_equal(ncol(sf), 3)
})

#a mock function for the header/non header cases, can be extended
#to other cases (above) as well
create_visium_mock <- function(version = "1.0", probe_set = TRUE) {
  stopifnot(version %in% c("1.0", "2.0","HD"))
  if (version == "1.0") {
    header <- FALSE
    tissue_pos_name <- "tissue_positions_list.csv"
  } else if (version == "2.0") {
    header <- TRUE
    tissue_pos_name <- "tissue_positions.csv"
  } else if (version == "HD"){
    tissue_pos_name <- "tissue_positions.parquet"
  }
  
  dir.create("mock_visiumDir/spatial", recursive = TRUE)
  
  #Create probe_set file
  if (probe_set) {
    writeLines(c(sprintf("#probe_set_file_version=%s", version),
                 "#panel_name=TEST",
                 "gene_id",
                 "ENSMUSG00000000001",
                 "ENSMUSG00000000003",
                 "ENSMUSG00000000028"),
               "mock_visiumDir/probe_set.csv")
  }
  
  
  # Create mock scalefactors_json.json
  scalefactors_json <- list(
    spot_diameter_fullres = 1,
    lowres = 0.5
  )
  jsonlite::write_json(scalefactors_json,
                       "mock_visiumDir/spatial/scalefactors_json.json")
  
  # Create mock tissue_positions_list.csv
  tissue_positions <- data.frame(
    barcode = c("ACGCCTGACACGCGCT-1",
                "TACCGATCCAACACTT-1",
                "CGGAGGCTCTCGTCTG-1"),
    in_tissue = c(1, 1, 1),
    array_row = c(0, 1, 0),
    array_col = 0:2,
    pxl_row_in_fullres = c(1, 2, 3),
    pxl_col_in_fullres = c(4, 5, 6)
  )
  
  if (version == "HD"){
    nanoparquet::write_parquet(tissue_positions,
                               file = sprintf(
                                 "mock_visiumDir/spatial/%s.parquet",
                                 tissue_pos_name))
  } else {
    write.table(tissue_positions,
                sprintf("mock_visiumDir/spatial/%s.csv", tissue_pos_name),
                row.names = FALSE,
                col.names = header,
                sep = ",")
    
  }
  
  
  # Create expected output
  expected_output <- data.frame(
    barcode = c("ACGCCTGACACGCGCT-1",
                "TACCGATCCAACACTT-1",
                "CGGAGGCTCTCGTCTG-1"),
    y = c(0.5, 1, 1.5),
    x = c(2, 2.5, 3)
  )
  return(expected_output)
}

test_that("load10XCoords returns the expected output for spaceranger v1.0", {
  expected_output <- create_visium_mock(version = "1.0")
  output <- load10XCoords("mock_visiumDir", 
            resolution="lowres",
            version = "1.0")
  expect_equal(output, expected_output)
  unlink("mock_visiumDir", recursive = TRUE)
})

test_that("load10XCoords returns the expected output for spaceranger v2.0", {
  expected_output <- create_visium_mock(version = "2.0")
  output <- load10XCoords("mock_visiumDir", resolution="lowres",
  version = "2.0")
  expect_equal(output, expected_output)
  unlink("mock_visiumDir", recursive = TRUE)
})

test_that("load10XCoords returns the expected output for visium HD", {
  expected_output <- create_visium_mock(version = "HD")
  output <- load10XCoords("mock_visiumDir", resolution="lowres",
                          version = "HD")
  expect_equal(as.data.frame(output), expected_output)
  unlink("mock_visiumDir", recursive = TRUE)
})

test_that("load10XCoords returns the expected output without probe_set file", {
  expected_output <- create_visium_mock(version = "1.0", probe_set = FALSE)
  output <- load10XCoords("mock_visiumDir", resolution="lowres")
  expect_equal(output, expected_output)
  unlink("mock_visiumDir", recursive = TRUE)
})

test_that("getCSVfeatures works with a barcode column", {
    obj <- data.frame(barcode = c("A1", "B2"), x = c(1, 2), y = c(3, 4))
    sf <- .get_csv_features(obj)
    expect_equal(rownames(sf), c("A1", "B2"))
})

test_that("getCSVfeatures works without a barcode column", {
    #simulate empty first colname
    temp <- tempfile(fileext = ".csv")
    write.csv(data.frame(x = c(1, 2), y = c(3, 4)), temp, row.names = TRUE)
    obj <- read.csv(temp)
    sf <- .get_csv_features(obj)
    expect_equal(rownames(sf), c("1", "2"))
})

test_that("getCSVfeatures fails without a barcode column or rownames", {
    obj <- data.frame(x = c(1, 2), y = c(3, 4))
    expect_error(.get_csv_features(obj), "No barcode column")
})

#' @title Compute the spatial influence of a spatial feature
#' @description This function computes the spatial influence of a specified pattern
#' @param spPatterns A data frame containing x, y coordinates and pattern name
#' @param optParams A data frame with optimal parameters for the pattern
#' @param ... Additional parameters for the Smooth function
#' @return A data frame with the spatial influence of the specified pattern
#' @export
calculate_influence <- function(spPatterns, optParams,...) {
    patnames <- setdiff(colnames(spPatterns),
                       c("x", "y", "barcode"))

    allwin <- spatstat.geom::owin(
    range(spPatterns$x),
    range(spPatterns$y))
    X <- spatstat.geom::ppp(x = spPatterns$x, y = spPatterns$y,
                            window = allwin,
                            marks = spPatterns[,patnames[1]])

    spInfluence <- sapply(patnames, function(pat) {
    # Create a point pattern object for each pattern
    X <- spatstat.geom::ppp(x = spPatterns$x, y = spPatterns$y,
                            window = allwin,
                            marks = spPatterns[,pat])
    
    # Calculate the kernel for the specified pattern
    Kact1 <- spatstat.explore::Smooth(
      X, at = "points", sigma = optParams[1,pat],...)
    
    # Plot the K-function
    return(Kact1)
    })
    spInfluence <- as.data.frame(spInfluence)
    colnames(spInfluence) <- patnames
    spInfluence <- cbind(spPatterns[,c("barcode","x", "y")], spInfluence)

    return(spInfluence)
}

#' @title Compute the threshold for identifying outlier values or hotspots
#' @description This function computes the threshold for identifying outlier 
#' values or hotspots by fitting a normal mixture model to the data.
#' @param df A vector containing pattern values
#' @param minval Minimum value for quantile threshold
#' @param maxval Maximum value for quantile threshold
#' @param method Method to use for threshold calculation. Options are "abs" for absolute (default) and "pct" for percentile.
#' @return A list containing the computed thresholds
#' @importFrom mixtools normalmixEM
.calc_threshold <- function(df, minval = 0.01, maxval = 0.99, method=c("abs","pct")) {
if (method[1]=="pct"){
    minthresh <- quantile(df,minval)
    maxthresh <- quantile(df,maxval)
} else {
   minthresh <- minval
   maxthresh <- maxval
}
#Calculate the two compmonents of the normal mixture model
res <- try(mixtools::normalmixEM(df, k = 2, maxit = 1000, epsilon = 1e-8), silent = TRUE)
if (inherits(res, "try-error") || is.null(res) || !all(c("mu", "sigma") %in% names(res)) || res$ft == 1000) {
    warning("mixtools::normalmixEM failed or reached maxit; using minval as threshold")
    return(minthresh)
}
comps <- res

# Identify smaller component
small <- which.min(comps$mu)

thresh <- min(max(comps$mu[small] + (comps$sigma[small] * 4), minthresh),maxthresh)

return(thresh)
}
#' @title Compute the thresholds for all columns in a data frame
#' @description This function computes the thresholds for all columns in a 
#' data frame. The data frame could be an spPatterns object or an spInfluence
#' object.
#' @param df A data frame with pattern values (optionally 
#' with x, y, barcode columns)
#' @param minvals Minimum value for quantile threshold
#' @param maxvals Maximum value for quantile threshold
#' @param ... Additional parameters to pass to lower level functions
#' @return A list containing the computed thresholds for each pattern
#' @export 
calculate_thresholds <- function(df, minvals = 0.01, maxvals = 0.99,...) {
  
    patnames <- setdiff(colnames(df), c("x", "y", "barcode"))
    #Check if minvals and maxvals are vectors
    if (length(minvals) == 1) minvals <- rep(minvals, length(patnames))
    if (length(maxvals) == 1) maxvals <- rep(maxvals, length(patnames))
    # Check if minvals and maxvals are of the same length and match 
    # the number of columns in df
    if ((length(minvals) != length(maxvals)) || length(patnames) != length(minvals)) {
        stop("minvals and maxvals must be scalar or vectors of 
              the length ncol(df)")
    }
    names(minvals) <- patnames
    names(maxvals) <- patnames

    # Calculate thresholds for all patterns
    thresholds <- sapply(patnames, function(pat) {
        .calc_threshold(df[,pat], minval=minvals[pat], maxval=maxvals[pat],...)
    })
    return(thresholds)
}


#' @title Find hotspots for all patterns or influences based on values
#' @description Convenience function to find hotspots for all spatial patterns 
#' or influence dataframes based on provided thresholds
#' @inheritParams calculate_thresholds
#' @param threshold a scalar or vector of thresholds for each column in the data frame.
#'  Either user provided or the output of @calculate_thresholds
#' @return a data frame with the same dimensions as the input data frame.
#' @export 
find_hotspots_gmm <- function(df, threshold = 0.1,...){
    patnames <- setdiff(colnames(df),c("x","y","barcode"))
    if (length(threshold)==1){
        threshold <- rep(threshold,length(patnames))
    }
    if (length(threshold)!=length(patnames)){
        stop("Length of threshold must be 1 or equal to number of patterns.")
    }
    names(threshold) <- patnames
    
    hotspots <- matrix(NA, nrow=nrow(df), ncol=length(patnames))
    colnames(hotspots) <- patnames
    for (pat in patnames){
        hotspots[,pat] <- ifelse(
            df[,pat]>threshold[pat],pat,NA)
    }
    hotspots <- cbind(df[c("barcode","y","x")],hotspots)
    row.names(hotspots) <- hotspots$barcode
    hotspots <- as.data.frame(hotspots)
    return(hotspots)
}

.classify_spots <- function(pat_hotspots, influence_hotspots, patternpair = NULL) {
    patnames <- setdiff(colnames(pat_hotspots), c("x", "y", "barcode"))
    infnames <- setdiff(colnames(influence_hotspots), c("x", "y", "barcode"))  
    #check if pat_hotspots and influence_hotspots have the same dimensions
    if (!all(dim(pat_hotspots) == dim(influence_hotspots))) {
        stop("pat_hotspots and influence_hotspots must have the same dimensions.")
    } else if (!all(patnames == infnames)) {
        stop("pat_hotspots and influence_hotspots must have the same column names.")
    }
    # Check if patternpair is NULL or is contained in patnames
    if (!is.null(patternpair) && !all(patternpair %in% patnames)) {
        stop("patternpair must be NULL or contained in patnames.")
    } else if (is.null(patternpair) && length(patnames) > 2) {
        stop("More than 2 patterns found. Please provide patternpair.")
    }
    
    region <- pat_hotspots[,patternpair[1]]
    pat1.inf2 <- ifelse(!is.na(region) & !is.na(influence_hotspots[,patternpair[2]]),"Interacting",
    ifelse(!is.na(region),region,NA))

    region <- pat_hotspots[,patternpair[2]]
    pat2.inf1 <- ifelse(!is.na(region) & !is.na(influence_hotspots[,patternpair[1]]),"Interacting",
    ifelse(!is.na(region),region,NA))
    df <- data.frame(pat1.inf2=pat1.inf2, pat2.inf1=pat2.inf1)
return(df)
}

#' @title Perform row-wise t-tests from scratch
#' @description This function iterates over the rows of a matrix and performs a
#' t-test comparing two groups of columns. It calculates the t-statistic, p-value,
#' and sample sizes without relying on `stats::t.test()` for the core logic.
#' @param in.data A numeric matrix. Rows represent features, columns represent samples.
#' @param region A factor or vector indicating the group membership for each column of `in.data`.
#'                Must have exactly two levels/unique values. Its length must equal `ncol(in.data)`.
#' @param min_bins Minimum number of non-missing observations required in each group to perform the t-test.
#' @param ... Additional parameters to pass to the t-test function.
#' @return A matrix with rows corresponding to the features and columns:
#'          - `statistic`: The calculated t-statistic.
#'          - `p.value`: The calculated two-sided p-value.
#'         - `n1`: Number of non-missing observations in group 1 for that row.
#'         - `n2`: Number of non-missing observations in group 2 for that row.
#' @importFrom stats t.test
#' @importFrom effsize cohen.d
.row_t_test <- function(in.data, region, min_bins=50, ...){
    if (!is.factor(region)) {
        region <- factor(region)
    }
    if (nlevels(region) != 2) {
        stop("'region' must have exactly two levels (groups).")
    }
    group_levels <- levels(region)
    int <- which(as.character(group_levels)=="Interacting")
    interacting <- group_levels[int]
    patname <- group_levels[-int]
    idx_pat <- which(region == patname)
    idx_int <- which(region == interacting)
    t_scores <- sapply(rownames(in.data), function(r) {
        pat <- in.data[r, idx_pat]
        inter <- in.data[r, idx_int]
        if (length(pat) < min_bins || length(inter) < min_bins) {
            return(c(statistic=NA, p.value=NA, n1=0, n2=0, effect_size=NA))
        }
        tmp <- t.test(x=inter, y=pat, 
                      alternative = "two.sided", var.equal = FALSE, 
                      na.action = na.omit)
        effect_size <- effsize::cohen.d(inter, pat)$estimate
        return(c(statistic=tmp$statistic, p.value=tmp$p.value, n1=length(inter), n2=length(pat), effect_size=effect_size))
    })

    t_scores <- t(t_scores)
    colnames(t_scores) <- c("statistic", "p.value", "n1", "n2", "effect_size")
    return(t_scores)
}
#' @title Calculate interaction scores for a specific pattern pair
#' @description This function calculates interaction scores for a specific pattern pair
#' using the ` .classify_spots` function to determine the region of each spot.
#' @param data A numeric matrix with genes as rows and barcodes as columns.
#' @param pat_hotspots A data frame with pattern hotspots, containing columns for x, y, and barcode.
#' @param influence_hotspots A data frame with influence hotspots, containing columns for x, y, and barcode.
#' @param patternpair A character vector of length 2 specifying the pattern pair to analyze.
#' @param avoid_confounders Logical (default=FALSE) indicating whether to avoid confounding effects due to colocalization.
#' @param ... Additional parameters to pass to lower level functions.
#' @return A data frame with interaction scores for the specified pattern pair.
.calc_IM_scores <- function(data, pat_hotspots, influence_hotspots, patternpair, avoid_confounders=FALSE,...) {
    spotClass <-  .classify_spots(pat_hotspots, influence_hotspots, patternpair = patternpair)
    pat1 <- patternpair[1]
    pat2 <- patternpair[2]
    region <- spotClass[,1]
    if (avoid_confounders==TRUE)
        region[which(!is.na(spotClass[,2]))] <- NA
    if (sum(!is.na(unique(region)))==2){
        t1table <- .row_t_test(data, region=region)

    } else {
       t1table <- matrix(NA, nrow=nrow(data), ncol=5)
       colnames(t1table) <- c("statistic", "p.value", "n1", "n2", "effect_size")
    }
    t1table <- as.data.frame(t1table)
    t1table$gene <- rownames(t1table)
    t1table$cell_interaction <- paste0(pat1, "_near_", pat2)

    region <- spotClass[,2]
    if (avoid_confounders==TRUE)
        region[which(!is.na(spotClass[,1]))] <- NA
    if (sum(!is.na(unique(region)))==2){
        t2table <- .row_t_test(data, region=region)
    } else {
        t2table <- matrix(NA, nrow=nrow(data), ncol=5)
        colnames(t2table) <- c("statistic", "p.value", "n1", "n2", "effect_size")
    }
    t2table <- as.data.frame(t2table)
    t2table$gene <- rownames(t2table)
    t2table$cell_interaction <- paste0(pat2, "_near_", pat1)

    tscores <- rbind(t1table, t2table)
    tscores$p.adj <- p.adjust(tscores$p.value, method = "BH")
    return(tscores)
}

#' @title Calculate interaction scores for all pattern pairs
#' @description This function calculates interaction scores for all pattern pairs
#' using the `.calc_IM_scores` function. It can run in parallel if BiocParallel is available.
#' @param data A numeric matrix with genes as rows and barcodes as columns.
#' @param pat_hotspots A data frame with pattern hotspots, containing columns for x, y, and barcode.
#' @param influence_hotspots A data frame with influence hotspots, containing columns for x, y, and barcode.
#' @param pattern_pairs A data frame with pattern pairs to calculate interaction scores for. If NULL, 
#' all combinations of patterns in `pat_hotspots` will be used.
#' If provided, it should have two columns with pattern names. 
#' Each row should represent a pair of patterns for which interaction scores will be calculated.
#' @param ... Additional parameters to pass to lower level functions.
#' @return A data frame with interaction scores for all pattern pairs.
#' @export
calculate_gene_scores_directed <- function(data, pat_hotspots, influence_hotspots, pattern_pairs=NULL,...) {
    if (is.null(pattern_pairs)) {
        pattern_pairs <- utils::combn(setdiff(colnames(pat_hotspots), c("x", "y", "barcode")), 2, simplify = FALSE)
    }
    use_biocparallel <- (requireNamespace("BiocParallel", quietly = TRUE)) && 
                                        (BiocParallel::bpparam()$workers > 1) &&
                                        (!is.null(nrow(pattern_pairs)) && (nrow(pattern_pairs) > 1))
    if (use_biocparallel) {
        bpp <- BiocParallel::bpparam()
        IMscores_list <- BiocParallel::bplapply(
            seq_len(nrow(pattern_pairs)),
            function(i) {
                patternpair <- pattern_pairs[i,]
                IMscores.pair <- .calc_IM_scores(data, pat_hotspots, influence_hotspots, patternpair,...)
                return(IMscores.pair)
            },
            BPPARAM = bpp
        )
        IMscores <- do.call(rbind, IMscores_list)
        message("Processed all pattern pairs in parallel.\n")
    } else {
        IMscores <- c()
        for (i in 1:nrow(pattern_pairs)) {
            patternpair <- pattern_pairs[i,]
            IMscores.pair <- .calc_IM_scores(data, pat_hotspots, influence_hotspots, patternpair,...)
            IMscores <- rbind(IMscores, IMscores.pair)
            message("Processed pattern pair: ", patternpair[1], " and ", patternpair[2], "\n")
            if (i %% 10 == 0) {
                message("Processed ", i, "pattern pairs so far.\n")
            }
        }
    }
    return(IMscores)
}

#' @title calculate_overlap_directed
#' @description Calculate the overlap scores between patterns in hotspots
#' @param pat_hotspots A data frame with columns x, y, barcode and pattern names
#' @param influence_hotspots A data frame with columns x, y, barcode and pattern names
#' @param method The method to calculate overlapping abundance scores. Options are
#' "relative-abundance", "differential-abundance" and "absolute"
#' @param patternList A character vector of pattern names to calculate overlap 
#' scores for. If NULL, all patterns in pat_hotspots and influence_hotspots will be used.
#' @details The function calculates the overlap scores between patterns hotspots
#' using the specified method. The default method is "relative-abundance"
#' @return A data frame with columns pattern, influence and overlapping abundance
#' @export
#' @examples
#' hotspots <- data.frame(x = c(1,2,3,4,5),
#'                         y = c(1,2,3,4,5),
#'                         barcode = c("A","B","C","D","E"),
#'                         pattern1 = c(1,0,1,0,1),
#'                         pattern2 = c(1,1,0,0,1))
#' influence_hotspots <- data.frame(x = c(1,2,3,4,5),
#'                        y = c(1,2,3,4,5),
#'                       barcode = c("A","B","C","D","E"),
#'                       pattern1 = c(0,1,1,0,0),
#'                       pattern2 = c(0,1,0,1,1))
#' calculate_overlap_directed(pat_hotspots = hotspots, influence_hotspots = influence_hotspots)
#' @importFrom ggplot2 ggplot geom_tile geom_text theme_minimal
#' @importFrom reshape2 melt
#' @importFrom stats complete.cases
calculate_overlap_directed <- function(pat_hotspots, influence_hotspots,
                             patternList = NULL, method = c("relative-abundance",
                                                            "differential-abundance",
                                                             "absolute") ) {
    
    #warn if more than one method is supplied, do not warn by default
    if(length(method) > 1){
        method <- method[1]
        message("Only one method can be used at a time. Using ", method)
    }

    if (is.null(patternList)) {
        patternList <- setdiff(colnames(pat_hotspots),c("x","y","barcode"))
    } else if (!all(patternList %in% colnames(pat_hotspots))) {
        stop("Pattern names not found in hotspots")
    }

    patBinarized <- (!is.na(pat_hotspots[,patternList]))*1
    infBinarized <- (!is.na(influence_hotspots[,patternList]))*1
    intersects <- t(patBinarized) %*% infBinarized
    #nHotspots <- colSums(binarized)
    nHotsP1 <- t(t(colSums(patBinarized))) %*% array(1, length(patternList))
    nHotsP2 <- matrix(1, nrow=length(patternList),ncol=1) %*% colSums(infBinarized)
    colnames(nHotsP1) <- patternList
    colnames(nHotsP2) <- patternList
    rownames(nHotsP2) <- patternList
    overlapScore <- switch(method,
        "relative-abundance" = intersects/nHotsP2/(nHotsP1[,1]/nrow(patBinarized)),
        "differential-abundance" = intersects/nHotsP2 - (nHotsP1 - intersects)/(nrow(patBinarized) - nHotsP2),
        "absolute" = intersects,
        stop("Method not supported")
    )

    diag(overlapScore) <- NA
    colnames(overlapScore) <- paste0("near.",colnames(overlapScore))
    #overlapScore[upper.tri(overlapScore,diag = TRUE)] <- NA
  
    # Melt normalized Jaccard for output
    dfOverlap <- reshape2::melt(overlapScore)
    dfOverlap <- dfOverlap[stats::complete.cases(dfOverlap),]
    # Due to melting in lower triangular orientation, the column names are flipped
    colnames(dfOverlap) <- c("pattern", "influence", "relAbundance")
    return(dfOverlap)
}

#' Optimal paramters of 5 patterns from CoGAPS.
#'
#' A dataset with the optimal width of the gaussian distribution (sigmaOpt) and
#' the outlier threshold around the set of spots (thresOpt) for each pattern
#' obtained from CoGAPS. CoGAPS was ran on spatial transcriptomic data from a 
#' breast cancer sample.
#' 
#' @name optParams
#' @format A data frame with 2 rows and 5 columns:
#' \describe{
#'   \item{Pattern_1}{immune cell pattern paramters }
#'   \item{Pattern_2}{Disp.1 parameters}
#'   \item{Pattern_3}{intraductal carcinoma (DCIS) parameters }
#'   \item{Pattern_4}{Disp.2 parameters }
#'   \item{Pattern_5}{invasive carcinoma lesion pattern paramters }
#' }
#' @return A matrix of optimal parameters for patterns identified by CoGAPS
NULL

#' Curated Genes for example purposes
#' 
#' A vector with genes selected based on previous runs of SpaceMarkers on the
#' Visium 10x breast ductal carcinoma spatial transcriptomics dataset
#'
#' @name curated_genes
#' @format A vector with 114 pre-selected genes
#' @return a vector of genes
NULL

#' Curated Ligand-receptor interaction genes
#' A list of vectors with genes associated with ligand-receptor interactions from CellChat database
#' @name lrdf
#' @format A data frame with LR interaction genes
#' @return A list of vectors of LR genes
#' 
NULL

#' @importFrom matrixTests row_kruskalwallis
#' @importFrom rstatix filter
#' @importFrom matrixStats count
#' @importFrom stats lag dist pnorm sd
#' @importFrom qvalue qvalue
## author: Atul Deshpande
## email: adeshpande@jhu.edu

.row_dunn_test <- function(in.data,region,pattern1,pattern2){
    
    in.ranks <- matrixStats::rowRanks(in.data,cols = !is.na(region),
                                        ties.method = "average")

    rsub <- region[!is.na(region)]

    N <- length(rsub)
    N1 <- sum(rsub==pattern1)
    N2 <- sum(rsub==pattern2)
    NI <- sum(rsub=="Interacting")

    tiesStat <- apply(in.ranks,1,function(rr) {
        rr_table <- table(rr)
        sum(rr_table * (rr_table^2 - 1))
    })

    tiesStat2 <- sqrt(1 - tiesStat/N/(N-1)/(N+1))

    SEI1 <- sqrt(N*(N+1)/12*(1/NI+1/N1))
    SEI2 <- sqrt(N*(N+1)/12*(1/NI+1/N2))
    SE12 <- sqrt(N*(N+1)/12*(1/N1+1/N2))

    mInt<- apply(in.ranks[,rsub=="Interacting"],1,mean)
    mP1<- apply(in.ranks[,rsub==pattern1],1,mean)
    mP2<- apply(in.ranks[,rsub==pattern2],1,mean)

    zP1_Int <- (mP1-mInt)/SEI1/tiesStat2
    zP2_Int <- (mP2-mInt)/SEI2/tiesStat2
    zP2_P1 <- (mP2-mP1)/SE12/tiesStat2
    zVals <-cbind(zP1_Int,zP2_Int,zP2_P1)

    pval_1_Int <- ifelse(2*(pnorm(zP1_Int,lower.tail = TRUE))
                        <=1,2*(pnorm(zP1_Int,lower.tail = TRUE)),1)
    pval_2_Int <- ifelse(2*(pnorm(zP2_Int,lower.tail = TRUE))
                            <=1,2*(pnorm(zP2_Int,lower.tail = TRUE)),1)
    pval_2_1 <- ifelse(zP2_P1>0,2*(pnorm(zP2_P1,lower.tail = FALSE)),
                        2*(pnorm(zP2_P1,lower.tail = TRUE)))
    pvals<-cbind(pval_1_Int,pval_2_Int,pval_2_1)
return(cbind(zVals,pvals))
}

#===================
#' .find_genes_of_interest
#' Identify genes associated with pattern interaction.
#' This function identifies genes exhibiting significantly higher values of 
#' testMat in the Interaction region of the two 
#' patterns compared to regions with exclusive influence from either 
#' pattern. It uses Kruskal-Wallis test followed by
#' posthoc analysis using Dunn's Test to identify the genes.
#'
#' @usage
#' .find_genes_of_interest(testMat, goodGenes, region, fdr.level=0.05,
#'        analysis=c("enrichment","overlap"),...)
#' @param    testMat A matrix of counts with cells as columns and genes as rows
#' @param    goodGenes A vector of user specified genes expected to interact 
#' a priori. The default for this is NULL as the function can find these genes 
#' itself
#' @param    region A data frame of the reference pattern regions that overlap 
#' with the other patterns
#' @param    fdr.level False Discovery Rate. The default value is 0.05.
#' @param    analysis a character string that specifies the type of analysis to 
#' carry out, whether overlap or enrichment.
#' @param    ... Additional arguments to be passed to lower level functions
#' @return a list of genes exhibiting significantly higher values of testMat in 
#' the Interaction region of the two #' patterns compared to regions with 
#' exclusive influence from either pattern.

.find_genes_of_interest<-function(
        testMat,goodGenes=NULL,region, fdr.level=0.05,
        analysis=c("enrichment","overlap"),...) {
    
    # Default analysis = enrichment
    if ("enrichment" %in% analysis) {analysis <- "enrichment"}
    else if ("overlap" %in% analysis) {analysis <- "overlap"}
    else stop("analysis must be either 'enrichment' or 'overlap'")
    
    region <- factor(region)
    patnames <- levels(region)[which(levels(region)!="Interacting")]
    
    pattern1 <- patnames[1]
    pattern2 <- patnames[2]
    
    #we lose sparsity here, it is necessary for row tests (dunn, kruskal)
    testMat <- as.matrix(testMat)
    
    if (!is.null(goodGenes)){
        subset_goodGenes <- intersect(rownames(testMat),goodGenes)
    } else 
        {
        subset_goodGenes <- names(which(rowSums(testMat)>0))
    }
    testMat <- testMat[subset_goodGenes,]

    res_kruskal<- matrixTests::row_kruskalwallis(x=testMat,g=region)
    
    #adjust p-values for kruskal
    qq <- qvalue::qvalue(res_kruskal$pvalue,fdr.level = fdr.level,
                            pfdr = FALSE, pi0 = 1)
    res_kruskal <- cbind(res_kruskal,p.adj = qq$qvalues)
    
    #force res_kruskal statistics for zero variance genes to be 0 with p-value 1
    zero_genes <- names(which(rowSums(testMat[,!is.na(region)])==0))
    res_kruskal[zero_genes,c("df","statistic")] <- 0
    res_kruskal[zero_genes,c("pvalue","p.adj")] <- 1
    
    res_dunn_test <- .row_dunn_test(in.data=testMat, region=region,
                                        pattern1=pattern1, pattern2=pattern2)
    rownames(res_dunn_test) <- rownames(res_kruskal)

    #adjust p-values for Dunn's test
    qDunn <- qvalue::qvalue(res_dunn_test[,4:6],
        fdr.level = fdr.level, pfdr = FALSE, pi0 = 1)
    
    #check if any gene passed the fdr threshold for kruskal
    ind <- rownames(res_kruskal[which(res_kruskal$p.adj<fdr.level),])
    
    #readjust p-values for Dunn's test for the genes that passed the kruskal test
    if (length(ind)>0) {
        if (length(ind)==1) # no need of qvalue computation for one gene
            qDunn$qvalues[ind,] <- res_dunn_test[ind,4:6]
        else {
            qq<-qvalue::qvalue(res_dunn_test[ind,4:6],
                fdr.level=fdr.level,pfdr=FALSE,pi0 = 1)
            qDunn$qvalues[ind,] <- qq$qvalue   
        }
    }
    res_dunn_test <- cbind(res_dunn_test,qDunn$qvalues)
    colnames(res_dunn_test)[7:9] <- paste0(colnames(res_dunn_test)[7:9],".adj")
    
    #force res_dunn_test statistics for zero genes to be 0 with p-values of 1.
    res_dunn_test[zero_genes, c("zP1_Int","zP2_Int","zP2_P1")] <- 0
    res_dunn_test[zero_genes, c("pval_1_Int","pval_2_Int","pval_2_1")] <- 1
    res_dunn_test[zero_genes,c("pval_1_Int.adj",
                                "pval_2_Int.adj",
                                "pval_2_1.adj")] <- 1
    interactGenes <- .build_interact_genes_df(res_kruskal,res_dunn_test,ind,
                                          fdr.level,pattern1,pattern2,
                                          analysis)

    return(interactGenes)
}
.build_interact_genes_df <- function(res_kruskal,res_dunn_test,ind,
                                fdr.level=0.05,pattern1,pattern2,analysis) {
    interact_patt1 <- res_dunn_test[ind,"pval_1_Int.adj"]<fdr.level
    interact_patt2 <- res_dunn_test[ind,"pval_2_Int.adj"]<fdr.level
    interacting_over_both_patterns <- interact_patt1 & interact_patt2
    not_pattern1_diff_pattern2 <- res_dunn_test[ind,"pval_2_1.adj"]>=fdr.level
    exc_interact_patt1 <- interact_patt1 & not_pattern1_diff_pattern2
    exc_interact_patt2 <- interact_patt2 & not_pattern1_diff_pattern2
    names(exc_interact_patt2)<-ind
    names(exc_interact_patt1)<-names(exc_interact_patt2)
    names(interacting_over_both_patterns)<-names(exc_interact_patt1)
    interact_genes<-matrix(FALSE,nrow=nrow(res_dunn_test),ncol=2,dimnames=list(
        rownames(res_dunn_test),c("Gene",paste0(pattern1,' x ',pattern2))))
    interact_genes[,1] <- rownames(interact_genes)
    interact_genes[ind[which(exc_interact_patt1)],2]<-paste0("vs",pattern1)
    interact_genes[ind[which(exc_interact_patt2)],2]<-paste0("vs",pattern2)
    interact_genes[ind[which(interacting_over_both_patterns)],2]<-"vsBoth"
    colnames(res_kruskal) <- paste0("KW.",colnames(res_kruskal))
    colnames(res_dunn_test) <- paste0("Dunn.",colnames(res_dunn_test))
    interact_genes <- cbind(interact_genes,res_kruskal,res_dunn_test)
    if (analysis=="overlap"){
        interact_genes <-interact_genes[interact_genes[,2]!="FALSE",] 
    }
    return(list(interact_genes))
}

test_that(".find_genes_of_interest handles no significant genes without error", {
    # Mock input data
    fdr <- 0.05
    testMat <- matrix(rnorm(100), nrow=10, ncol=10)
    rownames(testMat) <- paste0("Gene", 1:10)
    region <- factor(rep(c("Pattern1", "Pattern2", "Interacting"), length.out=10))
    
    # Mock result of row_kruskalwallis to have no significant genes
    res_kruskal <- data.frame(
        pvalue = runif(10, 0.5, 1),  # p-values all above typical significance threshold
        row.names = rownames(testMat)
    )

    # Mock qvalue adjustment to have no significant adjusted p-values
    qq <- qvalue::qvalue(res_kruskal$pvalue, fdr.level = fdr, pfdr = FALSE, pi0 = 1)
    res_kruskal$p.adj <- qq$qvalues

    # Call the function and expect no errors
    expect_no_error(.find_genes_of_interest(testMat, region = region, fdr.level = fdr))
})

test_that(".find_genes_of_interest returns statistics for all non-zero genes", {
    # Mock input data
    fdr <- 0.05
    testMat <- matrix(runif(80), nrow=8, ncol=20)
    testMat <- rbind(testMat, matrix(0, nrow=4, ncol=20))  # Add 4 more rows
    testMat[10, 6] <- .2; # Add 3 non-zero genes
    testMat[11, 2] <- .4;
    testMat[12,9] <- .3;
    rownames(testMat) <- paste0("Gene", 1:12)
    region <- factor(rep(c("Pattern1", "Pattern2", "Interacting"), length.out=20))
    
    region[c(2,6,9)] <- NA  # Set some spots to NA
    region <- factor(region)
    suppressWarnings(
        sm_test <- .find_genes_of_interest(testMat, region = region, fdr.level = fdr)
    )
    zero_genes <- c("Gene10", "Gene11", "Gene12")
    coi <- c("KW.df","KW.statistic","KW.pvalue","KW.p.adj","Dunn.zP1_Int",
                "Dunn.zP2_Int","Dunn.zP2_P1","Dunn.pval_1_Int",
                "Dunn.pval_2_Int","Dunn.pval_2_1","Dunn.pval_1_Int.adj",
                "Dunn.pval_2_Int.adj","Dunn.pval_2_1.adj")
    # Check that all non-zero genes are included in the output
    expect_equal(nrow(sm_test[[1]]), 11)
    expect_equal(any(is.na(sm_test[[1]])), FALSE)
    expect_equal(sum(abs(t(as.matrix(sm_test[[1]][zero_genes,coi])) 
        - c(0,0,1,1,0,0,0,1,1,1,1,1,1))), 0)
})

# helper file for tests

# create sample data for getPairwiseInteractingGenes
.create_sample_data <- function(...) {
    data <- matrix(stats::rnorm(100), nrow = 10)
    rownames(data) <- paste0("gene_", seq_len(10))
    colnames(data) <- paste0("spot_", seq_len(10))
    spPatterns <- as.data.frame(matrix(stats::rnorm(40), nrow = 10))
    optParams <- data.matrix(data.frame("pattern1" = c(.2,3),
                                           "pattern2" = c(.2,3), 
                                            "pattern3" = c(.2,3), 
                                            "pattern4" = c(.2,3)))
    rownames(optParams) <- c("sigmaOpt","threshOpt")
    patnames <- colnames(spPatterns) <- 
        c("pattern1", "pattern2", "pattern3", "pattern4")
    coords <- data.frame(x = stats::runif(10), y = stats::runif(10), 
        barcode = paste0("spot_",seq_len(10)))
    spPatterns <- cbind(coords,spPatterns)
    return(list(data = data, spPatterns = spPatterns, 
                patnames = patnames, optParams = optParams))
}

---
title: "Inferring Immune Interactions in Breast Cancer"
author: "Orian Stapleton"
date: "2025-09-17"
output:
    BiocStyle::html_document:
        toc: yes
        toc_float:
          toc_collapsed: true
vignette: >
    %\VignetteIndexEntry{Inferring Immune Interactions in Breast Cancer}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

```{r global.options, include = FALSE}
knitr::opts_knit$set(
    collapse = TRUE,
    comment = "#>",
    fig.align   = 'center'
)

knitr::opts_chunk$set(out.extra = 'style="display:block; margin:auto;"')

```

# Overview

SpaceMarkers leverages latent feature analysis of the spatial components of 
transcriptomic data to identify biologically relevant molecular interactions 
between cell groups.This tutorial will use the latent features from CoGAPS to 
look at pattern interactions in a Visium 10x breast ductal carcinoma spatial 
transcriptomics dataset.

# Installation

```{r eval = FALSE}
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("SpaceMarkers")
```
```{r message = FALSE, warning = FALSE}
library(SpaceMarkers)
```

# Setup

## Links to Data

The data that will be used to demonstrate SpaceMarkers' capabilities is a human
breast cancer spatial transcriptomics dataset that comes from Visium. The CoGAPS
patterns as seen in the manuscript 
[Atul Deshpande et al.](https://doi.org/10.1016/j.cels.2023.03.004) 
will also be used

```{r}
data_dir <- "visiumBrCA"
unlink(file.path(data_dir), recursive = TRUE)
dir.create(data_dir,showWarnings = FALSE)
main_10xlink <- "https://cf.10xgenomics.com/samples/spatial-exp/1.3.0"
counts_folder <- "Visium_Human_Breast_Cancer"
counts_file <- "Visium_Human_Breast_Cancer_filtered_feature_bc_matrix.h5"
counts_url<-paste(c(main_10xlink,counts_folder,counts_file), collapse = "/")
sp_folder <- "Visium_Human_Breast_Cancer"
sp_file <- "Visium_Human_Breast_Cancer_spatial.tar.gz"
sp_url<-paste(c(main_10xlink,sp_folder,sp_file),collapse = "/")
```


## Extracting Counts Matrix

### load10xExpr

Here the counts matrix will be obtained from the h5 object on the Visium site 
and genes with less than 3 counts are removed from the dataset.This can be
achieved with the load10XExpr function.

```{r}
download.file(counts_url,file.path(data_dir,basename(counts_url)), mode = "wb")
counts_matrix <- load10XExpr(visiumDir = data_dir, h5filename = counts_file)
good_gene_threshold <- 3
goodGenes <- rownames(counts_matrix)[
    apply(counts_matrix,1,function(x) sum(x>0)>=good_gene_threshold)]
counts_matrix <- counts_matrix[goodGenes,]
```

## Obtaining CoGAPS Patterns

In this example the latent features from CoGAPS will be used to identify 
interacting genes with SpaceMarkers. Here the featureLoadings (genes) and 
samplePatterns (barcodes) for both the expression matrix and CoGAPS matrix 
need to match.

```{r}
cogaps_result <- readRDS(system.file("extdata","CoGAPS_result.rds",
    package="SpaceMarkers",mustWork = TRUE))
features <- intersect(rownames(counts_matrix),rownames(
    slot(cogaps_result,"featureLoadings")))
barcodes <- intersect(colnames(counts_matrix),rownames(
    slot(cogaps_result,"sampleFactors")))
counts_matrix <- counts_matrix[features,barcodes]
cogaps_matrix<-slot(cogaps_result,"featureLoadings")[features,]%*%
    t(slot(cogaps_result,"sampleFactors")[barcodes,])
```

## Obtaining Spatial Coordinates

### load10XCoords

The spatial coordinates will also be pulled from Visium for this dataset. 
These are combined with the latent features to demonstrate how cells for each 
pattern interact in 2D space. The data can be extracted with the 
**load10XCoords()** function

```{r}
download.file(sp_url, file.path(data_dir,basename(sp_url)), mode = "wb")
untar(file.path(data_dir,basename(sp_url)), exdir = file.path(data_dir))
spCoords <- load10XCoords(visiumDir = data_dir, 
                          resolution="lowres", version = "1.0")
rownames(spCoords) <- spCoords$barcode
spCoords <- spCoords[barcodes,]
spPatterns <- cbind(spCoords,slot(cogaps_result,"sampleFactors")[barcodes,])
head(spPatterns)
```

For demonstration purposes we will look at two patterns; Pattern_1 (immune cell)
and Pattern_5 (invasive carcinoma lesion). Furthermore we will only look at the
relationship between a pre-curated list of genes for efficiency.

```{r}
data("curated_genes")
spPatterns <- spPatterns[c("barcode","y","x","Pattern_1","Pattern_5")]
counts_matrix <- counts_matrix[curated_genes,]
cogaps_matrix <- cogaps_matrix[curated_genes, ]
```

# Executing SpaceMarkers

## SpaceMarker Modes

SpaceMarkers can operate in 'residual' or 'DE' (DifferentialExpression) mode. 
In an ideal world the overlapping patterns identified by SpaceMarkers would be a
homogeneous population of cells and the relationship between them would be 
linear. However, due to confounding effects of variations in cell density and 
common cell types in any given region, this is not always true.

To account for these confounding effects, the 'residual' mode compares the 
feature interactions between the expression matrix and the reconstructed latent
space matrix. The features with the highest residual error are reported. 
The genes are then classified according to regions of overlapping vs exclusive 
influence. The default mode is 'residual' mode.

However this is not to say there is no utility for DE mode. Suppose the 
feature (gene) information is not readily available and only the sample (cells)
latent feature patterns with P-values are available? This is the advantage of
'DE' mode. Where residual mode assesses the non-linear effects that may arise
from confounding variables, 'DE' mode assesses simple linear interactions 
between patterns directly from expression. DE mode like residual mode also 
compares genes from regions of overlapping vs exclusive influence butdoes not
consider residuals from the expression matrix as there is no matrix 
reconstruction with the latent feature matrix.

### Residual Mode

#### SpaceMarkers Step1: Hotpsots

SpaceMarkers identifies regions of influence using a gaussian kernel outlier 
based model. Spots that have spatial influence beyond the defined outlier 
threshold are termed **hotspots**. SpaceMarkers then identifies where the
hotspots are overlapping/interacting and where they are mutually exclusive.

get_spatial_params_morans_i: This function sets the width of the spatial kernel 
(sigmaOpt) as well as the outlier threshold around the set of spots
(threshOpt) for each pattern. By default, the sigmaOpt is set to the spot 
diameter at the appropriate resolution. Note that the legacy function has been
deprecated and has been renamed to .get_spatial_params_morans_i. Please read the 
documentation for more information.

```{r}
optParams <- get_spatial_params_morans_i(spPatterns,visiumDir = data_dir,
                                          resolution = "lowres")
```

#### SpaceMarkers Step2: Interacting Genes

get_pairwise_interacting_genes: This function identifies the regions of influence 
and interaction as well as the **genes** associated with these regions. 
A non-parametric Kruskal-Wallis test is used to identify statistically 
significant genes in any one region of influence without discerning which region
is more significant. A post hoc Dunn's Test is used for analysis of genes
between regions and can distinguish which of two regions is more significant. 
If 'residual' mode is selected the user must provide a reconstructed matrix from
the latent feature matrix. The matrix is passed to the 'reconstruction' argument
and can be left as NULL for 'DE' mode. The 'data' parameter is the original
expression matrix. The 'spPatterns' argument takes a dataframe with the spatial
coordinates of each cell as well as the patterns. The spatial coordinate columns
must contain the labels 'x' and 'y' to be recognized by the function.
The output of this are all possible pairs fo interactions from the spatial
patterns. 

```{r}
SpaceMarkers <- get_pairwise_interacting_genes(data = counts_matrix,
                                    reconstruction = cogaps_matrix,
                                    optParams = optParams,
                                    spPatterns = spPatterns,
                                    mode ="residual",analysis="overlap")

```

NB: When running get_pairwise_interacting_genes some warnings may be generated. 
The warnings are due to the nature of the 'sparse' data being used. 
Comparing two cells from the two patterns with identical information is 
redundant as SpaceMarkers is identifying statistically different expression for
interactions exclusive to either of the two patterns and a region that is due 
to interaction between the given two patterns. Also, if there are too many 
zeros in the genes (rows) of those regions, the columns are dropped as there 
is nothing to compare in the Kruskal Wallis test.


```{r}
print(head(SpaceMarkers[[1]]$interacting_genes[[1]]))
print(head(SpaceMarkers[[1]]$hotspots))
```

The output is a list of data frames with information about the interacting genes
between patterns from the CoGAPS matrix 
(interacting_genes object). 
There is also a data frame with all of the regions of influence for any two of 
patterns (the hotspotRegions object).

For the 'interacting_genes' data frames, the first column is the list of genes 
and the second column says whether the statistical test were done vsPattern_1,
vsPattern_2 or vsBoth. The remaining columns are statistics
for the Kruskal-Wallis test and the post hoc Dunn's test.The SpaceMarkersMetric
column is a product of sums of the Dunn's statistics and 
is used to rank the genes.

### DE Mode

As described previously 'DE' mode only requires the counts matrix and spatial 
patterns and not the reconstructed CoGAPS matrix. It identifies simpler 
molecular interactions between regions and still executes the 'hotspots' and
'interacting genes' steps of SpaceMarkers

```{r}
SpaceMarkers_DE <- get_pairwise_interacting_genes(
    data=counts_matrix,reconstruction=NULL,
    optParams = optParams,
    spPatterns = spPatterns,
    mode="DE",analysis="overlap")
```

### Residual Mode vs DE Mode: Differences

One of the first things to notice is the difference in the number 
of genes identified between the two modes.  

```{r}
residual_p1_p5<-SpaceMarkers[[1]]$interacting_genes[[1]]
DE_p1_p5<-SpaceMarkers_DE[[1]]$interacting_genes[[1]]
```

```{r}
paste(
    "Residual mode identified",dim(residual_p1_p5)[1],
        "interacting genes,while DE mode identified",dim(DE_p1_p5)[1],
        "interacting genes",collapse = NULL)
```

DE mode produces more genes than residual mode because the matrix of 
residuals highlights less significant differences for confounding genes 
across the spots.The next analysis will show where the top genes rank in each 
mode's list if they are identified at all. A function was created that will take
the top 20 genes of a reference list of genes and compare it to the entire list
of a second list of genes. The return object is a data frame of the gene, the
name of each list and the ranking of each gene as compared to the reference 
list. If there is no gene identified in the second list compared to the 
reference it is classified as NA.

```{r}

compare_genes <- function(ref_list, list2,ref_name = "mode1",
                            list2_name = "mode2", sub_slice = NULL){
    ref_rank <- seq(1,length(ref_list),1)
    list2_ref_rank <- which(list2 %in% ref_list)
    list2_ref_genes <- list2[which(list2 %in% ref_list)]
    ref_genes_only <- ref_list[ !ref_list  %in% list2_ref_genes ]
    mode1 <- data.frame("Gene" = ref_list,"Rank" = ref_rank,"mode"= ref_name)
    mode2 <- data.frame("Gene" = c(list2_ref_genes, ref_genes_only),"Rank" = c(
        list2_ref_rank,rep(NA,length(ref_genes_only))),"mode"= list2_name)
    mode1_mode2 <- merge(mode1, mode2, by = "Gene", all = TRUE) 
    mode1_mode2 <- mode1_mode2[order(mode1_mode2$Rank.x),]
    mode1_mode2 <- subset(mode1_mode2,select = c("Gene","Rank.x","Rank.y"))
    colnames(mode1_mode2) <- c("Gene",paste0(ref_name,"_Rank"),
                                paste0(list2_name,"_Rank"))
    return(mode1_mode2)
}
```

```{r}
res_to_DE <- compare_genes(head(residual_p1_p5$Gene, n = 20),DE_p1_p5$Gene,
                            ref_name="residual",list2_name="DE")
DE_to_res <- compare_genes(head(DE_p1_p5$Gene, n = 20),residual_p1_p5$Gene,
                            ref_name = "DE",list2_name = "residual")
```

#### Comparing residual mode to DE mode

```{r}
res_to_DE
```

Here we identify the top 20 genes in 'residual' mode and their corresponding 
ranking in DE mode. HLA-DRB1 is the only gene identified in 
residual mode and not in DE mode. The other genes are ranked relatively high
in both residual and DE mode.

#### Comparing DE mode to residual mode

```{r}
DE_to_res
```

Recall that DE mode looks at the information encoded in the latent feature space
and does not filter out genes based on any confounders between the counts matrix
and latent feature matrix as is done in 'residual' mode. Therefore there are
more genes in DE mode not identified at all in residual mode. 

There is some agreement with interacting genes between the two methods but there
are also quite a few differences. Therefore, the selected mode can significantly
impact the downstream results and should be taken into consideration based on 
the specific biological question being answered and the data available.

## Types of Analyses

Another feature of the SpaceMarkers package is the type of analysis that can be
carried out, whether 'overlap' or 'enrichment' mode. The major difference 
between the two is that enrichment mode includes genes even if they did not 
pass the post-hoc Dunn's test. These additional genes were included to enable a
more statistically powerful pathway enrichment analysis and understand to a 
better extent the impact of genes involved each pathway. 
Changing analysis = 'enrichment' in the get_pairwise_interacting_genes function 
will enable this.

```{r}
SpaceMarkers_enrich <- get_pairwise_interacting_genes(data = counts_matrix,
                                    reconstruction = cogaps_matrix,
                                    optParams = optParams,
                                    spPatterns = spPatterns,
                                    mode ="residual",analysis="enrichment")
SpaceMarkers_DE_enrich <- get_pairwise_interacting_genes(
    data=counts_matrix,reconstruction=NULL,
    optParams = optParams,
    spPatterns = spPatterns,
    mode="DE",analysis="enrichment")
residual_p1_p5_enrichment<-SpaceMarkers_enrich[[1]]$interacting_genes[[1]]$Gene
DE_p1_p5_enrichment<-SpaceMarkers_DE_enrich[[1]]$interacting_genes[[1]]$Gene

```

### Residual Mode vs DE Mode: Enrichment

The data frames for the Pattern_1 x Pattern_5 will be used to compare the 
results of the enrichment analyses

```{r}
enrich_res_to_de<-compare_genes(
    head(DE_p1_p5_enrichment, 20),
    residual_p1_p5_enrichment,
    ref_name="DE_Enrich",list2_name = "res_Enrich")
enrich_res_to_de
```

The ranks differ alot more here because now genes that were not previously 
ranked are assigned a score.

```{r}
overlap_enrich_de<-compare_genes(
    head(DE_p1_p5_enrichment,20),
    DE_p1_p5$Gene,
    ref_name="DE_Enrich",
    list2_name="DE_Overlap")
overlap_enrich_de
```

The enrichment and overlap analysis are in great agreement for DE mode.
Typically, you may see more changes among genes lower in the ranking. This is 
especially important where genes that do not pass the Dunn's test for 
interactions between any of the other two patterns in the overlap analysis are 
now ranked in enrichment analysis. The Pattern_1 x Pattern_5 entry for these 
genes is labelled as **FALSE**. 

Here is an example of the statistics for such genes. 

```{r}
tail(SpaceMarkers_DE_enrich[[1]]$interacting_genes[[1]])
```

The rankings of genes between the overlap and enrichment
analysis in residual mode are comparable as well. 

```{r}
overlap_enrich_res<-compare_genes(
    head(residual_p1_p5$Gene, 20),
    residual_p1_p5_enrichment,
    ref_name ="res_overlap",list2_name="res_enrich")
overlap_enrich_res
```

# Visualizing SpaceMarkers


## Loading Packages

The following libraries are required to make the plots and summarize dataframes

```{r message = FALSE, warning=FALSE}
library(Matrix)
library(rjson)
library(cowplot)
library(RColorBrewer)
library(grid)
library(readbitmap)
library(dplyr)
library(data.table)
library(viridis)
library(ggplot2)
```


The two main statistics used to help interpret the expression of genes across 
the patterns are the KW statistics/pvalue and the Dunn's test. In this context
the null hypothesis of the KW test is that the expression of a given gene across
all of the spots is equal. The post hoc Dunn's test identifies how statistically
significant the difference in expression of the given gene is between two 
patterns. The Dunn's test considers the differences between specific patterns 
and the KW test considers differences across all of the spots without 
considering the specific patterns. Ultimately, we summarize and rank these
effects with the SpaceMarkersMetric.

We will look at the top few genes based on our SpaceMarkersMetric


```{r}
res_enrich <- SpaceMarkers_enrich[[1]]$interacting_genes[[1]]
hotspots <- SpaceMarkers_enrich[[1]]$hotspots
top <- res_enrich %>% arrange(-SpaceMarkersMetric)
print(head(top))
```

## Code Setup

The plot_spatial_data_over_image function allows you to look at the 
deconvoluted patterns on the tissue image. We can compare these spatial maps to
the expression of genes identified interacting genes on violin plots. 

```{r}
createInteractCol <- function(spHotspots, 
                              interaction_cols = c("T.cells","B-cells")){
  col1 <- spHotspots[,interaction_cols[1]]
  col2 <- spHotspots[,interaction_cols[2]]
  one <- col1
  two <- col2
  one[!is.na(col1)] <- "match"
  two[!is.na(col2)] <- "match"
  both_idx <- which(one == two)
  both <- col1
  both[both_idx] <- "interacting"
  one_only <- setdiff(which(!is.na(col1)),unique(c(which(is.na(col1)),
                                                   both_idx)))
  two_only <- setdiff(which(!is.na(col2)),unique(c(which(is.na(col2)),
                                                   both_idx)))
  both[one_only] <- interaction_cols[1]
  both[two_only] <- interaction_cols[2]
  both <- factor(both,levels = c(interaction_cols[1],"interacting",
                                 interaction_cols[2]))
  return(both)
}

#NB: Since we are likely to plot multipe genes, this function assumes an
#already transposed counts matrix. This saves time and memory in the long run
#for larger counts matrices
plotSpatialExpr <- function(data,gene,hotspots,patterns,
                               remove.na = TRUE,
                               title = "Expression (Log)", text_size = 15){
  counts <- data
  interact <- createInteractCol(spHotspots = hotspots,
                                interaction_cols = patterns)
  df <- cbind(counts,hotspots,data.frame("region" = interact))
  if (remove.na){
    df <- df[!is.na(df$region),]
  }
  p <- df %>% ggplot( aes_string(x='region',y=gene,
                                            fill='region')) + geom_violin() +
    scale_fill_viridis(discrete = TRUE,alpha=0.6) +
    geom_jitter(color="black",size=0.4,alpha=0.9) +
    theme(legend.position="none",plot.title = element_text(size=text_size),
            axis.text.x = element_text(angle = 90, vjust = 0.5, hjust=1)) +
    ggtitle(paste0(gene,": ",title)) + xlab("")
  return(p)
}



```

## Get the Spatial Data

Let's transpose the counts matrix and combine the expression information with
the spatial information. 

```{r}
genes <- top$Gene
counts_df <- as.data.frame(as.matrix(
  t(counts_matrix[rownames(counts_matrix) %in% genes,])))

```

## Generate Plots

```{r suppressMessages=TRUE, warning=FALSE}
spatialMaps <- list()
exprPlots <- list()

for (g in genes){
  
    spatialMaps[[length(spatialMaps)+1]] <- suppressMessages(
        plot_spatial_data_over_image(visiumDir = data_dir,
                                                         df = cbind(spPatterns, counts_df),feature_col = g,
                                                         resolution="lowres",title = g))
  exprPlots[[length(exprPlots)+1]] <- plotSpatialExpr(
    data = counts_df,gene = g,hotspots = hotspots,
                   patterns = c("Pattern_1","Pattern_5"))
}
```

Below  are violin plots and spatial heatmaps to help visualize the expression
of individual genes across different patterns. 

### Pattern_1

```{r, message=FALSE, warning=FALSE, dpi=60, fig.width=6}

plot_spatial_data_over_image(visiumDir = data_dir,
                         df = cbind(spPatterns, counts_df),
                         feature_col = "Pattern_1",
                         resolution="lowres",title = "Pattern_1")
```

### Pattern_5

```{r, message=FALSE, warning=FALSE, dpi=60, fig.width=6}


plot_spatial_data_over_image(visiumDir = data_dir,
                         df = cbind(spPatterns, counts_df),
                         feature_col = "Pattern_5",
                         resolution="lowres",title = "Pattern_5")

```

On the spatial heatmap, Pattern_5, the invasive carcinoma pattern, is 
more prevalent on the bottom left of the tissue image. Where as Pattern_1,
the immune pattern is prevalent along the diagonal of the tissue image.

### Top SpaceMarkers

```{r, message=FALSE, warning=FALSE, dpi=60, fig.width=6}
plot_grid(plotlist = list(exprPlots[[1]],spatialMaps[[1]]))

```

APOE is expressed highly across all patterns but is especially strong in the 
interacting pattern. This is a good example of a SpaceMarker that is  highly 
expressed in the interacting region relative to both Pattern_1 and Pattern_5. 
The second gene also has a similar expression profile. 


```{r, message=FALSE,dpi=60, fig.width=6}
plot_grid(plotlist = list(exprPlots[[3]],spatialMaps[[3]]))
```

This gene is not as highly expressed in the tissue as the previous genes but
still shows higher and specific expression in the interacting region relative to
either Pattern_1 and Pattern_5 hence why it is still highly ranked by the 
SpaceMarkersMetric.

### Negative SpaceMarkersMetric

More negative SpaceMarkersMetric highlights that the expression of a gene in the
interacting region is **lower** relative to either pattern.

```{r}
bottom <- res_enrich %>% arrange(SpaceMarkersMetric)
print(head(bottom))
```

```{r warning=FALSE}
g <- bottom$Gene[1]
p1 <- plotSpatialExpr(
    data = counts_df,gene = g,hotspots = hotspots, 
                   patterns = c("Pattern_1","Pattern_5"))
p2 <- plot_spatial_data_over_image(visiumDir = data_dir,
                         df = cbind(spPatterns, counts_df),
                         feature_col = g,
                         resolution="lowres",title = g)

plot_grid(plotlist = list(p1,p2))

```


# Removing Directories

```{r}
unlink(file.path(data_dir), recursive = TRUE)
```

# References

Deshpande, Atul, et al. "Uncovering the spatial landscape of molecular 
interactions within the tumor microenvironment through latent spaces." 
Cell Systems 14.4 (2023): 285-301.

“Space Ranger.” Secondary Analysis in R -Software -Spatial Gene Expression -
Official 10x Genomics Support, 
support.10xgenomics.com/spatial-gene-expression/software/pipelines/latest/rkit. 
Accessed 22 Dec. 2023. 

## load10XExpr() Arguments

```{r echo=FALSE}
parameters = c('visiumDir', 'h5filename')
paramDescript = c('A string path to the h5 file with expression information',
                    'A string of the name of the h5 file in the directory')
paramTable = data.frame(parameters, paramDescript)
knitr::kable(paramTable, col.names = c("Argument","Description"))

```

## load10XCoords() Arguments

```{r echo=FALSE}
parameters = c('visiumDir', 'resolution')
paramDescript = c(
'A path to the location of the the spatial coordinates folder.',
'String values to look for in the .json object;lowres or highres.')
paramTable = data.frame(parameters, paramDescript)
knitr::kable(paramTable, col.names = c("Argument","Description"))

```

## get_spatial_params_morans_i() Arguments

```{r echo=FALSE}
parameters = c('spPatterns','visiumDir','spatialDir','pattern','sigma',
               'threshold','resolution')
paramDescript = c('A data frame of spatial coordinates and patterns.',
                  'A directory with the spatial and expression data for 
                  the tissue sample',
                  'A directory with spatial data for the tissue sample',
                  'A string of the .json filename with the image parameters',
                  'A numeric value specifying the kernel distribution width',
                  'A numeric value specifying the outlier threshold for the 
                  kernel',
                  'A string specifying the image resolution to scale')
paramTable = data.frame(parameters, paramDescript)
knitr::kable(paramTable, col.names = c("Argument","Description"))

```

## get_pairwise_interacting_genes() Arguments

```{r echo=FALSE}
parameters = c(
        'data','reconstruction', 'optParams','spPatterns',
        'mode', 'minOverlap','hotspotRegions','analysis')
paramDescript = c(
        'An expression matrix of genes and columns being the samples.',
        'Latent feature matrix. NULL if \'DE\' mode is specified',
        'A matrix of sigmaOpts (width) and the thresOpt (outlierthreshold)',
        'A data frame that contains of spatial coordinates and patterns.',
        'A string of the reference pattern for comparison to other patterns',
        'A string specifying either \'residual\' or \'DE\' mode.',
        'A value that specifies the minimum pattern overlap. 50 is the default',
        'A string specifying the type of analysis')
paramTable = data.frame(parameters, paramDescript)
knitr::kable(paramTable, col.names = c("Argument","Description"))

```

```{r}
sessionInfo()
```

---
title: "test-args"
date: "`r Sys.time()`"
output:
  html_document: 
    toc: TRUE
    toc_float: TRUE
    toc_depth: 4
    code_folding: show
    theme: united
    df_print: paged
    self_contained: TRUE
params:
    deconvResult:
    dataDir:
    workdir: 'text'
    timestamp: !r Sys.Date()
    auto_save: TRUE
---

```{r}
print(params)
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{get_im_scores}
\alias{get_im_scores}
\title{get_im_scores}
\usage{
get_im_scores(SpaceMarkers)
}
\arguments{
\item{SpaceMarkers}{A list of SpaceMarkers objects}
}
\value{
A data frame with columns Gene and SpaceMarkersMetric
}
\description{
Get the interaction scores for SpaceMarkers
}
\examples{
example(get_pairwise_interacting_genes)
get_im_scores(SpaceMarkers)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getSpatialParameters.R
\name{get_spatial_parameters}
\alias{get_spatial_parameters}
\title{Read optimal parameters for spatial kernel density from user input or .json
file}
\usage{
get_spatial_parameters(
  spatialPatterns,
  visiumDir = ".",
  spatialDir = "spatial",
  pattern = "scalefactors_json.json",
  sigma = NULL,
  threshold = 4,
  resolution = c("fullres", "lowres", "hires"),
  ...
)
}
\arguments{
\item{spatialPatterns}{A data frame that contains the spatial coordinates
for each cell type. The column names must include 'x' and 'y' as well as a
set of numbered columns named  'Pattern_1.....N'.}

\item{visiumDir}{A string path specifying the location of the 10xVisium
directory}

\item{spatialDir}{A string path specifying the location of the spatial folder
containing the .json file of the spot characteristics}

\item{pattern}{A string specifying the name of the .json file}

\item{sigma}{A numeric value specifying the width of the kernel density
estimate to be used for smoothing}

\item{threshold}{A numeric value specifying how many standard deviations
above the mean of a null distribution to use an outlier threshold for
identifying 'hotspots'}

\item{resolution}{A string specifying image resolution to be used for spot
diameter. Can take values of "fullres" (default), "lowres" or "hires".}

\item{...}{Arguments passed to methods}
}
\value{
a numeric matrix of sigmaOpts - the optimal width of the gaussian
distribution, and the threshOpt - outlier threshold around the set of spots
for each pattern
}
\description{
This function obtains the width of a spatial kernel density
(sigma) from either the user input or from a scale factors .json file.
The outlier threshold around the set of spots (threshold) for each pattern is
specified  by the user (default is 4).
}
\examples{
library(SpaceMarkers)
# Create test data
cells <- c()
test_num <- 500
for(i in 1:test_num){
    cells[length(cells)+1] <- paste0("cell_",i)
}
spPatterns <- data.frame(barcode = cells,
y = runif(test_num, min=0, max=test_num),
x = runif(test_num, min=0, max=test_num),
Pattern_1 = runif(test_num, min=0, max=1),
Pattern_2 = runif(test_num, min=0, max=1) )
# Call the get_spatial_parameters function with the test data
optParams <- get_spatial_parameters(spPatterns, sigma = 10)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hdutils.R
\name{.calc_threshold}
\alias{.calc_threshold}
\title{Compute the threshold for identifying outlier values or hotspots}
\usage{
.calc_threshold(df, minval = 0.01, maxval = 0.99, method = c("abs", "pct"))
}
\arguments{
\item{df}{A vector containing pattern values}

\item{minval}{Minimum value for quantile threshold}

\item{maxval}{Maximum value for quantile threshold}

\item{method}{Method to use for threshold calculation. Options are "abs" for absolute (default) and "pct" for percentile.}
}
\value{
A list containing the computed thresholds
}
\description{
This function computes the threshold for identifying outlier
values or hotspots by fitting a normal mixture model to the data.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{calculate_lr_scores}
\alias{calculate_lr_scores}
\title{calculate_lr_scores}
\usage{
calculate_lr_scores(
  ligand_scores,
  receptor_scores,
  lr_pairs,
  ligand_test = c("greater", "two.sided"),
  method = c("geometric_mean", "arithmetic_mean"),
  weighted = TRUE
)
}
\arguments{
\item{ligand_scores}{Output from getGeneSetScore for ligands}

\item{receptor_scores}{Output from getGeneSetScore for receptors}

\item{lr_pairs}{Data frame with columns 'ligand' and 'receptor'}

\item{ligand_test}{Character; specifies the type of test for ligand overexpression. Options are "greater" or "two.sided"}

\item{method}{Character; specifies the aggregation method for L-R scores. Options are "
geometric_mean" or "arithmetic_mean"}

\item{weighted}{Logical; if TRUE, L-R scores are weighted by their occurrence in
multiple L-R pairs}
}
\value{
Data frame with L-R scores and p-values
}
\description{
Calculate L-R pair scores using Fisher's method
}
\details{
This function computes L-R pair scores by combining ligand and receptor
overexpression scores using either geometric or arithmetic mean. It can also
weight L-R pairs based on their presence in multiple pairs to reduce bias from
promiscuous ligands or receptors.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocessing.R
\name{get_spatial_features}
\alias{get_spatial_features}
\title{Load spatial features}
\usage{
get_spatial_features(filePath, method = NULL, featureNames = ".")
}
\arguments{
\item{filePath}{A string path to the location of the file containing the
spatial features.}

\item{method}{A string specifying the type of object to obtain spatial
feature from. Default NULL, where the method is inferred based on object
type. Other methods are: "CoGAPS", "Seurat", or "BayesTME".}

\item{featureNames}{An array of strings specifying the column names
corresponding to the feature names or a regex string. In the case of Seurat,
all metadata columns with "_Feature" suffix are selected.}
}
\value{
a matrix of spatial features with barcodes associated
with individual coordinates
}
\description{
This function loads spatial features from a file containing
spatial features
}
\examples{
library(SpaceMarkers)
#CoGAPS data filePath
filePath <- system.file("extdata","CoGAPS_result.rds", 
package = "SpaceMarkers",mustWork = TRUE)
spFeatures <- get_spatial_features(filePath, method = "CoGAPS")
head(spFeatures)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{plot_spatial_data_over_image}
\alias{plot_spatial_data_over_image}
\title{plotSpatialDataOverImage}
\usage{
plot_spatial_data_over_image(
  visiumDir,
  df,
  feature_col,
  barcode_col = "barcode",
  resolution = c("lowres", "hires", "fullres"),
  version = NULL,
  colors = NULL,
  point_size = 2.5,
  stroke = 0.05,
  alpha = 0.5,
  title = "Spatial Heatmap",
  bg_color = NULL,
  crop = TRUE,
  text_size = 15
)
}
\arguments{
\item{visiumDir}{directory with a spatial folder containing
scalefactors_json.json, images (lowres,or hires), and
coordinates (tissue_positons_(list).csv or probe.csv)}

\item{df}{a dataframe with the features of interest. For example,
can behotspots (character), and/or influence (numeric))}

\item{feature_col}{feature to plot over spots, Default: NULL}

\item{barcode_col}{barcode column name to match with coordinates,
Default: 'barcode'}

\item{resolution}{Image resoultion to scale coordinates too,
Default: c("lowres", "hires", "fullres")}

\item{version}{Visium version. Automatically infers from load10XCoords if
NULL,Default: NULL}

\item{colors}{colors to be displayed over spots. If set to NULL, it
automatically colors the spots red for character values and uses viridis for
numeric values. Default: NULL}

\item{point_size}{size of spots displayed on the plot, Default: 2.5}

\item{stroke}{thickness of spot outline, Default: 0.05}

\item{alpha}{Transparency of the spots, Default: 0.5}

\item{title}{Title displayed on the plot, Default: 'Spatial Heatmap'}

\item{bg_color}{background color of ggplot box, Default: NULL}

\item{crop}{crop spatial plot to a zoomed in window, Default: TRUE}

\item{text_size}{size of text on the plot, Default: 15}
}
\value{
a ggplot object
}
\description{
This function plots spatial data over the complementary
histology image of varing resolutions
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/findGenesOfInterest.R
\name{.find_genes_of_interest}
\alias{.find_genes_of_interest}
\title{.find_genes_of_interest
Identify genes associated with pattern interaction.
This function identifies genes exhibiting significantly higher values of
testMat in the Interaction region of the two
patterns compared to regions with exclusive influence from either
pattern. It uses Kruskal-Wallis test followed by
posthoc analysis using Dunn's Test to identify the genes.}
\usage{
.find_genes_of_interest(testMat, goodGenes, region, fdr.level=0.05,
       analysis=c("enrichment","overlap"),...)
}
\arguments{
\item{testMat}{A matrix of counts with cells as columns and genes as rows}

\item{goodGenes}{A vector of user specified genes expected to interact
a priori. The default for this is NULL as the function can find these genes
itself}

\item{region}{A data frame of the reference pattern regions that overlap
with the other patterns}

\item{fdr.level}{False Discovery Rate. The default value is 0.05.}

\item{analysis}{a character string that specifies the type of analysis to
carry out, whether overlap or enrichment.}

\item{...}{Additional arguments to be passed to lower level functions}
}
\value{
a list of genes exhibiting significantly higher values of testMat in
the Interaction region of the two #' patterns compared to regions with
exclusive influence from either pattern.
}
\description{
.find_genes_of_interest
Identify genes associated with pattern interaction.
This function identifies genes exhibiting significantly higher values of
testMat in the Interaction region of the two
patterns compared to regions with exclusive influence from either
pattern. It uses Kruskal-Wallis test followed by
posthoc analysis using Dunn's Test to identify the genes.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{calculate_gene_set_specificity}
\alias{calculate_gene_set_specificity}
\title{calculate_gene_set_specificity}
\usage{
calculate_gene_set_specificity(
  data,
  spPatterns,
  gene_sets,
  weighted = TRUE,
  method = c("geometric_mean", "arithmetic_mean")
)
}
\arguments{
\item{data}{A numeric matrix or data frame of gene expression values (genes x samples).}

\item{spPatterns}{A data frame or matrix containing spatial pattern information, with columns for cell types and optionally "x", "y", "barcode".}

\item{gene_sets}{A named list of character vectors, where each vector contains gene names for a gene set.}

\item{weighted}{Logical; if TRUE, gene scores are weighted by their occurrence in multiple gene sets.}

\item{method}{Character; specifies the aggregation method for gene set scores. Options are "geometric_mean" or "arithmetic_mean".}
}
\value{
A numeric matrix of gene set specificity scores (gene sets x cell types).
}
\description{
This function computes specificity scores for given gene sets across cell types or spatial patterns.
It uses fold-change scores and p-values to weight gene contributions, and supports both geometric and arithmetic means.
}
\details{
Calculate Gene Set Specificity Scores
\itemize{
\item Genes not present in the data are excluded.
\item Genes with all zero expression are removed.
\item Fold-change scores and p-values are calculated using \code{.calculate_all_fc_scores}.
\item Scores are normalized and weighted by p-value significance.
\item For each gene set, scores are aggregated using the specified method and gene weights.
}
}
\examples{
# Example usage:
# gene_set_scores <- calculate_gene_set_specificity(expr_matrix, spPatterns, gene_sets)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocessing.R
\name{.infer_method}
\alias{.infer_method}
\title{inferMethod
Infer the method used to obtain spatial features}
\usage{
.infer_method(spObject, method)
}
\description{
inferMethod
Infer the method used to obtain spatial features
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{calculate_gene_set_score}
\alias{calculate_gene_set_score}
\title{calculate_gene_set_score}
\usage{
calculate_gene_set_score(
  IMscores,
  gene_sets,
  weighted = TRUE,
  method = c("geometric_mean", "arithmetic_mean")
)
}
\arguments{
\item{IMscores}{A matrix of interaction scores}

\item{gene_sets}{A list of gene sets, where each set is a vector of gene names}

\item{weighted}{Logical; if TRUE, gene scores are weighted by their occurrence in multiple gene sets}

\item{method}{Character; specifies the aggregation method for gene set scores. Options are "geometric_mean" or "arithmetic_mean"}
}
\value{
A matrix of mean interaction scores for genes in each gene set, with
attributes for log p-value sums and number of genes for later fisher combination
}
\description{
Calculate the mean interaction score for a set of genes
}
\details{
This function computes mean interaction scores for given gene sets across cell interactions.
It supports both geometric and arithmetic means, and can weight gene contributions based on their presence in multiple gene sets.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{.pick_image}
\alias{.pick_image}
\title{.pick_image}
\usage{
.pick_image(sp_dir, res)
}
\arguments{
\item{sp_dir}{path to the spatial directory}

\item{res}{a character string specifying the resolution of the image}
}
\value{
a character string of the image file name
}
\description{
The function picks the appropriate histology image file from the
spatial directory based on the specified resolution.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{optParams}
\alias{optParams}
\title{Optimal paramters of 5 patterns from CoGAPS.}
\format{
A data frame with 2 rows and 5 columns:
\describe{
\item{Pattern_1}{immune cell pattern paramters }
\item{Pattern_2}{Disp.1 parameters}
\item{Pattern_3}{intraductal carcinoma (DCIS) parameters }
\item{Pattern_4}{Disp.2 parameters }
\item{Pattern_5}{invasive carcinoma lesion pattern paramters }
}
}
\value{
A matrix of optimal parameters for patterns identified by CoGAPS
}
\description{
A dataset with the optimal width of the gaussian distribution (sigmaOpt) and
the outlier threshold around the set of spots (thresOpt) for each pattern
obtained from CoGAPS. CoGAPS was ran on spatial transcriptomic data from a
breast cancer sample.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hdutils.R
\name{calculate_gene_scores_directed}
\alias{calculate_gene_scores_directed}
\title{Calculate interaction scores for all pattern pairs}
\usage{
calculate_gene_scores_directed(
  data,
  pat_hotspots,
  influence_hotspots,
  pattern_pairs = NULL,
  ...
)
}
\arguments{
\item{data}{A numeric matrix with genes as rows and barcodes as columns.}

\item{pat_hotspots}{A data frame with pattern hotspots, containing columns for x, y, and barcode.}

\item{influence_hotspots}{A data frame with influence hotspots, containing columns for x, y, and barcode.}

\item{pattern_pairs}{A data frame with pattern pairs to calculate interaction scores for. If NULL,
all combinations of patterns in \code{pat_hotspots} will be used.
If provided, it should have two columns with pattern names.
Each row should represent a pair of patterns for which interaction scores will be calculated.}

\item{...}{Additional parameters to pass to lower level functions.}
}
\value{
A data frame with interaction scores for all pattern pairs.
}
\description{
This function calculates interaction scores for all pattern pairs
using the \code{.calc_IM_scores} function. It can run in parallel if BiocParallel is available.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getInteractingGenes.R
\name{find_all_hotspots}
\alias{find_all_hotspots}
\title{Find hotSpots for all spatial patterns}
\usage{
find_all_hotspots(
  spPatterns,
  params = NULL,
  outlier = "positive",
  nullSamples = 1000,
  includeSelf = TRUE,
  ...
)
}
\arguments{
\item{spPatterns}{A data frame that contains the spatial coordinates
and metrics for spatial features (cell types/cell processes). The column
names must include 'x' and 'y' as well as the spatially varying features.}

\item{params}{a named vector of the optimal sigma and threshold for a
given spatial pattern. The names are should be 'sigmaOpt' and 'threshOpt'.
The default value is NULL.}

\item{outlier}{a character string specifying whether to apply the
outlier threshold to the kernel density distribution in a one-sided manner
(specify 'positive' the default) or in a two sided manner (specify
'two.sided').}

\item{nullSamples}{a numeric values specifying the number of spatial patterns
to randomly sample for a null distribution.}

\item{includeSelf}{a logic value specifying whether to consider the
spatial influence the pattern has on surrounding regions only (set to FALSE),
or whether to also consider the influence of the pattern itself (set to TRUE
, the default).}

\item{...}{Arguments passed to methods}
}
\description{
Convenience function to find hotspots for all spatial patterns
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getSpatialParameters.R
\name{get_spatial_params_morans_i}
\alias{get_spatial_params_morans_i}
\title{Calculate the optimal parameters from spatial kernel density for
cell-cell interactions}
\usage{
get_spatial_params_morans_i(spatialPatterns, ...)
}
\arguments{
\item{spatialPatterns}{A data frame that contains the spatial coordinates
for each cell type. The column names must include 'x' and 'y' as well as a
set of numbered columns named  'Pattern_1.....N'.}

\item{...}{Arguments passed to methods}
}
\value{
a numeric matrix of sigmaOpts - the optimal width of the gaussian
distribution, and the threshOpt - outlier threshold around the set of spots
for each pattern
}
\description{
This function uses Morans.I to calculate the optimal width of
the kernel density (sigmaOpt) as well as the outlier threshold around the set
of spots (threshOpt) for a null distribution.
}
\examples{
library(SpaceMarkers)
# Create test data
cells <- c()
test_num <- 500
for(i in 1:test_num){
    cells[length(cells)+1] <- paste0("cell_",i)
}
spPatterns <- data.frame(barcode = cells,
y = runif(test_num, min=0, max=test_num),
x = runif(test_num, min=0, max=test_num),
Pattern_1 = runif(test_num, min=0, max=1),
Pattern_2 = runif(test_num, min=0, max=1) )
# Call the get_spatial_params_morans_i function with the test data
optParams <- get_spatial_params_morans_i(spPatterns)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocessing.R
\name{.get_csv_features}
\alias{.get_csv_features}
\title{.get_csv_features
Load features from dataframe}
\usage{
.get_csv_features(obj)
}
\description{
.get_csv_features
Load features from dataframe
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getInteractingGenes.R
\name{get_pairwise_interacting_genes}
\alias{get_pairwise_interacting_genes}
\title{get_pairwise_interacting_genes}
\usage{
get_pairwise_interacting_genes(
  data,
  spPatterns,
  mode = c("DE", "residual"),
  optParams = NULL,
  reconstruction = NULL,
  hotspots = NULL,
  minOverlap = 50,
  analysis = c("enrichment", "overlap"),
  pattern_pairs = NULL,
  ...,
  workers = NULL
)
}
\arguments{
\item{data}{original spatial data matrix.}

\item{spPatterns}{A data frame that contains the spatial coordinates
and metrics for spatial features (cell types/cell processes). The column
names must include 'x' and 'y' as well as the spatially varying features.}

\item{mode}{SpaceMarkers mode of operation. Possible values are
"DE" (the default) or "residual".}

\item{optParams}{a matrix with dimensions 2 X N, where N is the number
of spatial patterns with optimal parameters. The first row contains the
kernel width 'sigmaOpt' for each pattern, and the second row is the
threshOpt (outlier threshold) for each pattern. Users can also input their
preferred param values. The default value is NULL.}

\item{reconstruction}{reconstruction of the data matrix from latent
spaces. Required for "residual" mode.}

\item{hotspots}{a vector that specifies the patterns to compare
to the 'refPattern'. The default is NULL which indicates that all patterns
would be compared to the 'refPattern'.}

\item{minOverlap}{a number that specifies the minimum overlap between
genes in two patterns to be considered for the statistical tests.
The default is 50.}

\item{analysis}{a character string that specifies the type of downstream
analysis to be performed. Possible values are "enrichment" (default)
and "overlap". In enrichment mode, all genes are returned, ranked by
the SpaceMarkers metric. In overlap mode, only the genes which are
significantly overexpressed in the interaction region are returned.}

\item{pattern_pairs}{A matrix of pattern pairs to be analyzed. Default is}

\item{...}{Arguments passed to methods}

\item{workers}{(optional) Number of workers to
be used for parallel processing.}
}
\value{
a list of data frames for each pattern with 1) names of the patterns
(patterns object) 2) data frame with the hotspots of influence for the
two patterns (the hotspots object). 3) data frame with the genes
associated with the interaction between the two patterns
(interacting genes object, empty if insufficient interaction).
}
\description{
Performs pairwise analysis to find genes associated with
spatial interaction between pairs of spatially varying patterns.
}
\details{
================
}
\examples{
library(SpaceMarkers)
#Visium data links
urls <- read.csv(system.file("extdata","visium_data.txt",
package="SpaceMarkers",mustWork = TRUE))
counts_url <- urls[["visium_url"]][1]
sp_url <- urls[["visium_url"]][2]
#Remove present Directories if any
unlink(basename(sp_url))
unlink("spatial", recursive = TRUE)
files <- list.files(".")[grepl(basename(counts_url),list.files("."))]
unlink(files)
download.file(counts_url,basename(counts_url), mode = "wb")
counts_matrix<-load10XExpr(visiumDir=".",
h5filename = basename(counts_url))
#Obtaining CoGAPS Patterns
cogaps_result <- readRDS(system.file("extdata","CoGAPS_result.rds",
package="SpaceMarkers",mustWork = TRUE))
features <- intersect(rownames(counts_matrix),rownames(
    slot(cogaps_result,"featureLoadings")))
barcodes <- intersect(colnames(counts_matrix),rownames(
    slot(cogaps_result,"sampleFactors")))
counts_matrix <- counts_matrix[features,barcodes]
cogaps_matrix <- slot(cogaps_result,"featureLoadings")[features,]\%*\%
    t(slot(cogaps_result,"sampleFactors")[barcodes,])
#Obtaining Spatial Coordinates
download.file(sp_url, basename(sp_url), mode = "wb")
untar(basename(sp_url))
spCoords <- load10XCoords(visiumDir = ".", version = "1.0")
rownames(spCoords) <- spCoords$barcode
spCoords <- spCoords[barcodes,]
spPatterns <- cbind(spCoords,
slot(cogaps_result,"sampleFactors")[barcodes,])
data("curated_genes")
spPatterns<-spPatterns[c("barcode","y","x","Pattern_1",
"Pattern_3","Pattern_5")]
counts_matrix <- counts_matrix[curated_genes,]
cogaps_matrix <- cogaps_matrix[curated_genes, ]
optParams <- matrix(c(6, 2, 6, 2, 6, 2), nrow = 2)
rownames(optParams) <- c("sigmaOpt","threshOpt")
colnames(optParams) <- c("Pattern_1","Pattern_3","Pattern_5")
SpaceMarkersMode <- "DE"
pattern_pairs <- matrix(c("Pattern_1", "Pattern_1", 
           "Pattern_3", "Pattern_5"), nrow=2)
SpaceMarkers <- get_pairwise_interacting_genes(
    data=counts_matrix,reconstruction=NULL,
    optParams = optParams,
    spPatterns = spPatterns,
    mode="DE",analysis="enrichment", pattern_pairs=pattern_pairs)
#Remove present Directories if any
unlink(basename(sp_url))
unlink("spatial", recursive = TRUE)
files <- list.files(".")[grepl(basename(counts_url),list.files("."))]
unlink(files)

}
\seealso{
Other getIntGenes: 
\code{\link{find_pattern_hotspots}()},
\code{\link{get_interacting_genes}()}
}
\concept{getIntGenes}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hdutils.R
\name{calculate_influence}
\alias{calculate_influence}
\title{Compute the spatial influence of a spatial feature}
\usage{
calculate_influence(spPatterns, optParams, ...)
}
\arguments{
\item{spPatterns}{A data frame containing x, y coordinates and pattern name}

\item{optParams}{A data frame with optimal parameters for the pattern}

\item{...}{Additional parameters for the Smooth function}
}
\value{
A data frame with the spatial influence of the specified pattern
}
\description{
This function computes the spatial influence of a specified pattern
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hdutils.R
\name{find_hotspots_gmm}
\alias{find_hotspots_gmm}
\title{Find hotspots for all patterns or influences based on values}
\usage{
find_hotspots_gmm(df, threshold = 0.1, ...)
}
\arguments{
\item{df}{A data frame with pattern values (optionally
with x, y, barcode columns)}

\item{threshold}{a scalar or vector of thresholds for each column in the data frame.
Either user provided or the output of @calculate_thresholds}

\item{...}{Additional parameters to pass to lower level functions}
}
\value{
a data frame with the same dimensions as the input data frame.
}
\description{
Convenience function to find hotspots for all spatial patterns
or influence dataframes based on provided thresholds
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotLRCircos.R
\name{plot_target_from_sources_circos}
\alias{plot_target_from_sources_circos}
\title{Plot Ligand-Receptor Interactions from Multiple Source to a Single Target Cell Type}
\usage{
plot_target_from_sources_circos(
  lr_interactions_df,
  source_cell_names,
  target_cell_name,
  cell_order = NULL,
  gap_degree_after_sector = 5,
  track_height_molecules = 0.1,
  molecule_label_cex = 0.6,
  cell_label_cex = 0.9,
  link_transparency = 0.5,
  link_connection_rou = 0.7,
  link_arrowhead_type = "triangle",
  link_arrowhead_width = 0.1,
  link_arrowhead_length = 0.1,
  score_color_palette_fun = NULL,
  split_segments_for_links = TRUE,
  link_buffer_fraction = 0.1,
  scale_link_width_by_score = FALSE,
  score_transform_for_width = function(s) s,
  use_individual_molecule_colors = TRUE,
  default_ligand_color = "lightgreen",
  default_receptor_color = "lightblue",
  individual_ligand_palette_generator = NULL,
  individual_receptor_palette_generator = NULL,
  molecule_segment_border_col = NA,
  inter_molecule_segment_gap = 0.1
)
}
\arguments{
\item{lr_interactions_df}{A data.frame with columns: \code{ligand}, \code{receptor},
\code{source_cell_type}, \code{target_cell_type}, \code{score}.}

\item{source_cell_names}{Character vector, names of source cell types to show.}

\item{target_cell_name}{Character, name of the single target cell type.}

\item{cell_order}{Optional character vector for specific cell type ordering.
If NULL, target cell is first, then sources alphabetically.}

\item{gap_degree_after_sector}{Numeric, gap in degrees after each sector. Default is 5.}

\item{track_height_molecules}{Numeric, height of the track for molecule segments. Default is 0.1.}

\item{molecule_label_cex}{Numeric, cex for molecule labels. Default is 0.6.}

\item{cell_label_cex}{Numeric, cex for cell type labels. Default is 0.9.}

\item{link_transparency}{Numeric, alpha for links (0 to 1). Default is 0.5.}

\item{link_connection_rou}{Numeric (0-1) or vector of two for \code{rou} in \code{circos.link}. Default is 0.7.}

\item{link_arrowhead_type}{Character. Type of arrowhead (e.g., "triangle", "big.arrow"). Default is "big.arrow".}

\item{link_arrowhead_width}{Numeric. Width of the arrowhead. Default uses circlize default.}

\item{link_arrowhead_length}{Numeric. Length of the arrowhead. Default uses circlize default.}

\item{score_color_palette_fun}{A function (e.g., from \code{circlize::colorRamp2}) to map scores to colors.}

\item{split_segments_for_links}{Logical. If TRUE, molecule segments are sized by interaction count/score
and links connect to unique sub-segments. Default is TRUE.}

\item{link_buffer_fraction}{Numeric (0 to <0.5). Buffer around each link within its sub-segment.
Applies if \code{split_segments_for_links} is TRUE. Default is 0.1.}

\item{scale_link_width_by_score}{Logical. If TRUE (and \code{split_segments_for_links} is TRUE),
link/sub-segment width is proportional to score. Default is FALSE.}

\item{score_transform_for_width}{Function to transform scores for width scaling. Default is \code{function(s) s}.}

\item{use_individual_molecule_colors}{Logical. If TRUE, each unique ligand/receptor name gets a distinct color.
Default is TRUE.}

\item{default_ligand_color}{Character, color for all ligand segments if \code{use_individual_molecule_colors} is FALSE.
Default is "lightgreen".}

\item{default_receptor_color}{Character, color for all receptor segments if \code{use_individual_molecule_colors} is FALSE.
Default is "lightblue".}

\item{individual_ligand_palette_generator}{Function (takes n, returns n colors) for unique ligands.
Default generates a green palette.}

\item{individual_receptor_palette_generator}{Function (takes n, returns n colors) for unique receptors.
Default generates a blue palette.}

\item{molecule_segment_border_col}{Color for the border of L/R segments. Default \code{NA} (no border).}

\item{inter_molecule_segment_gap}{Numeric, gap between L/R segments on the same track. Default is 0.1.}
}
\value{
Invisibly returns NULL. The function is called for its side effect of creating a plot.
}
\description{
Visualizes ligand-receptor interactions focusing on a single target cell type
and its incoming interactions from a specified set of source cell types. Only
relevant ligands from the source cells and receptors on the target cell are shown.
}
\examples{
\dontrun{
if (requireNamespace("circlize", quietly = TRUE) &&
    requireNamespace("RColorBrewer", quietly = TRUE)) {
  # Use the same test data from previous examples
  test_lr_data <- data.frame(
    ligand = c("LGF1","LGF1","LGF2","LGF3","LGF4","LGF1","LGF5","LGF6","LGF5"),
    receptor = c("REC1","REC2","REC1","REC1","REC5","REC4","REC4","REC6","REC2"),
    source_cell_type = c("CellA","CellA","CellB","CellC","CellA","CellD","CellD","CellE","CellD"),
    target_cell_type = c("CellB","CellC","CellA","CellD","CellD","CellA","CellD","CellF","CellA"),
    score = c(4.0,2.5,3.0,2.2,1.5,1.0,3.5,0.5,2.8),
    stringsAsFactors = FALSE
  )
  # Plot interactions from CellB and CellD converging on CellA
  # plot_target_from_sources_circos(test_lr_data,
  #                             source_cell_names = c("CellB", "CellD"),
  #                             target_cell_name = "CellA")

  # Another example: Interactions from CellA and CellC targeting CellD
  # plot_target_from_sources_circos(test_lr_data,
  #                             source_cell_names = c("CellA", "CellC"),
  #                             target_cell_name = "CellD",
  #                             scale_link_width_by_score = TRUE)
 }
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hdutils.R
\name{.row_t_test}
\alias{.row_t_test}
\title{Perform row-wise t-tests from scratch}
\usage{
.row_t_test(in.data, region, min_bins = 50, ...)
}
\arguments{
\item{in.data}{A numeric matrix. Rows represent features, columns represent samples.}

\item{region}{A factor or vector indicating the group membership for each column of \code{in.data}.
Must have exactly two levels/unique values. Its length must equal \code{ncol(in.data)}.}

\item{min_bins}{Minimum number of non-missing observations required in each group to perform the t-test.}

\item{...}{Additional parameters to pass to the t-test function.}
}
\value{
A matrix with rows corresponding to the features and columns:
- \code{statistic}: The calculated t-statistic.
- \code{p.value}: The calculated two-sided p-value.
- \code{n1}: Number of non-missing observations in group 1 for that row.
- \code{n2}: Number of non-missing observations in group 2 for that row.
}
\description{
This function iterates over the rows of a matrix and performs a
t-test comparing two groups of columns. It calculates the t-statistic, p-value,
and sample sizes without relying on \code{stats::t.test()} for the core logic.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{lrdf}
\alias{lrdf}
\title{Curated Ligand-receptor interaction genes
A list of vectors with genes associated with ligand-receptor interactions from CellChat database}
\format{
A data frame with LR interaction genes
}
\value{
A list of vectors of LR genes
}
\description{
Curated Ligand-receptor interaction genes
A list of vectors with genes associated with ligand-receptor interactions from CellChat database
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{curated_genes}
\alias{curated_genes}
\title{Curated Genes for example purposes}
\format{
A vector with 114 pre-selected genes
}
\value{
a vector of genes
}
\description{
A vector with genes selected based on previous runs of SpaceMarkers on the
Visium 10x breast ductal carcinoma spatial transcriptomics dataset
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hdutils.R
\name{.calc_IM_scores}
\alias{.calc_IM_scores}
\title{Calculate interaction scores for a specific pattern pair}
\usage{
.calc_IM_scores(
  data,
  pat_hotspots,
  influence_hotspots,
  patternpair,
  avoid_confounders = FALSE,
  ...
)
}
\arguments{
\item{data}{A numeric matrix with genes as rows and barcodes as columns.}

\item{pat_hotspots}{A data frame with pattern hotspots, containing columns for x, y, and barcode.}

\item{influence_hotspots}{A data frame with influence hotspots, containing columns for x, y, and barcode.}

\item{patternpair}{A character vector of length 2 specifying the pattern pair to analyze.}

\item{avoid_confounders}{Logical (default=FALSE) indicating whether to avoid confounding effects due to colocalization.}

\item{...}{Additional parameters to pass to lower level functions.}
}
\value{
A data frame with interaction scores for the specified pattern pair.
}
\description{
This function calculates interaction scores for a specific pattern pair
using the \code{ .classify_spots} function to determine the region of each spot.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocessing.R
\name{.get_BTME_features}
\alias{.get_BTME_features}
\title{.get_BTME_features
Load features BayesTME object}
\usage{
.get_BTME_features(hf)
}
\description{
.get_BTME_features
Load features BayesTME object
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{plot_overlap_scores}
\alias{plot_overlap_scores}
\title{plot_overlap_scores}
\usage{
plot_overlap_scores(
  df,
  title = "Spatial Overlap Scores",
  out = NULL,
  fontsize = 15
)
}
\arguments{
\item{df}{A data frame with columns pattern1, pattern2 and overlapScore}

\item{title}{The title of the plot}

\item{out}{The output path for the plot}

\item{fontsize}{The font size of the plot}
}
\value{
A ggplot object
}
\description{
Plot the overlap scores between patterns in hotspots
}
\examples{
df <- data.frame(pattern1 = c("pattern1","pattern1","pattern2","pattern2"), 
                 pattern2 = c("pattern1","pattern2","pattern1","pattern2"),
                 overlapScore = c(0.5,0.7,0.3,0.9))
plot_overlap_scores(df)
plot_overlap_scores(df, "Overlap Scores", "overlapScores.png", 15)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocessing.R
\name{load10XExpr}
\alias{load10XExpr}
\title{Load 10X Visium Expression Data}
\usage{
load10XExpr(visiumDir = NULL, h5filename = "filtered_feature_bc_matrix.h5")
}
\arguments{
\item{visiumDir}{A string path to the h5 file with expression information.}

\item{h5filename}{A string of the name of the h5 file in the directory.}
}
\value{
A matrix of class dgeMatrix or Matrix that contains the expression
info for each sample (cells) across multiple features (genes)
}
\description{
This loads log-transformed 10X Visium expression data from
standard 10X
Visium folder.
}
\examples{
library(SpaceMarkers)
#Visium data links
urls <- read.csv(system.file("extdata","visium_data.txt",
package = "SpaceMarkers",mustWork = TRUE))
counts_url <- urls[["visium_url"]][1]
#Remove present Directories if any
files <- list.files(".")[grepl(basename(counts_url),list.files("."))]
unlink(files)
download.file(counts_url,basename(counts_url), mode = "wb")
counts_matrix<-load10XExpr(visiumDir=".",h5filename = basename(counts_url))
files <- list.files(".")[grepl(basename(counts_url),list.files("."))]
unlink(files)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocessing.R
\name{load10XCoords}
\alias{load10XCoords}
\title{Load 10x Visium Spatial Coordinates}
\usage{
load10XCoords(
  visiumDir,
  resolution = c("fullres", "lowres", "hires"),
  version = NULL
)
}
\arguments{
\item{visiumDir}{A string path to the location of the folder containing the
spatial coordinates. The folder in your visiumDir must be named 'spatial'
and must contain files 'scalefactors_json.json'
and 'tissue_positions_list.csv.'}

\item{resolution}{A string specifying which values to look for in the .json
object. Can be either fullres (default), lowres or hires.}

\item{version}{A string specifying the version of the spaceranger data.}
}
\value{
a data frame of the spatial coordinates
( x and y) for each spot/cell
}
\description{
This function loads spatial coordinates for each cell from a
10X Visium
spatial folder.
}
\examples{
library(SpaceMarkers)
#Visium data links
urls <- read.csv(system.file("extdata","visium_data.txt",
package = "SpaceMarkers",mustWork = TRUE))
sp_url <- urls[["visium_url"]][2]
# Spatial Coordinates
download.file(sp_url, basename(sp_url), mode = "wb")
untar(basename(sp_url))
spCoords <- load10XCoords(visiumDir = ".", version = "1.0")
unlink("spatial", recursive = TRUE)
unlink("Visium_Human_Breast_Cancer_spatial.tar.gz")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{plot_im_scores}
\alias{plot_im_scores}
\title{plot_im_scores}
\usage{
plot_im_scores(
  df,
  interaction,
  cutOff = 0,
  nGenes = 20,
  geneText = 12,
  metricText = 12,
  increments = 1,
  out = NULL
)
}
\arguments{
\item{df}{A data frame with columns Gene and SpaceMarkersMetric}

\item{interaction}{The interaction to plot}

\item{cutOff}{The cut off value for the plot}

\item{nGenes}{The number of genes to plot}

\item{geneText}{The font size for the gene text}

\item{metricText}{The font size for the metric text}

\item{increments}{The increments for the y-axis}

\item{out}{The output path for the plot}
}
\description{
Plot the top SpaceMarkers IMScores
}
\examples{
example(get_pairwise_interacting_genes)
plot_im_scores(get_im_scores(SpaceMarkers), "Pattern_1_Pattern_3")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{calculate_overlap_undirected}
\alias{calculate_overlap_undirected}
\title{calculate_overlap_undirected}
\usage{
calculate_overlap_undirected(
  hotspots,
  patternList = NULL,
  method = c("Szymkiewicz-Simpson", "Jaccard", "Sorensen-Dice", "Ochiai", "absolute")
)
}
\arguments{
\item{hotspots}{A data frame with columns x, y, barcode and pattern names}

\item{patternList}{A character vector of pattern names to calculate overlap
scores for}

\item{method}{The method to calculate overlap scores. Options are
"Szymkiewicz-Simpson", "Jaccard", "Sorensen-Dice", "Ochiai" and "absolute"}
}
\value{
A data frame with columns pattern1, pattern2 and overlapScore
}
\description{
Calculate the overlap scores between patterns in hotspots
}
\details{
The function calculates the overlap scores between patterns hotspots
using the specified method. The default method is "Szymkiewicz-Simpson"
overlap coefficient.
}
\examples{
hotspots <- data.frame(x = c(1,2,3,4,5),
                        y = c(1,2,3,4,5),
                        barcode = c("A","B","C","D","E"),
                        pattern1 = c("pattern1",NA,"pattern1",NA,"pattern1"),
                        pattern2 = c("pattern2","pattern2",NA,NA,"pattern2"))
calculate_overlap_undirected(hotspots)   
calculate_overlap_undirected(hotspots, c("pattern1","pattern2"))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getInteractingGenes.R
\name{get_interacting_genes}
\alias{get_interacting_genes}
\title{Calculate Interaction Regions and Associated Genes}
\usage{
get_interacting_genes(
  data,
  spPatterns,
  refPattern = "Pattern_1",
  mode = c("DE", "residual"),
  optParams = NULL,
  reconstruction = NULL,
  hotspots = NULL,
  analysis = c("enrichment", "overlap"),
  minOverlap = 50,
  ...
)
}
\arguments{
\item{data}{original spatial data matrix.}

\item{spPatterns}{A data frame that contains the spatial coordinates
and metrics for spatial features (cell types/cell processes). The column
names must include 'x' and 'y' as well as the spatially varying features.}

\item{refPattern}{a character string that specifies the pattern whose
"interaction" with every other pattern we want
to study. The default value is "Pattern_1".}

\item{mode}{SpaceMarkers mode of operation. Possible values are
"DE" (the default) or "residual".}

\item{optParams}{a matrix with dimensions 2 X N, where N is the number
of spatial patterns with optimal parameters. The first row contains the
kernel width 'sigmaOpt' for each pattern, and the second row is the
threshOpt (outlier threshold) for each pattern. Users can also input their
preferred param values. The default value is NULL.}

\item{reconstruction}{reconstruction of the data matrix from latent
spaces. Required for "residual" mode.}

\item{hotspots}{a vector that specifies the patterns to compare
to the 'refPattern'. The default is NULL which indicates that all patterns
would be compared to the 'refPattern'.}

\item{analysis}{a character string that specifies the type of downstream
analysis to be performed. Possible values are "enrichment" (default)
and "overlap". In enrichment mode, all genes are returned, ranked by
the SpaceMarkers metric. In overlap mode, only the genes which are
significantly overexpressed in the interaction region are returned.}

\item{minOverlap}{a number that specifies the minimum overlap between
genes in two patterns to be considered for the statistical tests.
The default is 50.}

\item{...}{Arguments passed to methods}
}
\value{
a list of data frames with information about the interacting genes
of the refPattern and each latent feature pattern matrix
(interacting_genes object). There is also a data frame with all of the
regions of influence for any two of patterns (the hotspots object).
}
\description{
This function calculates statistically significant genes using a
non-parametric Kruskal-Wallis test for genes in any one region
of influence and a post hoc Dunn's test is used for analysis of
genes between regions.
}
\examples{
library(SpaceMarkers)
#Visium data links
urls <- read.csv(system.file("extdata","visium_data.txt",
package="SpaceMarkers",mustWork = TRUE))
counts_url <- urls[["visium_url"]][1]
sp_url <- urls[["visium_url"]][2]
#Remove present Directories if any
unlink(basename(sp_url))
unlink("spatial", recursive = TRUE)
files <- list.files(".")[grepl(basename(counts_url),list.files("."))]
unlink(files)
download.file(counts_url,basename(counts_url), mode = "wb")
counts_matrix<-load10XExpr(visiumDir=".",h5filename = basename(counts_url))
#Obtaining CoGAPS Patterns
cogaps_result <- readRDS(system.file("extdata","CoGAPS_result.rds",
package="SpaceMarkers",mustWork = TRUE))
features <- intersect(rownames(counts_matrix),rownames(
    slot(cogaps_result,"featureLoadings")))
barcodes <- intersect(colnames(counts_matrix),rownames(
    slot(cogaps_result,"sampleFactors")))
counts_matrix <- counts_matrix[features,barcodes]
cogaps_matrix <- slot(cogaps_result,"featureLoadings")[features,]\%*\%
    t(slot(cogaps_result,"sampleFactors")[barcodes,])
#Obtaining Spatial Coordinates
download.file(sp_url, basename(sp_url), mode = "wb")
untar(basename(sp_url))
spCoords <- load10XCoords(visiumDir = ".", version = "1.0")
rownames(spCoords) <- spCoords$barcode
spCoords <- spCoords[barcodes,]
spPatterns <- cbind(spCoords,slot(cogaps_result,
"sampleFactors")[barcodes,])
data("curated_genes")
spPatterns<-spPatterns[c("barcode","y","x","Pattern_1","Pattern_5")]
counts_matrix <- counts_matrix[curated_genes,]
cogaps_matrix <- cogaps_matrix[curated_genes, ]
data("optParams")
SpaceMarkersMode <- "DE"
ref_Pattern <- "Pattern_1"
SpaceMarkers_test <- get_interacting_genes(
    data=counts_matrix,reconstruction=NULL,
    optParams = optParams,
    spPatterns = spPatterns,
    refPattern = "Pattern_1",
    mode="DE",analysis="overlap")
#Remove present Directories if any
unlink(basename(sp_url))
unlink("spatial", recursive = TRUE)
files <- list.files(".")[grepl(basename(counts_url),list.files("."))]
unlink(files)

}
\seealso{
Other getIntGenes: 
\code{\link{find_pattern_hotspots}()},
\code{\link{get_pairwise_interacting_genes}()}
}
\concept{getIntGenes}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getInteractingGenes.R
\name{find_pattern_hotspots}
\alias{find_pattern_hotspots}
\title{Identify hotspots of spatial pattern influence}
\usage{
find_pattern_hotspots(
  spPatterns,
  params = NULL,
  patternName = "Pattern_1",
  outlier = "positive",
  nullSamples = 1000,
  includeSelf = TRUE,
  ...
)
}
\arguments{
\item{spPatterns}{A data frame that contains the spatial coordinates
and metrics for spatial features (cell types/cell processes). The column
names must include 'x' and 'y' as well as the spatially varying features.}

\item{params}{a named vector of the optimal sigma and threshold for a
given spatial pattern. The names are should be 'sigmaOpt' and 'threshOpt'.
The default value is NULL.}

\item{patternName}{a character string that specifies the pattern of
interest}

\item{outlier}{a character string specifying whether to apply the
outlier threshold to the kernel density distribution in a one-sided manner
(specify 'positive' the default) or in a two sided manner (specify
'two.sided').}

\item{nullSamples}{a numeric values specifying the number of spatial patterns
to randomly sample for a null distribution.}

\item{includeSelf}{a logic value specifying whether to consider the
spatial influence the pattern has on surrounding regions only (set to FALSE),
or whether to also consider the influence of the pattern itself (set to TRUE
, the default).}

\item{...}{Arguments passed to methods}
}
\value{
a character vector with the spatial feature name if the spatial
influence exceeded the threshold for that spot/cell, and NA otherwise
}
\description{
This function calculates 'hotspots' which are regions of high
spatial influence based on an outlier threshold from a null distribution.
}
\examples{
library(SpaceMarkers)
#Visium data links
urls <- read.csv(system.file("extdata","visium_data.txt",
                           package="SpaceMarkers",mustWork = TRUE))
sp_url <- urls[["visium_url"]][2]
#Remove present Directories if any
unlink(basename(sp_url))
unlink("spatial", recursive = TRUE)
#Obtaining CoGAPS Patterns i.e Spatial Features
cogaps_result <- readRDS(system.file("extdata","CoGAPS_result.rds",
                                   package="SpaceMarkers",mustWork = TRUE))
spFeatures <- slot(cogaps_result,"sampleFactors")
#Obtaining Spatial Coordinates
download.file(sp_url, basename(sp_url), mode = "wb")
untar(basename(sp_url))
spCoords <- load10XCoords(visiumDir = ".", version = "1.0")
rownames(spCoords) <- spCoords$barcode
#Match Dimensions
barcodes <- intersect(rownames(spFeatures),spCoords$barcode)
spCoords <- spCoords[barcodes,]
spFeatures <- spFeatures[barcodes,]
spPatterns <- cbind(spCoords,spFeatures[barcodes,])
spPatterns<-spPatterns[c("barcode","y","x","Pattern_1","Pattern_5")]
data("optParams")
hotspots <- find_pattern_hotspots(
spPatterns = spPatterns,
patternName = "Pattern_1",
params = optParams[,"Pattern_1"],
outlier = "positive",nullSamples = 1000,includeSelf = TRUE)
#Remove present Directories if any
unlink(basename(sp_url))
unlink("spatial", recursive = TRUE)

}
\seealso{
Other getIntGenes: 
\code{\link{get_interacting_genes}()},
\code{\link{get_pairwise_interacting_genes}()}
}
\concept{getIntGenes}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hdutils.R
\name{calculate_thresholds}
\alias{calculate_thresholds}
\title{Compute the thresholds for all columns in a data frame}
\usage{
calculate_thresholds(df, minvals = 0.01, maxvals = 0.99, ...)
}
\arguments{
\item{df}{A data frame with pattern values (optionally
with x, y, barcode columns)}

\item{minvals}{Minimum value for quantile threshold}

\item{maxvals}{Maximum value for quantile threshold}

\item{...}{Additional parameters to pass to lower level functions}
}
\value{
A list containing the computed thresholds for each pattern
}
\description{
This function computes the thresholds for all columns in a
data frame. The data frame could be an spPatterns object or an spInfluence
object.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocessing.R
\name{.read_format}
\alias{.read_format}
\title{readFormat
Reads a format into an R object}
\usage{
.read_format(path)
}
\description{
readFormat
Reads a format into an R object
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hdutils.R
\name{calculate_overlap_directed}
\alias{calculate_overlap_directed}
\title{calculate_overlap_directed}
\usage{
calculate_overlap_directed(
  pat_hotspots,
  influence_hotspots,
  patternList = NULL,
  method = c("relative-abundance", "differential-abundance", "absolute")
)
}
\arguments{
\item{pat_hotspots}{A data frame with columns x, y, barcode and pattern names}

\item{influence_hotspots}{A data frame with columns x, y, barcode and pattern names}

\item{patternList}{A character vector of pattern names to calculate overlap
scores for. If NULL, all patterns in pat_hotspots and influence_hotspots will be used.}

\item{method}{The method to calculate overlapping abundance scores. Options are
"relative-abundance", "differential-abundance" and "absolute"}
}
\value{
A data frame with columns pattern, influence and overlapping abundance
}
\description{
Calculate the overlap scores between patterns in hotspots
}
\details{
The function calculates the overlap scores between patterns hotspots
using the specified method. The default method is "relative-abundance"
}
\examples{
hotspots <- data.frame(x = c(1,2,3,4,5),
                        y = c(1,2,3,4,5),
                        barcode = c("A","B","C","D","E"),
                        pattern1 = c(1,0,1,0,1),
                        pattern2 = c(1,1,0,0,1))
influence_hotspots <- data.frame(x = c(1,2,3,4,5),
                       y = c(1,2,3,4,5),
                      barcode = c("A","B","C","D","E"),
                      pattern1 = c(0,1,1,0,0),
                      pattern2 = c(0,1,0,1,1))
calculate_overlap_directed(pat_hotspots = hotspots, influence_hotspots = influence_hotspots)
}
